# Changelog

## 2.14

### 2.14.0

- Fixes mail tokens  by using TokenProcessor
- Adds new SUD tokens: contribution_url and syndicate_name
- Only shows active recurring contributions in tab
- Manages settings with a main setting form 

Technical:

- Cleanups .git instead of vendor before rsync
- Test with active relationships in PermissionsCest
- Code format

## 2.13

### 2.13.0

- Add loader on city autocomplete #168
- Add civirule action for set billing address in home address if empty #167
- Update automatic tests #154
- fix error on phone validation
- conditional field for retirement #165

## Version 2.12

### 2.12.0

- Fix display of membership introduction
- Expose non-test AND test paymentProcessors
- Improved display of news feed
- Make table head sticky in GenerateSyndicates page
- Added hook for Omnipay/Systempay management
- Added `bin/todo` utility

## Version 2.11

### 2.11.1

- Move $vads_sub_desc to the correct level, fix htmlentities error #153

### 2.11.0

- Manage summer break for recurring contributions
- Adds unit tests for summer break

## Version 2.10

### 2.10.0

- Add custom CiviRule to send email on contributions
- Add automatic tests for Omnipay Systempay
- Add custom field to store annual memebership amount at contact level
- Hide "send mail" checkbox for new contributions
- Manage "end of month", aka 30 february case for recurring contributions with Omnipay Systempay
- Fix pro-rata amount for recurring contributions

## Version 2.9

### 2.9.1

- Ensure refresh of contribution frequency choice
- Fix warning: Undefined variable for "$syndicate", "mandate_creditor_id" and "mandate_entity_id"
- Move bin directory at the root of the project
- Add bump-version script
- Update deps

### 2.9.0

- Update end_date of membership on new contribution in recurring context #130
- Add usefull `cartable_log()` function
- Move generic JS functions into `cartable` object in cartable.js
- Upgrade to Civix 23.02.1
- Upgrade to CiviCRM 5.69 (Contribution main page)
- Bump node-sass to 9.0.0
- Remove warnings for undeclared vars
- Fix working address update for empty employer

## Version 2.8

### 2.8.1

- Use stylized confirm for group in contact search
- More readable title in news dashlet

### 2.8.0

- Add civiRule to force Syndicate relation to new contact create #129
- Add new test: visible contacts per syndicates #117
- Fix "undefined index 0" in cartable.Me #208
- Add organization name in work address for postal label

## Version 2.7

### 2.7.1

- Fix visibility of SEPA for Team & Managers
- Automatic test for full membership process via Check payment #124
- Round down number of due installments #127

### 2.7.0

- Update membership status on contribution status change #118
- Fix number of contributions in contact tab #119
- Fix "Undefined array key 1" #114
- Run tests in browser via WebDriver

## Version 2.6

### 2.6.2

- Rounding up dates to the end of current month #107
- Custom text for single transaction amount #107

### 2.6.1

- Fix broken string for translation

### 2.6.0

- Prefilled membership completion page #107
- Adapt contribution create require campaign #103 
- Adapt for basical contact search form #103 
- Advanced search blocked if no group selected
- Link to syndicate's page from front-end dashboard #104

Technical stuff:
- Introduce automated tests with Codeception
- Update WP_Reporting to 1.5 and manage JS
- Add WP_Reporting listeners
- Refactor: move non hook or civix functions into utils.php
- use cartable_get_file_path() instead of hard coded paths

## Version 2.5

### 2.5.0

- Add hook for recurring SystemPay
- Page de contributions: gérer les cas "non adhésion"
- Improvements on #92 : donation page, price set, button label
- Inhibate SEPA nextCollectionDate alteration #101

## Version 2.4

### 2.4.0

- Extend group visibility to SUD_Equipiere_De #93
- Adds SUD_Equipiere_De and SUD_Contact_De relationship types
- Cleanup manualy created relationship types
- Manage global supplemental MembershipRatio #99
- Better style for generator
- Allows to pass arrays of roles to cartable_get_syndicates_of & cartable_get_contacts_of
- Fix standard contibution pages #92
- Remove warnings (undefined vars)

## Version 2.3

### 2.3.3

- Manage salary grid order in back-office
- Manage membership added via back-office #90
- Add WPReporting listener in cartable_civicrm_post

### 2.3.2

- Keep sorting of salary grid #89
- Show number of contributions vs number of recurring contributions #88

### 2.3.1

- Add all contributions to indicator in contact tab
- Fix condition for external url

### 2.3.0

- Give visibility to groups created by the syndicate managed of the current contact #86
- adds "external URL" custom field to syndicates #85 
- Add "member of" relationship on contribution #84

Fixes and dev stuff:

- Fix permissions on help pages #87
- Refactor user_is_manager_of function
- Adds usefull functions: cartable_get_contacts_of() & cartable_get_syndicates_of()

## Version 2.2

### 2.2.4

- Academies map style adjustment
- Telephone and city fields constraint
- Change the operation of team for the generator
- Fix translations in password reset popover

### 2.2.3

- Show correct SEPA amount in prorata context #80
- Adds phone format constraints #81
- Adds Relation generator #79
- add class to path for pointer #70
- Fix checkbox position in generator #72
- Use start_date rather than end_date in frequency selector #71
- Make markers not clickable #70 

### 2.2.2

- Reimplement "cheque" in paymentProcessors

### 2.2.1

- Fix get active etablishment to set work address

### 2.2.0

- Fix parent title in syndicate generator
- Add Syndicate link in Generator
- Upgrade to delete old wrong custom field #68
- Adds custom field: "Number of months for contribution" : fix inconsistent amount for some recurring contributions #67
- Add HDF in map #66
- Visually center the map
- Fix negative values in frequency selectors #69
- Fix usage of WP localization function 

## Version 2.1

### 2.1.3

- Fix condition get department in get_my_data
- Fix permission check on payment processor selector
- Hide WIP stuff for groupe generation
- More flexible  match for departments

### 2.1.2

- Do not check permissions on API4 for Address sync #26

### 2.1.1

- Fix authorization for bloc academies map

### 2.1.0

- Fix "puis" when pro-rata amount is the same as main amount. (compare correct vars) #48
- Fix PHP Warnings, unset vars #38 #39 #40 #41 #43 #51 #52
- Syndicates objects generator (SEPA creditor, SEPA payment gateway, donation contribution page, membership contribution page)
- SelfManagement settings
- Mechanism "Work" address synchronized with Work establishment
- Update main Contribution template for CiviCRM 5.64
- Fix password reset
- Fix dynamic link back to the map

CiviCRM >= 5.64 is required

### Version 2.0

- Supports single syndicate in contribution pages : skips first tab, alter return button
- Allows managers to reset password of their contacts
- Bump wp-reporting to 1.4
- Adds FAQ support page
- Extends Syndicate generation tool with: campaign, group manager

- 4 DB upgrades

## Version 1.10

### 1.10.0

- Add custom field displaying Membership Status
- Add support for CiviCRM 5.61
- Do not filter posts with no restriction meta, Fixes 404 introduced in 740508da7
- Catch more errors

## Version 1.9

### 1.9.1

- Manage boolean radio buttons as required fields
- Add error reporting option

### 1.9.0

- Add relationship ACL management on SEPA
- Add relationship ACL management on media in Mosaico
- Allows managers to manage medias
- fix monthly in DB
- fix rgpd with ext Communication Opt-in Fields
- Update ref for jquery-tabs

## Version 1.8

### 1.8.5

- Wording in payment frequencies
- make date format translatable
- Cleanup "_apportionment" before sending frequency to SEPA
- Do not check permissions on API4
- Rename dummy remaining "year(s)" and "month(s)" in confirmation page
- Automatically check first available payment method

### 1.8.4

- Bump jquery-tabs to 1.0.3
- Smooth scroll position in tabs

### 1.8.3

- Manage ProRata / Apportionment cases
- Rename Syndicate.apportionment into Syndicate.proRata
- [dev] Add usefull numeric functions

Requires DB upgrade

### 1.8.2

- [a11y] Use box-shadow instead of border for selected frequency
- Reorder frequency options (oneoff at last)

### 1.8.1

- Fix rolling period for monthly payments
- Add values for "Corps / Type de poste" custom field #8
- [a11y] Scroll to academy selector after shape choice
- [a11y] Obvious selected frequency
- [w5g]  explicit no renew membership

### 1.8.0

- Merge fields: "Corps" and "Type de poste" #8
- Fix pre-fill of conditional custom fields
- Bump node-sass to 8.0
- Add util functions get_option_group_id & cleanup_existing_values_in_options
- Make RulesOfprocedure and PaymentProcessors not searchable

Remove PHP warnings :
- Check if PriceSet is set in vars.
- Do not try to sort payment methods
- Cleanup unused $membershipRatesRows debug var

## Version 1.7

### 1.7.1

- Hide frequency when salary is not picked

### 1.7.0

- Add public page for mandate retreiving
- Add SUD.last_sepa_link token in emails
- Add token for Syndicate's thankYou Message
- Make ROP public
- Simply show value for salaryGrid preview
- Move frequencies data to dedicated file
- Replace CF value by human readble value for PaymentMethod
- Replace CF values in ThankYou page
- Only icons in admin menu on small desktop screens
- Add extra templates programmatically
- Manage standby period for payments, depending on syndicate settings
- Add apportionment behavior

## Version 1.6

### 1.6.1

- Manage "no membership" case in contribution page
- Enable autofill fields from URL params
- Move msg_templates in inc. directory
- Update message template for membership online receipt

### 1.6.0

- Add help page
- URL scheme for SUD becomes civicrm/sud/* instead of civicrm/cartable/*

## Version 1.5

### 1.5.0

- Fix amount strangely disapeared in recurring contributions.
- Add payment data in user profile
- Pre-fill SEPA form if values are saved in user's profile
- Save SEPA data in Contact

## Version 1.4

### 1.4.0

- Show options for SalaryGrid & Frequency depending on Syndicate in admin forms
- Manage recurring contribution "Monthly" depending on custom-field value
- Manage default salary Grid in confrim preview

## Version 1.3

### 1.3.0

- Disable zone without syndicate
- Offers zone only if syndicates are activated in contribution page
- Redirect empty zones to fallback URL
- Add class to ROP element
- remove useless CSS

## Version 1.2

### 1.2.0

- Add Degree custom field
- Add ROP checkbox to required fields

## Version 1.1

### 1.1.0

- Remove translations, since they are managed by GlotPress
- Add real creditor informations
- Remove misencoded chars
- Add SEPA mandate custom template

## Version 1.0

### 1.0.0

- Load DonneesParticuliers script to profile form
- More readable formName filter
- Add rules of procedure fields
- Allow "pay later" per syndicat

## Version 0.9

### 0.9.0

- Manage custom salary with per syndicate membership ratio
- Add ListsDomain custom field
- Arbitrary sort payment processors
- Remove PHP warnings

## Version 0.8

### 0.8.0

- Pretty preview for GrilleCotisation CF
- Increase GrilleCotisation max length to 1k chars

## Version 0.7

### 0.7.0

- Add fields for Membership rates, manage salary preview
- Do not crash if custom filed is not found (log error)
- Manage rich/conditional fields in both front,back and quick edit side.

## Version 0.6

### 0.6.0

- Hide NextButtons until required fields are full
- Make tabs not clickable
- WIP impro for help of fields
- Refactor: use new project architecture
- Add new Fonction field and its conditionnal logic
- Add empty fist option on selects
- Add classes on tabs buttons
- Wrap payment processor inputs

## Version 0.5

### 0.5.0

- Use select2 fot salary Select
- Add placeholder to salary Select
- Hide total amount
- Update lightgrey color
- Update layout of frequencies
- Move membership intro after salary select
- Add support for Custom GlotPress Source
- Make strings translatable
- Add generic class for titles
- Add "team" role
- Update license to MIT

## Version 0.4

### 0.4.1

- Use custom amount instead of memebership amount
- Manage textualized labels for salary gridM
- Les restrictive operator on education_nationale_school_filters

### 0.4.0

- Make PaymentProcessor mandatory
- Make fields for "Paramètres d’adhésion" non mandatory
- Manage allowed payment processor per syndicate on front
- Limit displayed PaymentsProcessors to selected ones
- Align main form button, for tab integration
- Pre-check frequency depending on amount/auto_renew
- Manage #auto_renew delay
- Keep lonely last button in the SEPA form
- Hide recur choice if option is not enabled for syndicate
- Sync state between map/label/radio #3
- Preview payment processors in admin
- Initial check, in case the form is pre-filled(re)
- Manage non-logged-in users
- Fix date selector
- Rounded amounts
- Factorize text replacement, manage tax free labels #3
- Manage next dates and rolling periods server-side.
- Display tax deduction #3
- Add description for each membership frequency #3
- Add per Syndicate membership settings #3
- Manage dynamic currency #3
- WIP on salary grid management on front

