# Contribution Guidelines

## General

 - Always English
 - Comment functions, classes and globals

## Naming

- Explicit prefix functions by cartable
- Be aware of plural and singular


## CSS and JS pre processor

Install dependencies
```
composer install
npm install
```

And compile scripts
```
guld build
```

For development purpose, you can use
```
guld watch
```

## Run test

Tests are run thanks to Codeception, via WebDriver.

Launch tests

```bash
cartable/vendor/bin/codecept run
```

To override environment variables, you can add theme before calling the binary

```bash
CODECEPTION_USER_LOGIN_ADMIN=login CODECEPTION_USER_PASSWORD_ADMIN=password CODECEPTION_HTACCESS=base64(login:password) CI_ENVIRONMENT_URL=https://example.ex SELENIUM_HOST=localhost cartable/vendor/bin/codecept run
```