<?php
class CRM_Cartable_CivirulesActions_ForceRelationToCreateContact extends CRM_Civirules_Action
{
     /**
     * Method to return the url for additional form processing for action
     * and return false if none is needed
     *
     * @param int $ruleActionId
     * @return bool
     * @access public
     */
    public function getExtraDataInputUrl($ruleActionId) {
        return FALSE;
    }
    /**
     * Method processAction to execute the action : work address from employer address
     *
     * @param CRM_Civirules_TriggerData_TriggerData $triggerData
     * @access public
     *
     */
    public function processAction(CRM_Civirules_TriggerData_TriggerData $triggerData)
    {
        $contactId = $triggerData->getContactId();
        $connected_id = CRM_Core_Session::singleton()->getLoggedInContactID();

        $session = CRM_Core_Session::singleton();
        if (empty($contactId) || empty($connected_id)) {
            return false;
        }
        if($connected_id == $contactId) {
            return false;
        }
        $relationshipTrigger = civicrm_api3('Relationship', 'get', [
            'return' => ["contact_id_b"],
            'contact_id_a' => $contactId,
            'is_active' => 1,
            'relationship_type_id' => "SUD_Membre_De",
            'options' => ['limit' => 1],
        ]);
        if ($relationshipTrigger['count'] == 0) {
            $relationships_of_connected = civicrm_api3('Relationship', 'get', [
                'return' => ["contact_id_b"],
                'contact_id_a' => $connected_id,
                'is_active' => 1,
                'relationship_type_id' => ['BETWEEN' => ["SUD_Gestionnaire", "SUD_Equipiere_De"]],
                'options' => ['limit' => 1],
            ]);
            if ($relationships_of_connected['count'] > 0) {
                $lastKey = key($relationships_of_connected['values']);
                $contactIdB = $relationships_of_connected['values'][$lastKey]['contact_id_b'];
                civicrm_api3('Relationship', 'create', [
                    'contact_id_a' => $contactId,
                    'contact_id_b' => $contactIdB,
                    'relationship_type_id' => "SUD_Membre_De",
                    'is_active' => 1,]);
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
}