<?php
use CRM_Cartable_ExtensionUtil as E;

class CRM_Cartable_Form_Settings extends CRM_Admin_Form_Setting
{
    /**
     * Subset of settings on the page as defined using the legacy method.
     *
     * @var array
     *
     * @deprecated - do not add new settings here - the page to display
     * settings on should be defined in the setting metadata.
     */
    protected $_settings = [];

    public function __construct()
    {
      $cartable_settings = include_once CARTABLE_DIR.'/settings/cartable.setting.php';
      foreach ($cartable_settings as $setting_name => $setting) {
        if(isset($setting['settings_pages'])) {
          foreach ($setting['settings_pages'] as $page_name => $page) {
            if($page_name == 'cartable') {
              $this->_settings[$setting_name] = $setting;
            }
          }
        }
      }
      parent::__construct();
    }

    /**
     * Build the form object.
     */
    public function buildQuickForm()
    {
        $this->setTitle(E::ts('Settings - Cartable'));
        parent::buildQuickForm();
    }

}