<?php
use CRM_Cartable_ExtensionUtil as E;

class CRM_Cartable_Page_Help extends CRM_Core_Page {

  public function run() {
    CRM_Utils_System::setTitle('Champs SUD Éducation');

    $val_path = cartable_get_dir_path('inc/values');
    $fields = scandir($val_path);
    $all_values = [];
    foreach ($fields as $field) {
      if (preg_match('/^([a-z0-9_-]+)\.php$/', $field, $matches)) {
        $all_values[$matches[1]] = include $val_path . '/' . $field;
      }
    }

    $this->assign('all_values', $all_values);

    $conditions = cartable_get_donnees_particuliers_vars();
    $this->assign('hide_if_not', $conditions['hide_if_not']);
    $this->assign('filter_options', $conditions['filter_options']);
    
    $CorpsField = cartable_get_custom_field_id('Corps', 'DonneesParticulier');
    $DisciplineField = cartable_get_custom_field_id('Discipline', 'DonneesParticulier');
    $AutreDisciplineField = cartable_get_custom_field_id('AutreDiscipline', 'DonneesParticulier');
    $StatutField = cartable_get_custom_field_id('Statut', 'DonneesParticulier');
    $TypeDePosteField = cartable_get_custom_field_id('TypeDePoste', 'DonneesParticulier');
    $FonctionField = cartable_get_custom_field_id('Fonction', 'DonneesParticulier');

    $custom_fields = [
      'Corps' => $CorpsField,
      'Discipline' => $DisciplineField,
      'AutreDiscipline' => $AutreDisciplineField,
      'Statut' => $StatutField,
      'TypeDePoste' => $TypeDePosteField,
      'Fonction' => $FonctionField,
    ];
    $this->assign('custom_fields', array_flip($custom_fields));

    parent::run();
  }

}
