<?php
use CRM_Cartable_ExtensionUtil as E;
use CRM_Sepa_Page_SepaMandatePdf;

class CRM_Cartable_Page_SepaMandate extends CRM_Sepa_Page_SepaMandatePdf {

  public function run() {
    $current_contact_id = CRM_Core_Session::singleton()->getLoggedInContactID();
    if(!$current_contact_id){
      throw new CRM_Core_Exception(E::ts('You are not allowed to access this page. Please login first.'));
    }
    
    $mid = (int)CRM_Utils_Request::retrieve('m_id', 'String', $this);
    
    if(!$mid){
      throw new CRM_Core_Exception(E::ts('Missing mandate ID.'));
    }

    $sepaMandates = \Civi\Api4\SepaMandate::get(false)
      ->addWhere('id', '=', $mid)
      ->execute();

    if($sepaMandates->rowCount == 0){
      throw new CRM_Core_Exception(E::ts('No SEPA mandate found.'));
    }

    foreach ($sepaMandates as $sepaMandate) {
      break;
    }
    
    if($sepaMandate['contact_id'] != $current_contact_id){
      throw new CRM_Core_Exception(E::ts('You are not allowed to access this mandate.'));
    }

    $sepaTemplates = \Civi\Api4\MessageTemplate::get(false)
      ->addWhere('msg_title', '=', "SUD SEPA PDF template")
      ->execute();
    
    $tpl = null;
    if($sepaTemplates->rowCount){
      foreach ($sepaTemplates as $sepaTemplate) {
        $tpl = $sepaTemplate['id'];
        break;
      }
    }

    $_REQUEST['id'] = $sepaMandate['id'];
    $_REQUEST['pdfaction'] = 'pdf';
    $_REQUEST['tpl'] = $tpl;

    parent::run();
  }

}
