<?php

function delete_entities(string $entity, array $names){
    try{
        $result = civicrm_api3($entity, 'get', [
            'return' => ['id'],
            'name' => [
                'IN' => $names,
            ],
            'sequential' => 1,
        ]);
        if($result['count']){
            foreach($result['values'] as $item){
                civicrm_api3($entity, 'delete', [
                    'id' => $item['id'],
                ]);
            }
        }
        return true;
    }
    catch(\Throwable $e){
        error_log("DEBUG:\tUninstall {$entity}\t".json_encode($e->getMessage()));
        \WPReporting()->send($e, 'cartable');
        return;
    }
    catch(\Exception $e){
        error_log("DEBUG:\tUninstall {$entity}\t".json_encode($e->getMessage()));
        \WPReporting()->send($e, 'cartable');
        return;
    }
    catch ( CiviCRM_API3_Exception $e ){
        return false;
    }
}

delete_entities(
    'CustomField',
    [
        "Departements",
        "Banque",
        "ICS",
        "IBAN",
        "BIC",
        "Ordre_Pour_Cheques",
        "DateADH",
        "Statut",
        "Corps",
        "TypeDePoste",
        "Discipline",
        "FrequencesPaiement",
        "GrilleCotisation",
        "RatioSupplementaire",
    ]
);

delete_entities(
    'CustomGroup',
    [
        "DonneesSyndicat",
        "DonneesParticulier",
        "ParametresAdhesion",
    ]
);

delete_entities(
    'ContactType',
    [
        "SyndicatSUD",
    ]
);
