<?php

civicrm_api3( 'CustomGroup', 'create', [
    'title'            => "Données de Syndicat",
    'name'             => 'DonneesSyndicat',
    'extends'          => ['Organization'],
    'column_name'      => 'donnees_syndicat',
    'weight'           => 1,
    'collapse_display' => 0,
    'is_active'        => 1,
    'style'            => "Inline",
    'api.CustomField.create' => [
        [
            'label'           => 'Département(s) couvert(s)',
            'name'            => 'Departements',
            'column_name'     => 'departements',
            'data_type'       => 'StateProvince',
            'html_type'       => 'Multi-Select State/Province',
            'weight'          => 4,
            'is_required'     => 1,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ],

        // Banque
        [
            'label'           => 'Banque',
            'name'            => 'Banque',
            'column_name'     => 'banque',
            'html_type'       => 'Text',
            'weight'          => 7,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ],
        [
            'label'           => 'ICS',
            'name'            => 'ICS',
            'column_name'     => 'ics',
            'html_type'       => 'Text',
            'help_pre'        => 'Identifiant Créancier SEPA',
            'weight'          => 8,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ],
        [
            'label'           => 'IBAN',
            'name'            => 'IBAN',
            'column_name'     => 'iban',
            'html_type'       => 'Text',
            'weight'          => 9,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ],
        [
            'label'           => 'BIC/Swift',
            'name'            => 'BIC',
            'column_name'     => 'bic',
            'html_type'       => 'Text',
            'weight'          => 10,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ],
        [
            'label'           => 'Ordre pour les chèques',
            'name'            => 'Ordre_Pour_Cheques',
            'column_name'     => 'ordre_pour_cheques',
            'html_type'       => 'Text',
            'weight'          => 11,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ],
    ],
]);


civicrm_api3( 'CustomGroup', 'create', [
    'title'            => "Données de particulier",
    'name'             => 'DonneesParticulier',
    'extends'          => ['Individual'],
    'column_name'      => 'donnees_particulier',
    'weight'           => 1,
    'collapse_display' => 0,
    'is_active'        => 1,
    'style'            => "Inline",
    'api.CustomField.create' => [
        [
            'label'           => 'Date de première adhésion',
            'name'            => 'DateADH',
            'column_name'     => 'date_adh',
            'data_type'       => 'Date',
            'html_type'       => 'Select Date',
            'start_date_years'=> '20',
            'end_date_years'  => '2',
            'date_format'     => 'dd/mm/yy',
            'weight'          => 1,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ],
        [
            'label'           => 'Statut',
            'name'            => 'Statut',
            'column_name'     => 'statut',
            'html_type'       => 'Select',
            'weight'          => 2,
            'is_required'     => 1,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
            'option_values'   => cartable_get_values('statuts'),
        ],
        [
            'label'           => 'Corps',
            'name'            => 'Corps',
            'column_name'     => 'corps',
            'html_type'       => 'Select',
            'weight'          => 3,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
            'option_values'   => cartable_get_values('_corps.archive'),
        ],
        [
            'label'           => 'Type de poste',
            'name'            => 'TypeDePoste',
            'column_name'     => 'type_de_poste',
            'html_type'       => 'Select',
            'weight'          => 3,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
            'option_values'   => cartable_get_values('_types-postes.archive'),
        ],
        [
            'label'           => 'Discipline',
            'name'            => 'Discipline',
            'column_name'     => 'discipline',
            'html_type'       => 'Select',
            'weight'          => 5,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
            'option_values'   => cartable_get_values('disciplines-all'),
        ],
    ],
]);