<?php

$discipline_field = civicrm_api3('CustomField', 'get', [
    'return' => ['id', 'option_group_id'],
    'name' => 'Discipline',
    'sequential' => 1,
]);
if($discipline_field['count']){
    foreach($discipline_field['values'] as $item){
        civicrm_api3('CustomField', 'create', [
            'id'              => $item['id'],
            'label'           => 'Discipline',
            'name'            => 'Discipline',
            'column_name'     => 'discipline',
            'html_type'       => 'Select',
            'weight'          => 5,
            'is_required'     => 0,
            'is_searchable'   => 1,
            'is_active'       => 1,
            'is_reserved'     => 1,
        ]);

        $custom_group = civicrm_api3('OptionGroup', 'getsingle', [
          'sequential' => 1,
          'id' => $item['option_group_id'],
        ]);

        $option_values = [
            'L1900' => "EDUCATION PHYSIQUE ET SPORTIVE",
            'L0060' => "LANGAGE DES SIGNES",
            'L0062' => "INGENIERIE FORMATION",
            'L0080' => "DOCUMENTATION",
            'L0090' => "AE (NON SPECIALISTE)",
            'L0100' => "PHILOSOPHIE",
            'L0201' => "LETTRES CLASSIQUES",
            'L0202' => "LETTRES MODERNES",
            'L0210' => "LETTRES - HISTOIRE",
            'L0211' => "HISTOIRE GEOGRAPHIE - LETTRES",
            'L0250' => "TAHITIEN",
            'L0421' => "ALLEMAND",
            'L0422' => "ANGLAIS",
            'L0423' => "ARABE",
            'L0424' => "CHINOIS",
            'L0425' => "DANOIS",
            'L0426' => "ESPAGNOL",
            'L0428' => "HEBREU",
            'L0429' => "ITALIEN",
            'L0430' => "JAPONAIS",
            'L0431' => "NEERLANDAIS",
            'L0432' => "POLONAIS",
            'L0433' => "PORTUGAIS",
            'L0434' => "RUSSE",
            'L0437' => "LANGUE TURQUE",
            'L0440' => "BASQUE",
            'L0441' => "BRETON",
            'L0442' => "CATALAN",
            'L0443' => "CORSE",
            'L0444' => "OCCITAN",
            'L0448' => "LANGUE MELANESIENNE",
            'L0449' => "CREOLE",
            'L0451' => "ALLEMAND FRANCAIS",
            'L0452' => "CREOLE LETTRES",
            'L0453' => "ARABE FRANCAIS",
            'L0456' => "ESPAGNOL FRANCAIS",
            'L0459' => "ITALIEN FRANCAIS",
            'L0460' => "CREOLE ANGLAIS",
            'L0463' => "PORTUGAIS FRANCAIS",
            'L0464' => "RUSSE FRANCAIS",
            'L0466' => "LETTRES ESPAGNOL",
            'L0469' => "LETTRES ITALIEN",
            'L0471' => "LETTRES ALLEMAND",
            'L0473' => "LETTRES JAPONAIS",
            'L0483' => "LETTRES ARABE",
            'L0485' => "CATALAN HISTOIRE-GEOGRAPHIE",
            'L0493' => "PORTUGAIS MUSIQUE",
            'L0500' => "ENSEIGNEMENT RELIGIEUX",
            'L0510' => "ENSEIGNEMENT RELIGIEUX CATHOLIQUE",
            'L0520' => "ENSEIGNEMENT RELIGIEUX PROTESTANT",
            'L0530' => "ENSEIGNEMENT RELIGIEUX ISRAELITE",
            'L0600' => "LANGUE DES SIGNES FRANCAISE",
            'L0610' => "BRAILLE",
            'L1000' => "HISTOIRE GEOGRAPHIE",
            'L1100' => "SCIENCES ECONOMIQUES ET SOCIALES",
            'L1300' => "MATHEMATIQUES",
            'L1315' => "MATHEMATIQUES - SCIENCES PHYSIQUES",
            'L1317' => "MATHEMATIQUES - MUSIQUE",
            'L1400' => "TECHNOLOGIE",
            'L1410' => "EDUCATION MANUELLE ET TECHNIQUE",
            'L1411' => "SII ARCHITECTURE ET CONSTRUCTION",
            'L1412' => "SII ENERGIE",
            'L1413' => "SII INFORMATIQUE ET NUMERIQUE",
            'L1414' => "SII INGENIERIE MECANIQUE",
            'L1415' => "SII INGENIERIE ELECTRIQUE",
            'L1416' => "SII INGENIERIE DES CONSTRUCTIONS",
            'L1500' => "SCIENCES PHYSIQUES",
            'L1510' => "PHYSIQUES CHIMIE APPLIQUEE",
            'L1511' => "MESURES PHYSIQUES ET CHIMIQUES",
            'L1512' => "PROCEDES PHYSICO-CHIMIQUES",
            'L1600' => "SCIENCE DE LA VIE ET DE LA TERRE",
            'L1615' => "SCIENCES NATURELLES - SCIENCES PHYSIQUES",
            'L1700' => "EDUCATION MUSICALE",
            'L1800' => "ARTS PLASTIQUES",
            'L1900' => "EDUCATION PHYSIQUE ET SPORTIVE",
            'L2001' => "ASSISTANT INGENIEUR",
            'L2020' => "DDFPT INDUS. ELECT. MECA. BAT.",
            'L2070' => "DDFPT SCIENCES ET TECHNIQUES DE LABORATOIRE",
            'L2080' => "DDFPT GESTION ET INFORMATIQUE",
            'L2085' => "DDFPT HOTELLERIE ET TOURISME",
            'L2100' => "GENIE INDUSTRIEL BOIS",
            'L2110' => "MENUISERIE CHARPENTE",
            'L2120' => "EBENISTERIE",
            'L2130' => "EXPLOITATION FORESTIERE ET SCIERIE",
            'L2140' => "AMEUBLEMENT",
            'L2200' => "GENIE INDUSTRIEL TEXTILES ET CUIRS",
            'L2210' => "FABRICATION INDUSTRIELLE DE L'HABILLEMENT",
            'L2220' => "ENTRETIEN DES ARTICLES TEXTILES",
            'L2230' => "INDUSTRIE TEXTILE",
            'L2240' => "INDUSTRIE DU CUIR ET DE LA CHAUSSURE",
            'L2300' => "GENIE INDUSTRIEL DE VERRE ET DE LA CERAMIQUE",
            'L2320' => "MIROITERIE",
            'L2330' => "VERRERIE SCIENTIFIQUE",
            'L2400' => "GENIE INDUSTRIEL DES STRUCTURES METALLIQUES",
            'L2401' => "CONSTRUCTIONS METALLIQUES",
            'L2402' => "METAUX EN FEUILLES",
            'L2500' => "GENIE INDUSTRIEL PLASTIQUE ET COMPOSITE",
            'L2501' => "TRANSFORMATION DES MATIERES PLASTIQUES",
            'L2600' => "GENIE CHIMIQUE",
            'L3000' => "GENIE CIVIL",
            'L3011' => "GEOMETRE",
            'L3030' => "CARTOGRAPHIE",
            'L3100' => "GENIE THERMIQUE",
            'L3110' => "INSTALLATIONS SANITAIRES ET THERMIQUES",
            'L3120' => "FROID ET CLIMATISATION",
            'L4010' => "STI EN CPGE",
            'L4100' => "GENIE MECANIQUE CONSTRUCTION",
            'L4120' => "OPTIQUE LUNETTERIE, PRECISION, COMPOSANTS",
            'L4130' => "GENIE MECANIQUE CONSTRUCTION DES PAPETERIES",
            'L4200' => "GENIE MECANIQUE PRODUCTIQUE",
            'L4210' => "MICROTECHNIQUE",
            'L4221' => "FORGE - ESTAMPAGE",
            'L4222' => "FONDERIE",
            'L4223' => "MODELAGE MECANIQUE",
            'L4225' => "GENIE INDUSTRIEL MATERIAUX SOUPLES",
            'L4230' => "TRAITEMENT THERMIQUE ET ELECTROPLASTIE",
            'L4240' => "INDUSTRIES CEREALES (PRODUCTIQUE)",
            'L4500' => "GENIE MECANIQUE MAINTENANCE",
            'L4511' => "MECANIQUE AUTOMOBILE",
            'L4512' => "MECANIQUE AGRICOLE",
            'L4540' => "MAINTENANCE DES AERONEFS",
            'L5100' => "GENIE ELECTRIQUE ELECTRONIQUE",
            'L5111' => "SON ET VIDEO",
            'L5112' => "AUDIOVISUEL",
            'L5200' => "ELECTROTECHNIQUE",
            'L5500' => "INFORMATIQUE - TELEMATIQUE",
            'L6100' => "INDUSTRIES GRAPHIQUES (IMPRIMERIE ET LIVRE)",
            'L6102' => "COMMUNICATION GRAPHIQUE",
            'L6115' => "LABORATOIRES DES INDUSTRIES GRAPHIQUES",
            'L6500' => "ENSEIGNEMENTS ARTISTIQUES ET ARTS APPLIQUES",
            'L6510' => "ARCHITECTURE INTERIEURE ET CADRE BATIMENT",
            'L6515' => "ESTHETIQUE INDUSTRIELLE - DESIGN",
            'L6520' => "DESIGN DE COMMUNICATION",
            'L6610' => "ARTS GRAPHIQUES",
            'L6620' => "ARTS DU BOIS",
            'L6630' => "ARTS DU METAL",
            'L6640' => "ARTS TEXTILES",
            'L6650' => "ARTS DU FEU (VERRE, CERAMIQUE)",
            'L6660' => "ARTS DU DECOR ARCHITECTURAL",
            'L6670' => "ARTS DU LIVRE",
            'L6680' => "ARTS DE LA PHOTOGRAPHIE",
            'L6690' => "ARTS DU SPECTACLE",
            'L6980' => "CINEMA ET PHOTOGRAPHIE",
            'L7100' => "BIOCHIMIE GENIE BIOLOGIQUE",
            'L7110' => "IMAGERIE MEDICALE",
            'L7120' => "DIETETIQUE",
            'L7140' => "HORTICULTURE",
            'L7150' => "BIOTECHNOLOGIES CEREALIERES",
            'L7200' => "BIOTECHNOLOGIES SANTE - ENVIRONNEMENT",
            'L7300' => "SCIENCES ET TECHNIQUES MEDICO-SOCIALES",
            'L7320' => "TECHNIQUES HOSPITALIERES",
            'L7330' => "PUERICULTURE",
            'L7410' => "ESTHETIQUE COSMETIQUE",
            'L8010' => "ECONOMIE ET GESTION",
            'L8011' => "ECONOMIE ET GESTION ADMINISTRATIVE",
            'L8012' => "ECONOMIE ET GESTION COMPTABLE",
            'L8013' => "ECONOMIE ET GESTION COMMERCIALE",
            'L8014' => "PUBLICITE",
            'L8015' => "ACTION COMMERCIALE (EN T.S)",
            'L8016' => "ASSURANCE",
            'L8017' => "FORCE DE VENTE (EN T.S)",
            'L8018' => "COMMERCE INTERNATIONAL (EN T.S)",
            'L8019' => "TRANSPORTS (EN T.S)",
            'L8020' => "AUDIOVISUEL (EN T.S)",
            'L8021' => "ECO. GESTION - INFO. DE GESTION (EN T.S)",
            'L8022' => "ECO. GESTION - HOTEL. TOURISME (EN T.S)",
            'L8026' => "ECO. GESTION - BANQUE (EN T.S)",
            'L8028' => "ECO. GESTION - ANIM GEST TOURIST (EN T.S)",
            'L8030' => "INFORMATIQUE DE GESTION",
            'L8031' => "INFORMATIQUE DE GESTION",
            'L8032' => "ECONOMIE ET GESTION PRODUCTION DE SERVICES",
            'L8033' => "BTS TOURISME",
            'L8040' => "BUREAUTIQUE",
            'L8041' => "SECRETARIAT ET COMMERCE",
            'L8510' => "HOTELLERIE OPTION TECHNIQUE CULINAIRE",
            'L8511' => "CUISINE",
            'L8512' => "PATISSERIE",
            'L8520' => "TECHNIQUE DE SERVICE ET DE COMMERCIALISATION",
            'L8521' => "MAITRE D'HOTEL RESTAURANT",
            'L8530' => "HOTELLERIE OPTION TOURISME",
            // PLP
            'P0210' => "LETTRES HISTOIRE GEOGRAPHIE",
            'P0221' => "LETTRES ALLEMAND",
            'P0222' => "LETTRES ANGLAIS",
            'P0223' => "LETTRES ARABE",
            'P0226' => "LETTRES ESPAGNOL",
            'P0229' => "LETTRES ITALIEN",
            'P1315' => "MATH. SCIENCES PHYSIQUES",
            'P1400' => "TECHNOLOGIE",
            'P2001' => "AIDE AU CHEF DE TRAVAUX",
            'P2100' => "GENIE INDUSTRIEL BOIS MENUISERIE CHARPENTE",
            'P2111' => "CHARPENTE NAVALE",
            'P2120' => "EBENISTERIE",
            'P2121' => "FABRICATION INDUSTRIELLE DU SIEGE",
            'P2122' => "TOURNEUR SUR BOIS",
            'P2130' => "EXPLOITATION FORESTIERE ET SCIERIE",
            'P2140' => "AMEUBLEMENT",
            'P2200' => "GENIE INDUSTRIEL TEXTILES CUIRS HABILLEMENT",
            'P2210' => "HABILLEMENT",
            'P2220' => "ENTRETIEN DES ARTICLES TEXTILES",
            'P2230' => "INDUSTRIE TEXTILE",
            'P2231' => "TULLE",
            'P2232' => "BRODERIE",
            'P2233' => "OURDISSAGE",
            'P2235' => "TAPISSERIE COUTURE DECOR",
            'P2240' => "INDUSTRIE DU CUIR ET DE LA CHAUSSURE",
            'P2241' => "MAROQUINERIE",
            'P2242' => "SELLIER GARNISSEUR",
            'P2243' => "CORDONNERIE",
            'P2301' => "GENIE INDUSTRIEL OPTION OPTIQUE-LUNETIER",
            'P2310' => "CERAMIQUE INDUSTRIELLE",
            'P2320' => "MIROITERIE",
            'P2321' => "MIROITERIE - MONTAGE - POSE",
            'P2322' => "TECHNI-VERRIERS",
            'P2330' => "VERRERIE SCIENTIFIQUE",
            'P2340' => "ENSEIGNES LUMINEUSES",
            'P2400' => "GENIE INDUSTRIEL DES STRUCTURES METALLIQUES",
            'P2402' => "METAUX EN FEUILLES",
            'P2450' => "CONSTRUCTION ET REPARATION CARROSSERIE",
            'P2452' => "REPARATION ET REVETEMENT EN CARROSSERIE",
            'P2500' => "GENIE INDUSTRIEL PLASTIQUES ET COMPOSITE",
            'P2600' => "GENIE CHIMIQUE",
            'P2650' => "METIERS DE L'EAU",
            'P3010' => "GENIE CIVIL CONSTRUCTION ET ECONOMIE",
            'P3013' => "DESSIN CALCUL TOPOGRAPHIE",
            'P3020' => "GENIE CIVIL CONSTRUCTION ET REALISATION",
            'P3021' => "MACONNERIE GROS ?UVRE",
            'P3022' => "PLATRERIE",
            'P3023' => "COUVERTURE",
            'P3024' => "TAILLEUR DE PIERRES",
            'P3025' => "CARRELAGE MOSAIQUE",
            'P3026' => "SOLIER MOQUETTISTE",
            'P3027' => "PEINTURE VITRERIE",
            'P3028' => "PEINTURE REVETEMENT",
            'P3100' => "GENIE THERMIQUE",
            'P3120' => "FROID ET CLIMATISATION",
            'P4100' => "GENIE MECANIQUE CONSTRUCTION",
            'P4120' => "OPTIQUE",
            'P4200' => "GENIE MECANIQUE PRODUCTIQUE",
            'P4210' => "MICROTECHNIQUE",
            'P4221' => "FORGE - ESTAMPAGE",
            'P4222' => "FONDERIE",
            'P4223' => "MODELAGE MECANIQUE",
            'P4224' => "MOULAGE NOYAUTAGE",
            'P4226' => "OUTILLAGE",
            'P4227' => "DECOLLETAGE",
            'P4230' => "TRAITEMENT THERMIQUE ET ELECTROSPLASTIE",
            'P4245' => "GENIE MECANIQUE INDUST. PATES A PAPIER",
            'P4246' => "INDUSTRIES PAPETIERES",
            'P4250' => "APPAREILLAGE ORTHESE",
            'P4450' => "GENIE MECANIQUE ENGINS",
            'P4500' => "GENIE MECANIQUE AUTOMOBILES",
            'P4512' => "MECANIQUE AGRICOLE",
            'P4513' => "CYCLES ET MOTOCYCLES",
            'P4530' => "MAINTENANCE DE BATEAUX DE PLAISANCE",
            'P4540' => "MAINTENANCE AERONEF",
            'P4550' => "GENIE MECA MAINTENANCE SYST MECA ET AUTOMATISMES",
            'P4551' => "MAINTENANCE DES METIERS DE BONNETERIE",
            'P5100' => "GENIE ELECTRIQUE ELECTRONIQUE",
            'P5110' => "MAINTENANCE ELECTRONIQUE (MAVELEC)",
            'P5112' => "AUDIOVISUEL",
            'P5120' => "MAINTENANCE RESEAU BUREAUTIQUE ET TELEMATIQUE",
            'P5150' => "MATH-SCIENCES OPTION ELECTRONIQUE",
            'P5200' => "GENIE ELECTRIQUE ELECTROTECHNIQUE",
            'P5210' => "EQUIPEMENT MENAGER ET COLLECTIVITES",
            'P6100' => "INDUSTRIES GRAPHIQUES",
            'P6111' => "COMPOSITION EN FORME IMPRIMANTE",
            'P6115' => "LABORATOIRE DES INDUSTRIES GRAPHIQUES",
            'P6150' => "IMPRESSION LIVRE ET IMAGE",
            'P6310' => "CONDUCTEURS ROUTIERS",
            'P6320' => "CONDUCTEURS D'ENGINS DE TRAVAUX PUBLICS",
            'P6330' => "NAVIGATION",
            'P6331' => "NAVIGATION FLUVIALE ET RHENANE",
            'P6500' => "ENSEIGNEMENTS ARTISTIQUES ET ARTS APPLIQUES",
            'P6515' => "DESIGN DE PRODUIT",
            'P6520' => "DESIGN DE COMMUNICATION",
            'P6610' => "ARTS GRAPHIQUES",
            'P6611' => "PEINTRE EN LETTRES",
            'P6612' => "PEINTRE FILEUR",
            'P6620' => "ART DU BOIS",
            'P6621' => "EBENISTERIE D'ART",
            'P6622' => "SCULPTURE BOIS",
            'P6623' => "FACTURE PIANOS",
            'P6624' => "MARQUETERIE",
            'P6630' => "ARTS DU METAL",
            'P6631' => "BIJOUTERIE",
            'P6632' => "BRONZE D'ART",
            'P6633' => "FERRONNERIE D'ART",
            'P6640' => "ARTS TEXTILES",
            'P6641' => "TAPISSERIE GARNITURE DECOR",
            'P6642' => "FLEURS ET PLUMES",
            'P6643' => "COSTUMIER DE THEATRE",
            'P6650' => "ARTS DU FEU",
            'P6651' => "TAILLEURS DE CRISTAUX",
            'P6652' => "ARTS DU FEU",
            'P6660' => "ARTS DU DECORS ARCHITECTURAL",
            'P6661' => "STAFFEUR",
            'P6670' => "ARTS DU LIVRE",
            'P6671' => "SERIGRAPHIE",
            'P6672' => "RELIURE MAIN",
            'P6673' => "DOREUR ORNEMANISTE",
            'P6680' => "ARTS DE LA PHOTOGRAPHIE",
            'P6690' => "ARTS DU SPECTACLE",
            'P6911' => "CARTONNAGE",
            'P6921' => "VANNERIE",
            'P6922' => "CHAISERIE BROSSERIE",
            'P6940' => "ARMURERIE",
            'P6941' => "COUTELLERIE",
            'P6945' => "JOUETS",
            'P6951' => "STANDARD",
            'P6961' => "ECLAIRAGISTE",
            'P6971' => "FLEURISTE",
            'P6980' => "CINEMA ET PHOTOGRAPHIE",
            'P7110' => "IMAGERIE MEDICALE",
            'P7130' => "BIOTECHNOLOGIES DE LA MER",
            'P7140' => "HORTICULTURE",
            'P7200' => "BIOTECHNOLOGIE SANTE (EF EFS)",
            'P7202' => "BIOTECHNOLOGIES GENIE BIOLOGIQUE",
            'P7210' => "EMPLOYE TECHNIQUE DES COLLECTIVITES",
            'P7300' => "SCIENCES ET TECHNIQUES MEDICO-SOCIALES",
            'P7330' => "PUERICULTURE",
            'P7410' => "ESTHETIQUE COSMETIQUE",
            'P7420' => "COIFFURE",
            'P7430' => "PROTHESE ORTHESE",
            'P7431' => "PROTHESE DENTAIRE",
            'P8013' => "ECONOMIE ET GESTION OPTION COMMERCE ET VENTE",
            'P8038' => "ECONOMIE ET GESTION OPTION TRANSPORT LOGISTIQUE",
            'P8039' => "ECONOMIE ET GESTION OPTION GENIE DES  ADMINISTRATIONS",
            'P8041' => "SECRETARIAT",
            'P8043' => "VENTE",
            'P8510' => "HOTELLERIE OPT. TECHNIQUES CULINAIRES",
            'P8511' => "CUISINE",
            'P8512' => "PATISSERIE",
            'P8513' => "BOULANGERIE",
            'P8515' => "METIERS DE L'ALIMENTATION",
            'P8516' => "METIERS DE L'ALIMENTATION OPT. BOUCHERIE",
            'P8517' => "METIERS DE L'ALIMENTATION OPT. CHARCUTERIE",
            'P8518' => "METIERS DE L'ALIMENTATION OPT. POISSONNERIE",
            'P8520' => "HOTELLERIE SERVICE ET COMMERCIALISATION",
            'P8521' => "MAITRE D HOTEL",
        ];

        foreach($option_values as $value=>$label){
            civicrm_api3('OptionValue', 'create', [
                'option_group_id' => $custom_group['name'],
                'value' => $value,
                'name' => $label,
            ]);
        }
    }
}
