<?php
use CRM_Cartable_ExtensionUtil as E;

// Reorder existing custom fields
$GrilleCotisation = \Civi\Api4\CustomField::get()
->addWhere('name', '=', 'GrilleCotisation')
  ->setLimit(1)
  ->addChain('update_order', \Civi\Api4\CustomField::update()
    ->addValue('weight', 10)
    ->addWhere('id', '=', '$id')
    )
    ->execute();

$RatioSupplementaire = \Civi\Api4\CustomField::get()
->addWhere('name', '=', 'RatioSupplementaire')
  ->setLimit(1)
  ->addChain('update_order', \Civi\Api4\CustomField::update()
    ->addValue('weight', 15)
    ->addWhere('id', '=', '$id')
    )
    ->execute();

$FrequencesPaiement = \Civi\Api4\CustomField::get()
    ->addWhere('name', '=', 'FrequencesPaiement')
    ->setLimit(1)
    ->addChain('update_order', \Civi\Api4\CustomField::update()
    ->addValue('weight', 20)
    ->addWhere('id', '=', '$id')
    )
    ->execute();

$ThankYouMessage = \Civi\Api4\CustomField::get()
    ->addWhere('name', '=', 'ThankYouMessage')
    ->setLimit(1)
    ->addChain('update_order', \Civi\Api4\CustomField::update()
    ->addValue('weight', 40)
    ->addWhere('id', '=', '$id')
    )
    ->execute();

// Add new custom fields
$days = array_combine(range(1, 31), range(1, 31));

$ContributionStartDay = \Civi\Api4\CustomField::create()
  ->addValue('custom_group_id:name', 'ParametresAdhesion')
  ->addValue('name', 'ContributionStartDay')
  ->addValue('label', E::ts('Contribution Start Day'))
  ->addValue('help_pre', E::ts('When the payment period starts'))
  ->addValue('html_type', 'Select')
  ->addValue('option_values', $days)
  ->addValue('data_type:name', 'Alphanumeric')
  ->addValue('weight', 22)
  ->addValue('is_searchable', false)
  ->addValue('is_active', true)
  ->addValue('is_required', false)
  ->execute();

$ContributionStartDay = \Civi\Api4\CustomField::create()
  ->addValue('custom_group_id:name', 'ParametresAdhesion')
  ->addValue('name', 'ContributionStartMonth')
  ->addValue('label', E::ts('Contribution Start Month'))
  ->addValue('html_type', 'Select')
  ->addValue('option_values', \CRM_Utils_Date::getFullMonthNames())
  ->addValue('data_type:name', 'Alphanumeric')
  ->addValue('weight', 24)
  ->addValue('is_searchable', false)
  ->addValue('is_active', true)
  ->addValue('is_required', false)
  ->execute();

$ContributionEndDay = \Civi\Api4\CustomField::create()
->addValue('custom_group_id:name', 'ParametresAdhesion')
  ->addValue('name', 'ContributionEndDay')
  ->addValue('label', E::ts('Contribution End Day'))
  ->addValue('help_pre', E::ts('When the payment period ends'))
  ->addValue('html_type', 'Select')
  ->addValue('option_values', $days)
  ->addValue('data_type:name', 'Alphanumeric')
  ->addValue('weight', 26)
  ->addValue('is_searchable', false)
  ->addValue('is_active', true)
  ->addValue('is_required', false)
  ->execute();

$ContributionEndDay = \Civi\Api4\CustomField::create()
  ->addValue('custom_group_id:name', 'ParametresAdhesion')
  ->addValue('name', 'ContributionEndMonth')
  ->addValue('label', E::ts('Contribution End Month'))
  ->addValue('html_type', 'Select')
  ->addValue('option_values', \CRM_Utils_Date::getFullMonthNames())
  ->addValue('data_type:name', 'Alphanumeric')
  ->addValue('weight', 28)
  ->addValue('is_searchable', false)
  ->addValue('is_active', true)
  ->addValue('is_required', false)
  ->execute();

$Apportionment = \Civi\Api4\CustomField::create()
  ->addValue('custom_group_id:name', 'ParametresAdhesion')
  ->addValue('name', 'Apportionment')
  ->addValue('label', E::ts('Apportionment'))
  ->addValue('help_post', E::ts('Monthly amount will be calculted based on the number of months until the end of the payment period'))
  ->addValue('html_type', 'Radio')
  ->addValue('data_type', 'Boolean')
  ->addValue('weight', 30)
  ->addValue('is_searchable', false)
  ->addValue('is_active', true)
  ->addValue('is_required', false)
  ->execute();