<?php
use CRM_Cartable_ExtensionUtil as E;

/**
 * Update architecture of professinal custom fields
 * https://git.avecnous.eu/sudeducation/cartable/-/issues/8
 *
 * */ 

$FonctionField_id = _cartable_get_option_group_id('Fonction', 'DonneesParticulier');
$TypeDePosteField_id = _cartable_get_option_group_id('TypeDePoste', 'DonneesParticulier');
$CorpsField_id = _cartable_get_option_group_id('Corps', 'DonneesParticulier');

// Fonctions
$biblio = cartable_get_values('fonctions-biblio');
$tech = cartable_get_values('fonctions-tech');
$sante = cartable_get_values('fonctions-sante-social');
$options = array_merge($biblio, $tech, $sante);
$options = _cartable_cleanup_existing_values_in_options($options, $FonctionField_id);
foreach($options as $value=>$name) {
  $results = \Civi\Api4\OptionValue::create()
    ->addValue('option_group_id', $FonctionField_id)
    ->addValue('value', $value)
    ->addValue('label', $name)
    ->execute();
}

// Move all options from "Type de poste" to "Corps"
$optionValues = \Civi\Api4\OptionValue::get()
->addWhere('option_group_id', '=', $TypeDePosteField_id)
->addChain('move_from_field', \Civi\Api4\OptionValue::update()
      ->addValue('option_group_id', $CorpsField_id)
      ->addWhere('id', '=', '$id')
  )
->execute();

// Remove "Type de poste" field
$customField = \Civi\Api4\CustomField::get()
->addWhere('name', '=', 'TypeDePoste')
->addChain('delete_cf', \Civi\Api4\CustomField::delete()
  ->addWhere('id', '=', '$id')
)
->execute();

// Rename "Corps" field
$customField = \Civi\Api4\CustomField::update()
->addWhere('name', '=', 'Corps')
->addValue('label', 'Corps ou type de poste')
->execute();

// Rename existing options
$options_rename = [
  'enseignant·e' => [
    'value' => 'Enseignant·e',
    'label' => 'Enseignant·e',
  ],
  'Biblio' => [
    'value' => 'Biblio',
    'label' => 'Filière Bibliothèque',
  ],
  'IGR/IGA' => [
    'value' => 'IGE/IGR/ASI',
    'label' => 'IGE, IGR, ASI',
  ],
  'Social / santé' => [
    'value' => 'Santé/social',
    'label' => 'Santé, social',
  ],
];
foreach($options_rename as $old_value=>$option) {
  $results = \Civi\Api4\OptionValue::get()
    ->addWhere('value', '=', $old_value)
    ->setLimit(1)
    ->addChain('update_value', \Civi\Api4\OptionValue::update()
      ->addValue('value', $option['value'])
      ->addValue('label', $option['label'])
      ->addWhere('id', '=', '$id')
    )
  ->execute();
}

// Add new options if not existing
$options_new = cartable_get_values('corps-contractuel')+cartable_get_values('corps-titulaires');
$options_new = _cartable_cleanup_existing_values_in_options($options_new, $CorpsField_id);
foreach($options_new as $value=>$name) {
  $results = \Civi\Api4\OptionValue::create()
    ->addValue('option_group_id', $CorpsField_id)
    ->addValue('value', $value)
    ->addValue('label', $name)
    ->execute();
}

// Cleanup legacy options
// $options_remove = [

// ];
// $options_remove = _cartable_remaining_values_in_options($options_remove, $CorpsField_id);
// foreach($options_remove as $value=>$name) {
//   $results = \Civi\Api4\OptionValue::get()
//     ->addValue('option_group_id', $CorpsField_id)
//     ->addValue('value', $value)
//     ->addChain('update_value', \Civi\Api4\OptionValue::delete()
//       ->addWhere('id', '=', '$id')
//     )
//     ->execute();
// }

