<?php
use CRM_Cartable_ExtensionUtil as E;

/**
 * Update values of professinal custom fields
 * https://git.avecnous.eu/sudeducation/cartable/-/issues/8
 *
 * */ 

$CorpsField_id = _cartable_get_option_group_id('Corps', 'DonneesParticulier');

// Add new options if not existing
$options = cartable_get_values('corps-contractuel')+cartable_get_values('corps-titulaires');
$options_new = _cartable_cleanup_existing_values_in_options($options, $CorpsField_id);
foreach($options_new as $value=>$name) {
  $results = \Civi\Api4\OptionValue::create()
    ->addValue('option_group_id', $CorpsField_id)
    ->addValue('value', $value)
    ->addValue('label', $name)
    ->execute();
}

// Cleanup legacy options
$options_to_remove = [
  "Biatss" => "Biatss",
  "IGE, IGR, ASI" => "IGE, IGR, ASI",
  "Filière Bibliothèque" => "Filière Bibliothèque",
  "Cons. princ. d’éducation" => "Cons. princ. d’éducation",
  "Enseignement et éducation" => "Enseignement et éducation",
];
$options_remove = _cartable_remaining_values_in_options($options_to_remove, $CorpsField_id);
foreach($options_remove as $value=>$name) {
  $results = \Civi\Api4\OptionValue::get()
    ->addWhere('option_group_id', '=', $CorpsField_id)
    ->addWhere('value', '=', $value)
    ->addChain('update_value', \Civi\Api4\OptionValue::delete()
      ->addWhere('id', '=', '$id')
    )
    ->execute();
}
