<?php
use CRM_Cartable_ExtensionUtil as E;
try{
    //grp
    civicrm_api3('OptionGroup', 'create', [
        'name'        => 'contribution_page_options',
        'title'       => E::ts('Contribution Pages'),
        'is_active'   => 1,
    ]);
    $pagesContribution = civicrm_api3('ContributionPage', 'get', [
        'sequential' => 1,
        'options'    => ['limit' => 0],
    ]);
    foreach ($pagesContribution['values'] as $page) {
        civicrm_api3('OptionValue', 'create', [
            'option_group_id' => 'contribution_page_options',
            'name'            => $page['id'],
            'label'           => $page['title'],
            'value'           => $page['id'],
            'is_active'       => 1,
        ]);
    }

    //adhesion id
    civicrm_api3('CustomField', 'create', [
        'custom_group_id' => 'DonneesSyndicat',
        'label'           => E::ts('Membership Page'),
        'name'            => 'MembershipPage',
        'html_type'       => 'Select',
        'data_type'       => 'String',
        'is_searchable'   => 1,
        'is_active'       => 1,
        'is_required'     => 0,
        'weight'          => 6,
        'option_group_id' => 'contribution_page_options'
    ]);
    //don id
    civicrm_api3('CustomField', 'create', [
        'custom_group_id' => 'DonneesSyndicat',
        'label'           => E::ts('Donation Page'),
        'name'            => 'DonationPage',
        'html_type'       => 'Select',
        'data_type'       => 'String',
        'is_searchable'   => 1,
        'is_active'       => 1,
        'is_required'     => 0,
        'weight'          => 6,
        'option_group_id' => 'contribution_page_options'
    ]);
}
catch(\Throwable $e){
    \WPReporting()->send($e, 'cartable');
    die;
}
catch(\Exception $e){
    \WPReporting()->send($e, 'cartable');
    die;
}