<?php
use CRM_Cartable_ExtensionUtil as E;
try{
    //grp
    civicrm_api3('OptionGroup', 'create', [
        'name' => "campaign_pages",
        'title' => "Campaign Pages",
        'is_active' => 1,
    ]);
    $pagesCampaign = civicrm_api3('Campaign', 'get', [
        'sequential' => 1,
        'options'    => ['limit' => 0],
    ]);
    foreach ($pagesCampaign['values'] as $page) {
        civicrm_api3('OptionValue', 'create', [
            'option_group_id' => 'campaign_pages',
            'name'            => $page['id'],
            'label'           => $page['name'],
            'value'           => $page['id'],
            'is_active'       => 1,
        ]);
    }

    civicrm_api3('CustomField', 'create', [
        'custom_group_id' => 'DonneesSyndicat',
        'label'           => E::ts('Campaign Page'),
        'name'            => 'CampaignPage',
        'html_type'       => 'Select',
        'data_type'       => 'String',
        'is_searchable'   => 1,
        'is_active'       => 1,
        'is_required'     => 0,
        'weight'          => 6,
        'option_group_id' => 'campaign_pages'
    ]);

}
catch(\Throwable $e){
    \WPReporting()->send($e, 'cartable');
    die;
}
catch(\Exception $e){
    \WPReporting()->send($e, 'cartable');
    die;
}