<?php 
use CRM_Cartable_ExtensionUtil as E;

//create action for Rule => send email notification for payments
civicrm_api3('CiviRuleAction', 'create', [
    'name'       => "send_email_for_payments",
    'label'      => E::ts("Send an email for payments"),
    'class_name' => "CRM_Cartable_CivirulesActions_SendEmailForPayments",
    "is_active"  => 1,
]);


//create message template for Contact => send email notification for payments
civicrm_api4('MessageTemplate', 'create', [
    'values' => [
      'msg_title' => 'Contributions - Reçu de contribution contact',
      'msg_subject' => 'Confirmation de contribution',
      'msg_text' => "{contact.email_greeting_display},\r\n\r\nYour contribution of {contribution.total_amount}{contribution.tax_currency} to {syndicate.name} has been made successfully.\r\n\r\nThank you for your contribution to {syndicate.name} !",
      'msg_html' => "<p>{contact.email_greeting_display},</p><p>Your contribution of {contribution.total_amount}{contribution.tax_currency} to {syndicate.name} has been made successfully.</p><p>Thank you for your contribution to {syndicate.name} !</p>",
      'is_active' => TRUE,
      'is_default' => TRUE,
    ],
    'checkPermissions' => FALSE,
]);

//create message template for Syndicate => send email notification for payments
civicrm_api4('MessageTemplate', 'create', [
    'values' => [
      'msg_title' => 'Contributions - Reçu de contribution syndicate',
      'msg_subject' => 'Confirmation de contribution',
      'msg_text' => "A contribution of {contribution.total_amount}{contribution.tax_currency} to {syndicate.name} has been made successfully by {contact.displayName} ({contact.email}).",
      'msg_html' => "<p>A contribution of {contribution.total_amount}{contribution.tax_currency} to {syndicate.name} has been made successfully by {contact.displayName} ({contact.email}).</p>",
      'is_active' => TRUE,
      'is_default' => TRUE,
    ],
    'checkPermissions' => FALSE,
]);
