<?php

use CRM_Cartable_ExtensionUtil as E;

try {
    $customGroupMembership = civicrm_api4('CustomGroup', 'get', [
        'select' => [
            'name',
            'table_name',
        ],
        'where' => [
            ['name', '=', 'Parametres'],
        ],
    ]);
    $custom_table_membership = $customGroupMembership->first()['table_name'];

    $customGroupContact = civicrm_api4('CustomGroup', 'get', [
        'select' => [
            'name',
            'table_name',
        ],
        'where' => [
            ['name', '=', 'DonneesParticulier'],
        ],
    ]);
    $custom_table_contact = $customGroupContact->first()['table_name'];

    $sql = "UPDATE
	`{$custom_table_contact}` c
    INNER JOIN civicrm_membership m ON m.contact_id = c.entity_id
    INNER JOIN `{$custom_table_membership}` p ON p.entity_id = m.id
SET
    c.`annual_amount_for_contribution` = SUBSTRING_INDEX(p.`grille_salariale`, '|', -1)
WHERE
    p.`grille_salariale` IS NOT NULL AND c.`annual_amount_for_contribution` IS NULL;
    ";

    CRM_Core_DAO::executeQuery($sql);

} catch(\Throwable $e) {
    \WPReporting()->send($e, 'cartable');
    die;
} catch(\Exception $e) {
    \WPReporting()->send($e, 'cartable');
    die;
}
