<?php

namespace Civi\Api4\Action\Contact;

use CRM_Cartable_API_UpdatePassword as UpdatePasswordAPI;
use Civi\Api4\Generic\Result;
use CRM_Cartable_ExtensionUtil as E;

/**
 * Reset password wordpress
 * 
 */
class UpdatePassword extends \Civi\Api4\Generic\AbstractAction {
    /**
     * id of wordpress user
     * @var int
     */
    protected $userID;
    /**
     * new password
     * @var string
     */
    protected $newPassword;
    
    public function _run(Result $result) {
        $contactID = $this->userID;
        $newPassword = $this->newPassword;

        $wpuserID = getWordPressUserID($contactID);
        

        wp_set_password($newPassword, $wpuserID);

        $result = [
            'status' => 'success',
            'message' => E::ts('Password updated successfully!'),
            'count' => 1,
            'values' => [
                [
                    'wordpress_user_id' => $wpuserID,
                ]
            ],
        ];

        $jsonResponse = json_encode($result);

        header('Content-Type: application/json');
        echo $jsonResponse;
        exit();
    }
   
}

