<?php

$CorpsField = cartable_get_custom_field_id('Corps', 'DonneesParticulier');
$DisciplineField = cartable_get_custom_field_id('Discipline', 'DonneesParticulier');
$AutreDisciplineField = cartable_get_custom_field_id('AutreDiscipline', 'DonneesParticulier');
$StatutField = cartable_get_custom_field_id('Statut', 'DonneesParticulier');
$FonctionField = cartable_get_custom_field_id('Fonction', 'DonneesParticulier');
if(!$CorpsField || !$DisciplineField || !$AutreDisciplineField || !$StatutField){
    return false;
}
return [
    'hide_if_not' => [
        $CorpsField => [
            $StatutField => [
                'titulaire',
                'stagiaire',
                'cdd',
                'cdi',
                'retraite',
            ],
        ],
        $DisciplineField => [
            $CorpsField => [
                'Certifié·e',
                'Agrégé·e',
                'PLP',
                'Enseignant⋅e',
            ],
        ],
        $AutreDisciplineField => [
            $CorpsField => [
                'Autre',
            ],
        ],
        $FonctionField => [
            $CorpsField => [
                'PE',
                'PLP',
                'Certifié·e',
                'Agrégé·e',
                'Biblio',
                'Biatss',
                'Enseignant⋅e',
                'Santé/social',
                'Technique',
            ],
        ],
    ],
    'filter_options' => [
        // Corps
        $CorpsField => [
            // Statut
            $StatutField => [
                'cdd' => cartable_get_values('corps-contractuel'),
                'cdi' => cartable_get_values('corps-contractuel'),
                'titulaire' => cartable_get_values('corps-titulaires'),
                'stagiaire' => cartable_get_values('corps-titulaires'),
                'retraite' => cartable_get_values('corps-retraite'),
            ],
        ],
        $DisciplineField => [
            // Corps
            $CorpsField => [
                'Certifié·e' => cartable_get_values('disciplines-fonctionnaires'),
                'Agrégé·e' => cartable_get_values('disciplines-fonctionnaires'),
                'PLP' => cartable_get_values('disciplines-non-titulaires'),
                'Enseignant⋅e' => cartable_get_values('disciplines-all'),
            ],
        ],
        // Fonction
        $FonctionField => [
            // Corps
            $CorpsField => [
                'PE' => cartable_get_values('fonctions-pe'),

                'PLP' => cartable_get_values('fonctions-plp'),
                'Certifié·e' => cartable_get_values('fonctions-plp'),
                'Agrégé·e' => cartable_get_values('fonctions-plp'),

                'Santé/social' => cartable_get_values('fonctions-sante-social'),
                'Biblio' => cartable_get_values('fonctions-biblio'),
                'Technique' => cartable_get_values('fonctions-tech'),
                'Biatss' => cartable_get_values('fonctions-sante-social')+cartable_get_values('fonctions-biblio')+cartable_get_values('fonctions-tech'),
                
                'Enseignant⋅e' => cartable_get_values('fonctions-education')+cartable_get_values('fonctions-1deg'),
            ],
        ],
    ],
];