<?php
use CRM_Cartable_ExtensionUtil as E;

$default_rates = "
600|6
1000|45
3900|660
";
return [
    'cartable_membership_rates' => [
        'name' => 'cartable_membership_rates',
        'type' => 'String',
        'description' => E::ts('Salary / cotisation amount rates'),
        'default' => trim($default_rates),
        'title' => E::ts('Membership rates'),
        'help_text' => E::ts('One per line. salary_amount|contribution_amount'),
        'html_type' => 'Textarea',
        'html_attributes' => [
            'rows' => 15,
            'cols' => 75
        ],
        'settings_pages' => [
            'member' => [
                'weight' => 150,
            ],
        ],
    ],
    'cartable_membership_ratio' => [
        'name' => 'cartable_membership_ratio',
        'type' => 'Number',
        'description' => E::ts('percentage for grater salary amounts'),
        'default' => '',
        'title' => E::ts('Membership ratio'),
        'html_type' => 'Text',
        'settings_pages' => [
            'member' => [
                'weight' => 160,
            ],
        ],
    ],
    'cartable_tax_deduction' => [
        'name' => 'cartable_tax_deduction',
        'type' => 'Number',
        'description' => E::ts('percentage for fiscal deduction'),
        'default' => '',
        'title' => E::ts('Fiscal deduction'),
        'html_type' => 'Text',
        'settings_pages' => [
            'member' => [
                'weight' => 170,
            ],
        ],
    ],
    'cartable_rules_of_procedure' => [
        'name' => 'cartable_rules_of_procedure',
        'type' => 'String',
        'description' => E::ts('Default rules of procedure'),
        'default' => '',
        'title' => E::ts('Rules of procedure'),
        'html_type' => 'Textarea',
        'html_attributes' => [
            'rows' => 15,
            'cols' => 75
        ],
        'settings_pages' => [
            'member' => [
                'weight' => 180,
            ],
        ],
    ],
    'cartable_fallback_join_url' => [
        'name' => 'cartable_fallback_join_url',
        'type' => 'String',
        'description' => E::ts('Where to redirect when a zone on the map has no available group.'),
        'default' => '',
        'title' => E::ts('Fallback join URL'),
        'html_type' => 'Text',
        'settings_pages' => [
            'member' => [
                'weight' => 190,
            ],
        ],
    ],
    'cartable_profile_url' => [
        'name' => 'cartable_profile_url',
        'type' => 'String',
        'description' => E::ts('URL of profile page'),
        'default' => '',
        'title' => E::ts('URL of profile page'),
        'html_type' => 'Text',
        'settings_pages' => [
            'cartable' => [
                'weight' => 190,
            ],
        ],
    ],
    'cartable_join_url' => [
        'name' => 'cartable_join_url',
        'type' => 'String',
        'description' => E::ts('URL of membership page'),
        'default' => '',
        'title' => E::ts('URL of join page'),
        'html_type' => 'Text',
        'settings_pages' => [
            'cartable' => [
                'weight' => 200,
            ],
        ],
    ],
    'cartable_sud_documentation_url' => [
        'name' => 'cartable_sud_documentation_url',
        'type' => 'String',
        'description' => E::ts('URL of SUD documentation'),
        'default' => '',
        'title' => E::ts('URL of SUD documentation'),
        'html_type' => 'Text',
        'settings_pages' => [
            'cartable' => [
                'weight' => 300,
            ],
        ],
    ],
    'cartable_sud_documentation_url_iframe' => [
        'name' => 'cartable_sud_documentation_url_iframe',
        'type' => 'String',
        'description' => E::ts('URL of SUD documentation iframe'),
        'default' => '',
        'title' => E::ts('URL of SUD documentation iframe'),
        'html_type' => 'Text',
        'settings_pages' => [
            'cartable' => [
                'weight' => 310,
            ],
        ],
    ],
    'cartable_sud_faq_url' => [
        'name' => 'cartable_sud_faq_url',
        'type' => 'String',
        'description' => E::ts('URL of SUD F.A.Q'),
        'default' => '',
        'title' => E::ts('URL of SUD F.A.Q'),
        'html_type' => 'Text',
        'settings_pages' => [
            'cartable' => [
                'weight' => 320,
            ],
        ],
    ],
    'cartable_sud_faq_url_iframe' => [
        'name' => 'cartable_sud_faq_url_iframe',
        'type' => 'String',
        'description' => E::ts('URL of SUD F.A.Q iframe'),
        'default' => '',
        'title' => E::ts('URL of SUD F.A.Q iframe'),
        'html_type' => 'Text',
        'settings_pages' => [
            'cartable' => [
                'weight' => 330,
            ],
        ],
    ],
    'cartable_sud-academies-map-url' => [
        'name' => 'cartable_sud-academies-map-url',
        'type' => 'String',
        'description' => E::ts('URL of SUD academies map'),
        'default' => '',
        'title' => E::ts('URL of SUD academies map'),
        'html_type' => 'Text',
        'settings_pages' => [
            'cartable' => [
                'weight' => 340,
            ],
        ],
    ],
];
