

<table id="cartable-syndicates" class="row-highlight">
    <thead>
        <tr>
            <th></th>
            <th>Syndicat</th>
            {* <th>Membre de</th> *}
            <th>Gestionnaire de</th>
            <th>Campagne</th>
            <th>Type d’adhésion</th>
            <th>Créancier SEPA</th>
            <th>Passerelle de paiement</th>
            <th>Page d'ahésion</th>
            <th>Page de don</th>
            <th>Gestionnaires</th>
            <th>Equipiers</th>
        </tr>
    </thead>
    <tbody>
        {foreach from=$syndicates item=Syndicate}
            <tr class="crm-entity odd-row" id="syndicate-{$Syndicate.id}" data-id="{$Syndicate.id}">
                <td class="cartable-checkbox">
                    {if $Syndicate.membershipType && $Syndicate.campaignName && $Syndicate.managerGroupName && $Syndicate.sepaCreditorName && $processorOfSyndicate && $Syndicate.adhPageName && $Syndicate.donPageName}
                        <input type="checkbox" disabled="disabled"/>
                    {else}
                        <input type="checkbox" id="syndicate-chkbx-{$Syndicate.id}"/>
                    {/if}
                </td>
                <td class="name">
                    <label for="syndicate-chkbx-{$Syndicate.id}">
                        {$Syndicate.display_name}
                    </label>
                    <span>
                        <a href="{crmURL p='civicrm/contact/view' q="cid=`$Syndicate.id`&reset=1"}"><i class="crm-i fa-eye" aria-hidden="true"></i></a>
                    </span>
                </td>
                {* <td class="member-of">
                    
                </td> *}
                <td class="manager-of">
                    {if $Syndicate.managerGroupName}
                        <a href="{crmURL p='civicrm/group' q="action=update&id=`$Syndicate.managerGroupId`&reset=1"}">{$Syndicate.managerGroupName}</a>
                        <input type="hidden" name="manager-of-{$Syndicate.id}" value="{$Syndicate.managerGroupId}">
                    {/if}
                </td>
                <td class="campaign">
                    {if $Syndicate.campaignName }
                        <a href="{crmURL p='civicrm/campaign/add' q="action=update&id=`$Syndicate.campaignId`&reset=1"}">{$Syndicate.campaignName}</a>
                        <input type="hidden" name="campaign-{$Syndicate.id}" value="{$Syndicate.campaignId}">
                    {/if}
                </td>
                <td class="membershiptype">
                    {if $Syndicate.membershipType }
                        <a href="{crmURL p='civicrm/admin/member/membershipType/add' q="action=update&id=`$Syndicate.membershipType.id`&reset=1"}">{$Syndicate.membershipType.name}</a>
                        <input type="hidden" name="membershiptype-{$Syndicate.id}" value="{$Syndicate.membershipType.id}">
                    {/if}
                </td>
                <td class="sepacreditor">
                    {if $Syndicate.sepaCreditorName }
                        <a href="{crmURL p='civicrm/admin/setting/sepa'}">{$Syndicate.sepaCreditorName}</a>
                        <input type="hidden" name="sepaCreditor-{$Syndicate.id}" value="{$Syndicate.sepaCreditorId}">
                    {/if}
                </td>
                <td class="paymentprocessor">
                   {if $Syndicate.paymentProcessor}
                        {foreach from=$Syndicate.paymentProcessor key=processorId item=processor}
                            <a href="{crmURL p='civicrm/admin/paymentProcessor/edit' q="action=update&id=`$processorId`&reset=1"}">{$processor}</a>
                            <input type="hidden" name="paymentProcessor-{$Syndicate.id}" value="{$processorId}">
                            <input type="hidden" name="paymentProcessorSystemPayId" value="{$paymentProcessorSystemPayId}">
                            <input type="hidden" name="paymentProcessorNationalId" value="{$paymentProcessorNationalId}">
                            <br>
                        {/foreach}
                   {/if}
                </td>
                <td class="adhpage">
                    {if $Syndicate.adhPageName }
                        <a href="{crmURL p='civicrm/admin/contribute/settings' q="action=update&id=`$Syndicate.adhPageId`&reset=1"}">{$Syndicate.adhPageName}</a>
                    {/if}
                </td>
                <td class="donpage">
                    {if $Syndicate.donPageName }
                        <a href="{crmURL p='civicrm/admin/contribute/settings' q="action=update&id=`$Syndicate.donPageId`&reset=1"}">{$Syndicate.donPageName}</a>
                    {/if}
                </td>
                <td class="managers">
                    {if $Syndicate.managers}
                        {foreach from=$Syndicate.managers item=manager key=managerKey}
                            <a href="{crmURL p='civicrm/contact/view' q="cid=`$manager.id`&reset=1"}">{$manager.display_name}</a>
                            {if $managerKey < count($Syndicate.managers) - 1}, {/if}
                        {/foreach}
                    {/if}
                </td>
                <td class="teams">
                    {if $Syndicate.teams}
                        {foreach from=$Syndicate.teams item=team key=teamKey}
                            <a href="{crmURL p='civicrm/contact/view' q="cid=`$team.id`&reset=1"}">{$team.display_name}</a>
                            {if $teamKey < count($Syndicate.teams) - 1}, {/if}
                        {/foreach}
                    {/if}
                </td>
            </tr>
        {/foreach}
    </tbody>
</table>
<br>
<hr>
<br>
<div id="cartable-generator-tools" class="">
    <div class="crm-block crm-form-block">
        <h2>
            {ts domain='cartable'}Managers{/ts}
        </h2>
        <h3>
            <span class="crm-i fa fa-plus"></span> {ts domain='cartable'}Ajouter des gestionnaires{/ts}
        </h3>
        <div class="crm-submit-buttons">
            <p class="row">
             Selectionner le Syndicat ET le groupe 
            </p>
            <p class="row">
                <label for="add-manager-for-syndicate">{ts}Group{/ts}</label>
                <select id="add-manager-for-syndicate" class="crm-select2 crm-form-select">
                    {if $allManagerGroups}
                        {foreach from=$allManagerGroups item=ManagerGroup}
                            <option value="{$ManagerGroup.childId}">
                                {$ManagerGroup.childTitle}
                            </option>
                        {/foreach}
                    {/if}
                </select>
            </p>
            <p class="row">
            <label for="add-manager-contact-mail">{ts}Email(s) (séparés par une ","){/ts}</label>
            <input type="text" id="add-manager-contact-mail" name="add-manager-contact-mail" size="150">
            </p>
            <button id="cartable-generate-add-manager-for-syndicate" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Ajouter les gestionnaires{/ts}
            </button>
        </div>
    </div>

    <div class="crm-block crm-form-block">
        <h2>
            {ts domain='cartable'}Team{/ts}
        </h2>
        <h3>
            <span class="crm-i fa fa-plus"></span> {ts domain='cartable'}Ajouter des équipiers{/ts}
        </h3>
        <div class="crm-submit-buttons">
            <p class="row">
             Selectionner le Syndicat ET le groupe 
            </p>
            <p class="row">
                <label for="add-team-for-syndicate">{ts}Group{/ts}</label>
                <select id="add-team-for-syndicate" class="crm-select2 crm-form-select">
                    <option value="{$teamParentGroupId}">
                        {$teamParentTitle}
                    </option>
                    {if $allTeamGroups}
                        {foreach from=$allTeamGroups item=TeamGroup}
                            <option value="{$TeamGroup.childId}">
                                {$TeamGroup.childTitle}
                            </option>
                        {/foreach}
                    {/if}
                </select>
            </p>
            <p class="row">
            <label for="add-team-contact-mail">{ts}Email(s) (séparés par une ","){/ts}</label>
            <input type="text" id="add-team-contact-mail" name="add-team-contact-mail" size="150">
            </p>
            <button id="cartable-generate-add-team-for-syndicate" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Ajouter les équipiers{/ts}
            </button>
        </div>
    </div>

    {* <div class="crm-block crm-form-block">
        <h3>
            {ts domain='cartable'}Générer les groupes membres{/ts}
        </h3>
        <p class="row">
        </p>
        <div class="crm-submit-buttons">
            <button id="cartable-generate-member-group" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les groupes membres{/ts}
            </button>
        </div>
    </div> *}

    <div class="crm-block crm-form-block">
        <h2>
            {ts domain='cartable'}Manager groups{/ts}
        </h2>
        <h3>
            {ts domain='cartable'}Générer les groupes gestionnaires{/ts}
        </h3>
        <p class="row">
            <label for="manager_group_visibility">{ts}Visibility{/ts}</label>
            <select id="manager_group_visibility" class="crm-select2 crm-form-select">
                <option value="User and User Admin Only">
                    {ts}User and User Admin Only{/ts}
                </option>
                <option value="Public Pages">
                    {ts}Public Pages{/ts}
                </option>
            </select>
        </p>
        <p class="row">
            <label for="manager_group_type">{ts}Group Type{/ts}</label>
            <select id="manager_group_type" class="crm-select2 crm-form-select" multiple="multiple">
                <option value="Contrôle d'accès">{ts}Contrôle d'accès{/ts}</option>
                <option value="Liste de diffusion">{ts}Liste de diffusion{/ts}</option>
            </select>
        </p>
        <p class="row">
            <label for="manager_group_is_active">{ts}Active{/ts}</label>
            <input type="checkbox" id="manager_group_is_active" name="manager_group_is_active">
        </p>
        <p class="row">
            <label for="manager_group_is_reserved">{ts}Reserved{/ts}</label>
            <input type="checkbox" id="manager_group_is_reserved" name="manager_group_is_reserved">
        </p>
        <input type="hidden" id="manager_group_parent" name="manager_group_parent" value={$managerParentGroupId}>
        <div class="crm-submit-buttons">
            <button id="cartable-generate-manager-group" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les groupes gestionnaires{/ts}
            </button>
        </div>
    </div>

    <div class="crm-block crm-form-block">
        <h2>
            {ts}Campaigns{/ts}
        </h2>
        <h3>
            {ts domain='cartable'}Générer les campagnes pour les syndicats sélectionnés{/ts}
        </h3>
            <p class="row">
                <label for="campaign_type_id">{ts}Campaign Type{/ts}</label>
                <select id="campaign_type_id" class="crm-select2 crm-form-select">
                        <option value="Constituent Engagement">
                            {ts}Constituent Engagement{/ts}
                        </option>
                        <option value="Direct Mail">
                            {ts}Direct Mail{/ts}
                        </option>
                        <option value="Referral Program">
                            {ts}Referral Program{/ts}
                        </option>
                </select>
            </p>
            <p class="row">
                <label for="campaign_status_id">{ts}Campaign Status{/ts}</label>
                <select id="status_id" class="crm-select2 crm-form-select">
                    <option value="In Progress">
                        {ts}In Progress{/ts}
                    </option>
                    <option value="Planned">
                        {ts}Planned{/ts}
                    </option>
                    <option value="Completed">
                        {ts}Completed{/ts}
                    </option>
                    <option value="Cancelled">
                        {ts}Cancelled{/ts}
                    </option>
                </select>
            </p>
            <p class="row">
                <label for="campaign_start_date">{ts}Start date{/ts}</label>
                <input type="date" id="campaign_start_date" name="campaign_start_date"/>
            </p>
            <p class="row">
                <label for="campaign_is_active">{ts}Active{/ts}</label>
                <input type="checkbox" id="campaign_is_active" name="campaign_is_active">
            </p>
            <div class="crm-submit-buttons">
            <button id="cartable-generate-campaign" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les campagnes{/ts}
            </button>
        </div>
    </div>

    <div class="crm-block crm-form-block">
        <h2>
            {ts}Membership Types{/ts}
        </h2>
        <h3>
            {ts domain='cartable'}Générer les types d’adhésion pour les syndicats sélectionnés{/ts}
        </h3>
        <p class="row">
            <label for="financial_type_id">{ts}Financial Type{/ts}</label>
            <select id="financial_type_id" class="crm-select2 crm-form-select">
                {foreach from=$financialTypes item=financialType}
                    <option value="{$financialType.name}">
                        {$financialType.name}
                    </option>
                {/foreach}
            </select>
        </p>

        <p class="row">
            <label for="duration_interval">{ts}Duration Interval{/ts}</label>
            <input id="duration_interval" type="number" value="" class="crm-form-text" size="4"/>
            <select id="duration_unit" class="crm-select2 crm-form-select">
                <option value="year">{ts}Year{/ts}</option>
                <option value="month">{ts}Month{/ts}</option>
                <option value="day">{ts}Day{/ts}</option>
            </select>
        </p>

        <p class="row">
            <label for="period_type">{ts}Period Type{/ts}</label>
            <select id="period_type" class="crm-select2 crm-form-select" >
                <option value="fixed">{ts}Fixed{/ts}</option>
                <option value="variable">{ts}Variable{/ts}</option>
            </select>
        </p>

        <div class="crm-submit-buttons">
            <button id="cartable-generate-membership-type" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les types d'ahésions{/ts}
            </button>
        </div>
    </div>

    <div class="crm-block crm-form-block">
        <h2>
            {ts domain='cartable'}ICS{/ts}
        </h2>
        <h3>
            {ts domain='cartable'}Générer les créanciers SEPA pour les syndicats sélectionnés{/ts}
        </h3>
        <p class="row">
            <label for="sepacreditor_sepa_file_format_id_name">{ts}Version PAIN{/ts}</label>
            <select id="sepacreditor_sepa_file_format_id_name" class="crm-select2 crm-form-select" >
                <option value="pain.008.001.02">{ts}pain.008.001.02 (ISO 20022/official SEPA guidelines){/ts}</option>
                <option value="pain.008.003.02">{ts}pain.008.003.02 container core direct debit (CDC EBICS-2.7){/ts}</option>
                <option value="pain.008.003.02 COR1">{ts}pain.008.003.02 (COR1 EBICS-3.0){/ts}</option>
                <option value="pain_008_003_02_rcur_ch">{ts}pain.008.003.02 (EBICS-3.0 RCUR/CH){/ts}</option>
                <option value="pain_008_001_02_CH_03">{ts}pain.008.001.02.CH.03 (CH-DD){/ts}</option>
                <option value="pain_008_003_02_address">{ts}pain.008.003.02 with Address (EBICS-3.0){/ts}</option>
                <option value="pain_008_001_02_OTHERID">{ts}pain.008.001.02 without BIC{/ts}</option>
                <option value="pain_008_001_02_NOCSNM">{ts}pain.008.001.02 without BIC and CdtrSchmId:Nm{/ts}</option>
            </select>
        </p>
        <p class="row">
            <label for="sepacreditor_uses_bic">{ts}Uses BIC{/ts}</label>
            <input type="checkbox" id="sepacreditor_uses_bic" name="sepacreditor_uses_bic">
        </p>
        <p class="row">
            <label for="sepacreditor_mandate_active">{ts}Active{/ts}</label>
            <input type="checkbox" id="sepacreditor_mandate_active" name="sepacreditor_mandate_active">
        </p>
        <div class="crm-submit-buttons">
            <button id="cartable-generate-sepacreditor" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les créanciers SEPA{/ts}
            </button>
        </div>
    </div>

    <div class="crm-block crm-form-block">
        <h2>
            {ts}Payment Processors{/ts}
        </h2>
        <h3>
            {ts domain='cartable'}Générer les passerelles de paiement pour les syndicats sélectionnés{/ts}
        </h3>
        <p class="row">
            <label for="payment_processor_financial_account_id_name">{ts}Compte comptable{/ts}</label>
            <select id="payment_processor_financial_account_id_name" class="crm-select2 crm-form-select" >
                <option value="Le compte de la passerelle de paiement">{ts}Le compte de la passerelle de paiement{/ts}</option>
                <option value="Compte à recevoir">{ts}Compte à recevoir{/ts}</option>
                <option value="Compte courant bancaire">{ts}Compte courant bancaire{/ts}</option>
                <option value="Stock cadeaux">{ts}Stock cadeaux{/ts}</option>
            </select>
        </p>
        <p class="row">
            <label for="payment_processor_is_active">{ts}Active{/ts}</label>
            <input type="checkbox" id="payment_processor_is_active" name="payment_processor_is_active">
        </p>
        <p class="row">
            <label for="payment_processor_is_default">{ts}Default{/ts}</label>
            <input type="checkbox" id="payment_processor_is_default" name="payment_processor_is_default">
        </p>
        <p class="row">
            <label for="payment_processor_choice">{ts}Passerelles à ajouter{/ts}</label>
            <select id="payment_processor_choice" class="crm-select2 crm-form-select" multiple="multiple">
                <option value="processor_systempay">{ts}CB SystemPay National{/ts}</option>
                <option value="processor_national">{ts}Prélèvement automatique (national){/ts}</option>
                <option value="processor_syndicate">{ts}Prélèvement local (ex: Prélèvement bancaire (17)){/ts}</option>
                <option value="processor_cheque">{ts}Chèque{/ts}</option>
            </select>
        </p>

        <div class="crm-submit-buttons">
            <button id="cartable-generate-payment-processor" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les passerelles de paiement{/ts}
            </button>
        </div>
    </div>

    <div class="crm-block crm-form-block">
        <h2>
            {ts}Membership Pages{/ts}
        </h2>
        <h3>
            {ts domain='cartable'}Générer les pages d’adhésion pour les syndicats sélectionnés{/ts}
        </h3>
        <p class="row">
            <label for="adh-page_is_confirm_enabled">{ts}Utiliser une page de confirmation?{/ts}</label>
            <input type="checkbox" id="adh-page_is_confirm_enabled" name="adh-page_is_confirm_enabled">
        </p>
        <p class="row">
            <label for="adh-page_is_active">{ts}Active{/ts}</label>
            <input type="checkbox" id="adh-page_is_active" name="adh-page_is_active">
        </p>
        <hr>
        <p class="row">
            <label for="adh-page_is_pay_later">{ts}Option « Je paye plus tard »{/ts}</label>
            <input type="checkbox" id="adh-page_is_pay_later" name="adh-page_is_pay_later">
        </p>
        <p class="row">
            <label for="adh-page_amount_block_is_active">{ts}Section des montants de contribution activée{/ts}</label>
            <input type="checkbox" id="adh-page_amount_block_is_active" name="adh-page_amount_block_is_active">
        </p>
        <p class="row">
            <label for="adh-page_is_recur">{ts}Contributions périodiques{/ts}</label>
            <input type="checkbox" id="adh-page_is_recur" name="adh-page_is_recur">
            <label for="adh-page_recur_frequency_unit">{ts}Unités possibles{/ts}</label>
            <select id="adh-page_recur_frequency_unit" class="crm-select2 crm-form-select" multiple="multiple">
                <option value="day">{ts}Day{/ts}</option>
                <option value="week">{ts}Week{/ts}</option>
                <option value="month">{ts}Month{/ts}</option>
                <option value="year">{ts}Year{/ts}</option>
            </select>
        </p>
        <p class="row">
            <label for="adh-page_is_allow_other_amount">{ts}Autoriser les autres montants{/ts}</label>
            <input type="checkbox" id="adh-page_is_allow_other_amount" name="adh-page_is_allow_other_amount">
        </p>
        <hr>
        <p class="row">
            <label for="adh-page_member_is_active">{ts}Section d'adhésion activée ?{/ts}</label>
            <input type="checkbox" id="adh-page_member_is_active" name="adh-page_member_is_active">
        </p>
        <p class="row">
            <label for="adh-page_display_min_fee">{ts}Afficher la cotisation{/ts}</label>
            <input type="checkbox" id="adh-page_display_min_fee" name="adh-page_display_min_fee">
        </p>
        <p class="row">
            <label for="adh-page_is_required">{ts}Nécessite l'adhésion{/ts}</label>
            <input type="checkbox" id="adh-page_is_required" name="adh-page_is_required">
        </p>
        <hr>
        <p class="row">
            <label for="adh-page_params_frequency">{ts}Fréquences de paiement{/ts}</label>
            <select id="adh-page_params_frequency" class="crm-select2 crm-form-select" multiple="multiple">
            <option value="yearly">{ts}Renouvellement Annuel{/ts}</option>
            <option value="monthly">{ts}Renouvellement Mensuel{/ts}</option>
            <option value="monthly_apportionment">{ts}Renouvellement mensuel réparti{/ts}</option>
            <option value="oneoff">{ts}Une fois{/ts}</option>
        </select>
        </p>
        <div class="crm-submit-buttons">
            <button id="cartable-generate-adh-page" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les pages d’adhésion{/ts}
            </button>
        </div>
    </div>

    <div class="crm-block crm-form-block">
        <h2>
            {ts}Contribution Pages{/ts}
        </h2>
        <h3>
            {ts domain='cartable'}Générer les pages de don pour les syndicats sélectionnés{/ts}
        </h3>
        <p class="row">
            <label for="don-page_is_confirm_enabled">{ts}Utiliser une page de confirmation?{/ts}</label>
            <input type="checkbox" id="don-page_is_confirm_enabled" name="don-page_is_confirm_enabled">
        </p>
        <p class="row">
            <label for="don-page_is_active">{ts}Active{/ts}</label>
            <input type="checkbox" id="don-page_is_active" name="don-page_is_active">
        </p>
        <hr>
        <p class="row">
            <label for="don-page_is_pay_later">{ts}Option « Je paye plus tard »{/ts}</label>
            <input type="checkbox" id="don-page_is_pay_later" name="don-page_is_pay_later">
        </p>
        <p class="row">
            <label for="don-page_amount_block_is_active">{ts}Section des montants de contribution activée{/ts}</label>
            <input type="checkbox" id="don-page_amount_block_is_active" name="don-page_amount_block_is_active">
        </p>
        <p class="row">
            <label for="don-page_is_recur">{ts}Contributions périodiques{/ts}</label>
            <input type="checkbox" id="don-page_is_recur" name="don-page_is_recur">
            <label for="don-page_recur_frequency_unit">{ts}Unités possibles{/ts}</label>
            <select id="don-page_recur_frequency_unit" class="crm-select2 crm-form-select" multiple="multiple">
                <option value="day">{ts}Day{/ts}</option>
                <option value="week">{ts}Week{/ts}</option>
                <option value="month">{ts}Month{/ts}</option>
                <option value="year">{ts}Year{/ts}</option>
            </select>
        </p>
        <p class="row">
            <label for="don-page_is_allow_other_amount">{ts}Autoriser les autres montants{/ts}</label>
            <input type="checkbox" id="don-page_is_allow_other_amount" name="don-page_is_allow_other_amount">
        </p>
        <hr>
        <p class="row">
            <label for="don-page_member_is_active">{ts}Section d'adhésion activée ?{/ts}</label>
            <input type="checkbox" id="don-page_member_is_active" name="don-page_member_is_active">
        </p>
        <p class="row">
            <label for="don-page_display_min_fee">{ts}Afficher la cotisation{/ts}</label>
            <input type="checkbox" id="don-page_display_min_fee" name="don-page_display_min_fee">
        </p>
        <p class="row">
            <label for="don-page_is_required">{ts}Nécessite l'adhésion{/ts}</label>
            <input type="checkbox" id="don-page_is_required" name="don-page_is_required">
        </p>
        <div class="crm-submit-buttons">
            <button id="cartable-generate-don-page" class="crm-button crm-form-submit">
                <i aria-hidden="true" class="crm-i fa-check"></i>
                {ts domain='cartable'}Générer les pages de don{/ts}
            </button>
        </div>
    </div>
</div>


{literal}
<script type="text/javascript">
var syndicates = {/literal}{$syndicates|@json_encode}{literal};
</script>
{/literal}
