var gulp = require('gulp');
var uglify = require('gulp-uglify');
var rename = require('gulp-rename');
var pipeline = require('readable-stream').pipeline;
var sass = require('gulp-sass')(require('node-sass'));
var sourcemaps = require('gulp-sourcemaps');

sass.compiler = require('node-sass');

function compile_script(done) {
    gulp.src('./src/js/*.js')
    .pipe(uglify())
    .pipe(rename(function (path) {
        path.extname = ".js"
    }))
    .pipe(gulp.dest('./cartable/assets/built'));
    done();
};
function compile_script_dev(done) {
    gulp.src('./src/js/*.js')
    .pipe(rename(function (path) {
        path.extname = ".js"
    }))
    .pipe(gulp.dest('./cartable/assets/built'));
    done();
};
function compile_css(done) {
    gulp.src('./src/css/*.scss')
    .pipe(sass({outputStyle: 'compressed'}).on('error', sass.logError))
    .pipe(gulp.dest('./cartable/assets/built'));
    done();
};
function compile_css_dev(done) {
    gulp.src('./src/css/*.scss')
    .pipe(sourcemaps.init())
    .pipe(sass().on('error', sass.logError))
    .pipe(sourcemaps.write('.'))
    .pipe(gulp.dest('./cartable/assets/built'));
    done();
};

exports.build = gulp.series(compile_script, compile_css);

exports.watch = function() {
  gulp.series(compile_script_dev, compile_css_dev);
  // You can use a single task
  gulp.watch('src/css/**/*.scss', compile_css_dev);
  // Or a composed task
  gulp.watch('src/js/**/*.js', compile_script_dev);
};
