var initial_auto_select = false;

//donation
if (cartable.membershipField == null) {
    CRM.$('.contribution_amount-section .label').replaceWith(function () {
        return '<h3>' + CRM.$(this).text() + '</h3>';
    });
    CRM.$('.price-set-option-content').hide();
    var buttons = CRM.$('.contribution_amount-section input').map(function(index) {
        var label = CRM.$(this).siblings('label').text();
        if (label.includes('€')) {
            label = CRM.$(this).siblings('label').find('.crm-price-amount-amount').text();
        }
        var inputIndex = index;
        return '<button class="cartable-donation-button" data-input-index="' + inputIndex + '">' + label + '</button>';
    }).get();
    var buttonContainer = CRM.$('<div>').addClass('cartable-donation-button-container');
    buttonContainer.append(buttons); 
    CRM.$('.contribution_amount-section').append(buttonContainer);
    var section_other_amount = CRM.$('.other_amount-section');
    section_other_amount.hide();
    var elements_amount = CRM.$('button.cartable-donation-button');
    if (elements_amount.length > 0) {
        var last_element_amount = elements_amount.slice(-1)[0];
        var last_element_input_index = CRM.$(last_element_amount).data('input-index');

        elements_amount.on('click', function(event) {
            event.preventDefault();
            var inputIndex = CRM.$(this).data('input-index');
            var next_button = CRM.$("[data-id='tab-cartable-tab-step-3']");
            var amountField = CRM.$('.other_amount-content input');
            amountField.val('');
            CRM.$('.contribution_amount-section input').eq(inputIndex).prop('checked', true).css('display', 'none');
            if (this !== last_element_amount) {
                section_other_amount.hide();
                CRM.$(next_button).show();
            } else {
                CRM.$(next_button).hide();
                section_other_amount.show();
                CRM.$(this).prop('checked', 'checked').trigger('change');
                var amount_field = CRM.$('.other_amount-content input');
                var errorMessage = CRM.$('<div class="error-message crm-error"></div>');
                CRM.$(amount_field).on('input', function () {
                    var amount_field_value = amount_field.val();
                    CRM.$(next_button).hide();
                    if(amount_field_value != '') {
                        if (isNaN(amount_field_value)) {
                            CRM.$(next_button).hide();
                            var translatedTextNumberOnly = ts('This field should only contain numbers', 'cartable');
                            errorMessage.html(translatedTextNumberOnly)
                            amount_field.addClass('crm-error');
                            amount_field.removeClass('valid');
                            amount_field.after(errorMessage);
                            amount_field.css('border-color', 'red');
                        } else {
                            var containsOnlyZeros = /^0+$/.test(amount_field_value);
                            if (containsOnlyZeros) {
                                CRM.$(next_button).hide();
                                var translatedTextNotZero = ts('This field can not be empty. Please enter an not null amount.', 'cartable');
                                errorMessage.html(translatedTextNotZero);
                                amount_field.addClass('crm-error');
                                amount_field.removeClass('valid');
                                amount_field.css('border-color', 'red');
                            }
                            amount_field.removeClass('crm-error');
                            errorMessage.remove();
                            amount_field.css('border-color', '');
                            CRM.$(next_button).show();
                        }
                    } else {
                        CRM.$(next_button).hide();
                        var translatedTextNotNull = ts('This field can not be empty. Please enter an amount.', 'cartable');
                        errorMessage.html(translatedTextNotNull);
                        amount_field.addClass('crm-error');
                        amount_field.removeClass('valid');
                        amount_field.css('border-color', 'red');
                    }
                })
                
            }
            elements_amount.not(this).removeClass('current');
            CRM.$(this).addClass('current');
        });
    }
}
const cartable_select_zone = function () {
    CRM.$('#cartable-academies-selector').text('');
    CRM.$('#cartable-academies-map-wrapper svg path.zone').removeClass('current');
    if (CRM.$(this)[0].tagName === 'path') {
        var zone_path = CRM.$(this);
    }
    else if (membershipType) {
        var zone_path = cartable.mt_to_zones[membershipType.id];
    }
    zone_path.addClass('current');
    var deps = (zone_path.attr('data-departements')).split(',');

    deps.forEach((dep) => {
        if (typeof cartable.Syndicates.IndexedSyndicates[dep] == 'undefined' || cartable.Syndicates.IndexedSyndicates[dep].length === 0) {
            CRM.$('#cartable-tab-step-1 .front-tabs-link.next').hide();
            return;
        }
        cartable.Syndicates.IndexedSyndicates[dep].forEach((syndicate_id) =>{
            var syndicate = cartable.Syndicates.Syndicates[syndicate_id];
            if(syndicate.membership_field === null){
                return;
            }
            if(syndicate.PaymentProcessors.length === 0){
                return;
            }
            var item_row = CRM.$('<label>')
                .addClass('cartable-syndicate')
                .attr('id', 'cartable-label-' + syndicate.membership_field)
                .attr('data-id', syndicate.id)
                .attr('data-name', syndicate.display_name)
                .attr('for', syndicate.membership_field)
                .append('<span>' + syndicate.display_name + '</span>')
                .on('click', function () {
                    CRM.$('#' + CRM.$(this).attr('for')).prop('checked', 'checked').trigger('change');
                    js_tab_openTab('cartable-tab-step-2');
            });
            CRM.$('#cartable-academies-selector').append(item_row);
        });
        var targetElement = CRM.$('label[data-id="' + cartable.get('csynd') + '"]');
        if (targetElement.length > 0) {
            jQuery(document).ready(function () {
                targetElement.click();
            });
        }

    });
    if(initial_auto_select){
        CRM.$('#cartable-tab-step-1 .front-tabs-link.next').show();
    }
    if (initial_auto_select === false && CRM.$('#cartable-academies-selector label').length == 1) {
        initial_auto_select = true;
        CRM.$('#' + (CRM.$('#cartable-academies-selector label').attr('for'))).prop('checked', 'checked').trigger('change');
        js_tab_openTab('cartable-tab-step-2');
    }
    else{
        location.hash = '#cartable-academies-selector';
    }
    initial_auto_select = false;
};


jQuery(document).ready(function(){
    // Map
    cartable.mt_to_zones = {};
    CRM.$('#cartable-academies-map-wrapper svg path').each(function(){
        var deps = CRM.$(this).attr('data-departements');
        if(!deps){
            return;
        }
        var zone = CRM.$(this);
        var zone_syndics = [];
        deps = deps.split(',');
        deps.forEach((dep) => {
            if(typeof cartable.Syndicates.IndexedSyndicates[dep] != 'undefined'){
                cartable.Syndicates.IndexedSyndicates[dep].forEach((syndicate_id) =>{
                    if(typeof cartable.Syndicates.IndexedMembershipTypes[syndicate_id] != 'undefined'){
                        var membershiptype = cartable.Syndicates.IndexedMembershipTypes[syndicate_id];
                        cartable.mt_to_zones[membershiptype.id] = zone;
                        var syndicate = cartable.Syndicates.Syndicates[syndicate_id];
                        if (CRM.$('#' + syndicate.membership_field).length){
                            CRM.$('#'+syndicate.membership_field).attr('data-syndicate-id', syndicate.id);
                            zone_syndics.push(syndicate);
                        }
                    }

                });
            }
        });
        if (zone_syndics.length > 0) {
            var zoneElement = CRM.$(this).addClass('zone').on('click', cartable_select_zone);
            zoneElement.click();
        }
        else{
            CRM.$(this).addClass('nomansland');
            if (cartable.Membership.membershipFallbackJoinURL) {
                CRM.$(this).on('click', function(){
                    window.open(cartable.Membership.membershipFallbackJoinURL, '_blank');
                });
            }
        }
    });


    // In membership-completing context, we hide every fields except the one we need
    // Execution is stopped after this "if"
    if( typeof cartable.Membership.MembershipToComplete != 'undefined' && cartable.Membership.MembershipToComplete !== null){
        CRM.$('#cartable-tab-step-1').hide();
        return;
    }

    // Tabs
    CRM.$('.crm-contribution-main-form-block .crm-public-form-item').each(function(){
        CRM.$('script', CRM.$(this)).insertAfter(CRM.$('.crm-contribution-main-form-block'));
        if((CRM.$(this).text()).trim()===''){
            CRM.$(this).remove();
        }
    });
    jQuery('.crm-contribution-main-form-block').on('tab_ready', function(){
        jQuery('.crm-contribution-main-form-block .front-tabs-menu-item .front-tabs-link').css({cursor:'default'}).unbind();
        CRM.$('.crm-contribution-main-form-block .front-tabs-link.next').hide();
    }).createTabs({
        children: '.cartable-tab-section',
        childrenTitle: 'h2',
        //hideUntilLast: 'input[type=submit]',
        prevText: cartable.Syndicates.i18n.tabs.back,
        nextText: cartable.Syndicates.i18n.tabs.next,
        prevClass: 'btn prev',
        nextClass: 'btn next'
    }).after('<div id="cartable-post-contribution-form"></div>');
    // Align main form button, for tab integration
    CRM.$('#_qf_Main_upload-bottom').addClass('float-right');

    // Membership
    CRM.$('#priceset .membership_amount-content input[type=radio]').on('change', function(){
        if(CRM.$(this).is(':checked')){
            CRM.$('label.cartable-syndicate').removeClass('active');
            CRM.$('#cartable-label-'+CRM.$(this).attr('id')).addClass('active');
            CRM.$(this).trigger('chosen');
            if(typeof education_nationale_school_filters != 'undefined'){
                education_nationale_school_filters.postal_code
            }
        }
    });

});
