var cartable = cartable || {};

/**
 *
 * @param {string} parameterName
 * @returns {string}
 */
cartable.get = function (parameterName) {
    var result = null,
        tmp = [];
    var items = location.search.substr(1).split("&");
    for (var index = 0; index < items.length; index++) {
        tmp = items[index].split("=");
        if (tmp[0] === parameterName) result = decodeURIComponent(tmp[1]);
    }
    return result;
}

/**
 * Autofill stuff
 */
cartable._autofill = {};

/**
 * Add a field to the autofill list
 * @param {string} selector
 * @param {string} get_param
 */
cartable.addAutoFill = function (selector, get_param) {
    cartable._autofill[selector] = get_param;
};

/**
 * Autofill fields
 */
cartable.autoFill = function () {
    try {
        if (cartable && cartable._autofill) {
            for (f in cartable._autofill) {
                cartable.autofill_field(f, cartable._autofill[f]);
            }
        }
    }
    catch (err) {
        wp_reporting.log_error('cartable', err);
    }
};

/**
 *
 * @param {string} field_name
 * @param {string} get_parameter
 * @returns {boolean}
 */
cartable.autofill_field = function (field_name, get_parameter) {
    if (get_parameter === undefined) {
        get_parameter = field_name;
    }
    var _get_param = cartable.get(get_parameter);
    var _targets;
    if (_get_param === null) {
        return false;
    }
    if (field_name.substr(0, 1) == '#' || field_name.substr(0, 1) == '.') {
        _targets = CRM.$(field_name);
    }
    else {
        _targets = CRM.$('input[name=' + field_name + '], textarea[name=' + field_name + '], select[name=' + field_name + ']');
    }
    _multi = _targets.length;
    if (_multi === 0) {
        return false;
    }
    // Multi
    if (_targets.attr('type') === 'radio' || _targets.attr('type') === 'checkbox') {
        $('input[name=' + field_name + '][value=' + _get_param + ']').attr('checked', 'checked').trigger('change').trigger('click');
    }
    // Single
    else {
        _targets.val(_get_param).trigger('change').trigger('click');
    }
    return true;
}

/**
 * 
 * @param {*} datestring 
 * @returns string
 */
cartable.format_date = function (datestring) {
    return CRM.utils.formatDate(datestring, cartable.Membership.i18n.dateformat);
}

/**
 * 
 * @param float amount 
 * @returns float
 */
cartable.fiscal_deducted = function (amount) {
    return Math.round(amount * (100 - cartable.Membership.membershipTaxDeduction)) / 100;
}

/**
 * 
 * @param float value 
 * @returns string
 */
cartable.amountForHumans = function (value) {
    return isNaN(value) ? '' : value + cartable.Membership.currency.symbol;
}

/**
 * 
 * @param float value 
 * @returns int
 */
cartable.roundedAmountByMonths = function (value) {
    return Math.round(AnnualContributionAmount / (value / 100)) / 100;
}

/**
 * 
 * @param object obj 
 * @returns object
 */
cartable.sortObject = function (obj) {
    return Object.keys(obj).sort().reduce(function (result, key) {
        result[key] = obj[key];
        return result;
    }, {});
}