jQuery(document).ready(function () {
    const url = new URL(window.location.href);
    const cid = url.searchParams.get('cid');
    let cachedContributionRecurs = null;

    var contributionRecurring = CRM.$("#tab_recurring a em");
    var contributionEm = CRM.$("#tab_contribute a em");
    var contributionNotRecur = contributionEm.html();

    function fetchContributionRecurs() {
        if (cachedContributionRecurs !== null) {
            return Promise.resolve(cachedContributionRecurs);
        }

        return CRM.api4('ContributionRecur', 'get', {
            where: [["contact_id", "=", cid], ["contribution_status_id:name", "NOT IN", ["Cancelled", "Failed", "Completed"]]],
            checkPermissions: false
        }).then(function (data) {
            cachedContributionRecurs = data;
            return cachedContributionRecurs;
        });
    }

    // recurring contribution tab
    if (contributionRecurring.html() !== undefined) {
         contributionRecurring.html('<span class="loading-spinner">...</span>');
         fetchContributionRecurs().then(function (activeContributionRecurs) {
            contributionRecurring.html(activeContributionRecurs.length);
         }).catch(function (failure) {
            console.error("Error retrieving recurring contributions:", failure);
        });
    }
    
    // counter 
    function updateContributionCount() {
        fetchContributionRecurs().then(function (contributionRecurs) {
            if (contributionRecurs.length > 0) {
                var numberOfRecurContribution = contributionRecurs.length;
                var numberOfContributionToShow = `${contributionNotRecur}/${numberOfRecurContribution}`;
                contributionEm.html(numberOfContributionToShow);
            } else {
                if (contributionNotRecur == 0) {
                    var numberOfContributionToShow = `${contributionNotRecur}`;
                    contributionEm.html(numberOfContributionToShow);
                }
            }
        }).catch(function (failure) {
            console.error("Error updating contribution count:", failure);
        });
    }

    updateContributionCount();
    
    CRM.$(window).on('beforeunload', function () {
        CRM.$(window).off('popstate', restoreContributionCount);
    });
    
    CRM.$(window).on('popstate', restoreContributionCount);
    
    function restoreContributionCount() {
        contributionEm.html(contributionNotRecur);
    }
});