
const cartable_toggle_field_if_value = function(target_id){
    var has_to_show = false;
    var target_field = CRM.$('#'+target_id+', [data-api-field='+target_id+']');
    var target_field_wrapper = CRM.$('#editrow-'+target_id+', .'+target_id+'-row, .custom_field-row[class*=" '+target_id+'_"]');
    if(typeof cartable.DonneesParticuliers.hide_if_not[target_id] !== undefined){
        var src_fields = cartable.DonneesParticuliers.hide_if_not[target_id];
        for(var src_id in src_fields){
            var src_field = CRM.$('#'+src_id+', [data-api-field='+src_id+']');
            if(src_fields[src_id].indexOf(src_field.val())>-1){
                has_to_show = true;
                break;
            }
        }
    }
    if(has_to_show){
        target_field_wrapper.show();
    }
    else{
        target_field_wrapper.hide();
        target_field.val('').trigger('change');
    }
    if(typeof cartable.DonneesParticuliers.filter_options[target_id] !== 'undefined'){
        var src_fields = cartable.DonneesParticuliers.filter_options[target_id];
        var available_values = ['<option>--</option>'];
        for(var src_id in src_fields){
            var src_field = CRM.$('#'+src_id+', [data-api-field='+src_id+']');
            if(typeof src_fields[src_id][src_field.val()] !== undefined){
                for(v in src_fields[src_id][src_field.val()]){
                    available_values.push('<option value="'+v+'">'+src_fields[src_id][src_field.val()][v]+'</option>');
                }
            }
        }
        target_field.val('').html(available_values);
        if(target_field.attr('data-initial-value') !== 'undefined' && target_field.attr('data-initial-value') !== ''){
            target_field.val(target_field.attr('data-initial-value'));
            // target_field.removeAttr('data-initial-value');
        }
        target_field.trigger('change');
    }
};

const cartable_check_toggle_field = function () {

    var options = CRM.$(this).find('option');
    if (options.length === 2) {
        var selectedValue = options[1].value;
        CRM.$(this).val(selectedValue).trigger('change');
    }

    var fields_to_hide = (CRM.$(this).attr('data-fields-to-hide')).split('|');
    for(var target_id in fields_to_hide){
        if(fields_to_hide[target_id] !== 'undefined'){
            cartable_toggle_field_if_value(fields_to_hide[target_id]);
        }
    }
};

const cartable_check_required = function(){
    var required_count = 0;
    var required = [];
    CRM.$('.form-item label .crm-marker').each(function(){
        var item = CRM.$(this).parents('.form-item');
        if (CRM.$('input[type=radio]', item).length){
            item.addClass('required');
        }
    });
    CRM.$('input.required, select.required, textarea.required', CRM.$('.custom_pre_profile-group')).each(function(){
        if(CRM.$(this).val() == ''){
            required_count++;
            required.push(CRM.$(this));
        }
    })
    // Checkup checkboxes
    if (CRM.$('#editrow-' + cartable.Syndicates.AcceptRulesOfProcedureField).length) {
        if (!CRM.$('#editrow-' + cartable.Syndicates.AcceptRulesOfProcedureField + ' input[type=checkbox]').is(':checked')) {
            required_count++;
            required.push(CRM.$(this));
        }
    }
    // Checkup boolean radio buttons
    if (CRM.$('.form-item.required').length){
        var list = CRM.$('.form-item.required').toArray();
        for(l in list){
            var item = CRM.$(list[l]);
            if (CRM.$('input[type=radio]:checked', item).length == 0) {
                required_count++;
                required.push(CRM.$(this));
            }
        }
    }
    if(required_count){
        CRM.$('#cartable-tab-step-3 .front-tabs-link.next').hide();
        return required;
    }
    else{
        CRM.$('#cartable-tab-step-3 .front-tabs-link.next').show();
        return true;
    }
}

jQuery(document).ready(function(){
    if(typeof cartable.DonneesParticuliers.hide_if_not !== undefined){
        for(var target_id in cartable.DonneesParticuliers.hide_if_not){
            var target = CRM.$('#'+target_id+', [data-api-field='+target_id+']');
            target.attr('data-initial-value', target.val());
            var src_fields = cartable.DonneesParticuliers.hide_if_not[target_id];
            for(var src_id in src_fields){
                var src_field = CRM.$('#'+src_id+', [data-api-field='+src_id+']');
                src_field.attr('data-fields-to-hide', src_field.attr('data-fields-to-hide')+'|'+target_id)
                .on('change', cartable_check_toggle_field).trigger('change');
            }
        }
    }

    CRM.$('.helprow-post').each(function(){
        CRM.$(this).appendTo(CRM.$(this).prev('div').addClass('has-help has-help-post'));
    });
    CRM.$('.helprow-pre').each(function(){
        CRM.$(this).prependTo(CRM.$(this).next('div').addClass('has-help has-help-pre'));
    });
    CRM.$('input, select, textarea', CRM.$('.crm-public-form-item')).on('focus', function(){
        CRM.$(this).parents('div.form-item').addClass('form-item-focus');
    }).on('blur', function(){
        CRM.$(this).parents('div.form-item').removeClass('form-item-focus');
    }).on('keyup change', function(){
        cartable_check_required();
    });

    cartable_check_required();
});
