var is_cartable_working = 0;
// Membership Type
const cartable_create_membershiptype = function (params) {
    CRM.alert('Génération en cours', 'Information', 'info');
    CRM.api3('MembershipType', 'create', params).then(function(result) {
        result.values.forEach( (mt)=>{
            var row = CRM.$('#cartable-syndicates tr#syndicate-'+mt.member_of_contact_id);
            var mtl = CRM.$('<a>')
                            .attr('href', CRM.url('civicrm/admin/member/membershipType/add', {
                                action: "update",
                                id: mt.id,
                                reset: 1,
                            }))
                            .text(mt.name)
            CRM.$('td.membershiptype', row).append(mtl);
            CRM.$('input[type=checkbox]', row).removeProp('checked').prop('disabled', 'disabled');
        });
        CRM.alert('Type(s) d’adhésion générée(s)', 'Succès', 'success');
        setTimeout(function() {
            location.reload();
        }, 10);
        is_cartable_working--;
    }, function(error) {
        // oops
        CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
        is_cartable_working--;
    });
}
//Campaign
const cartable_create_campaign = function (campaign, syndicate) {
    CRM.alert('Génération en cours', 'Information', 'info');
    CRM.api3('Campaign', 'create', campaign).then(function (result) {
        const campaignId = result.id;
        const campaignName = result.values[result.id].title;
        const campaignGroup = 'campaign_pages';
        CRM.api3('OptionValue', 'create', {
            option_group_id: campaignGroup,
            name: campaignName,
            label: campaignName,
            value: campaignId,
            is_active: 1
        }).then(function (result) {
            CRM.api4('Contact', 'update', {
                values: { "DonneesSyndicat.CampaignPage": campaignId },
                where: [["id", "=", syndicate], ["contact_type", "=", "Organization"], ["contact_sub_type", "=", "SyndicatSUD"]]
            }).then(function (results) {
                results.forEach(function (result) {
                    var row = CRM.$('#cartable-syndicates tr#syndicate-' + syndicate);
                    var campaignLink = CRM.$('<a>')
                        .attr('href', CRM.url('civicrm/campaign/add', {
                            action: "update",
                            id: campaignId,
                            reset: 1,
                        }))
                        .text(campaignName);
                    var campaign = CRM.$('<td>')
                    .addClass('campaign')
                    .append(campaignLink);
                CRM.$('td.campaign', row).replaceWith(campaign);
                }); 
                
                CRM.alert('Campagne(s) générée(s)', 'Succès', 'success');
                setTimeout(function() {
                    location.reload();
                }, 10);
                is_cartable_working--;
            }, function (error) {
                // oops
                CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                is_cartable_working--;
            });
        }, function (error) {
            // oops
            CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
            is_cartable_working--;
        });
    }, function (error) {
        // oops
        CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
        is_cartable_working--;
    });
}
//Manager Group
const cartable_create_manager_group = function (group, syndicate) {
    CRM.alert('Génération en cours', 'Information', 'info');
    CRM.api4('Group', 'create', {
        values: group
    }).then(function (result) {
        const groupId = result[0].id;
        const groupName = result[0].title;
        const managerGroup = 'manager_group';
        CRM.api3('OptionValue', 'create', {
            option_group_id: managerGroup,
            name: groupName,
            label: groupName,
            value: groupId,
            is_active: 1
        }).then(function (result) {
            CRM.api4('Contact', 'update', {
                values: { "DonneesSyndicat.ManagerGroup": groupId },
                where: [["id", "=", syndicate], ["contact_type", "=", "Organization"], ["contact_sub_type", "=", "SyndicatSUD"]]
            }).then(function (results) {
                results.forEach(function (result) {
                    var managerGroupName = groupName;
                    var managerGroupId = groupId;
                    var row = CRM.$('#cartable-syndicates tr#syndicate-' + syndicate);
                    var groupLink = CRM.$('<a>')
                        .attr('href', CRM.url('civicrm/group', {
                            action: "update",
                            id: managerGroupId,
                            reset: 1,
                        }))
                        .text(managerGroupName);
                    var managerTd = CRM.$('<td>')
                        .addClass('manager-of')
                        .append(groupLink);
                    CRM.$('td.manager-of', row).replaceWith(managerTd);
                });

                CRM.alert('Groupe(s) gestionnaires  généré(s)', 'Succès', 'success');
                setTimeout(function() {
                    location.reload();
                }, 10);
                is_cartable_working--;
            }, function (error) {
                // oops
                CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                is_cartable_working--;
            });
        }, function (error) {
            // oops
            CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
            is_cartable_working--;
        });
    }, function (error) {
        // oops
        CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
        is_cartable_working--;
    });
}
// Sepa Creditor
const cartable_create_sepaCreditor = function (sepaCreditor, syndicate) {
    CRM.alert('Génération en cours', 'Information', 'info');
    CRM.api4('SepaCreditor', 'create', {
        values: sepaCreditor 
    }).then(function(results) {
        results.forEach(function (result) {
            var name = result.name;
            var row = CRM.$('#cartable-syndicates tr#syndicate-' + syndicate);
            var creditorLink = CRM.$('<a>')
                .attr('href', CRM.url('civicrm/admin/setting/sepa'))
                .text(name);
            var creditorTd = CRM.$('<td>')
                .addClass('sepacreditor')
                .append(creditorLink);
            
            CRM.$('td.sepacreditor', row).replaceWith(creditorTd);
        });
        CRM.alert('Créancier(s) SEPA  généré(s)', 'Succès', 'success');
        setTimeout(function() {
            location.reload();
        }, 10);
        is_cartable_working--;
    }, function (error) {
        // oops
        CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
        is_cartable_working--;
    });
}
// Payment Processor
const cartable_create_paymentProcessor = function (paymentProcessor, paymentProcessorTest, syndicate, paymentProcessorSystemPayId, paymentProcessorNationalId, paymentbyChq, paymentProcessorLocal) {
    CRM.alert('Génération en cours', 'Information', 'info');
    CRM.api4('PaymentProcessor', 'create', {
        values: paymentProcessor 
    }).then(function (results) {
        const paymentProcessorId = results[0].id;
        const paymentProcessorName = results[0].name;
        var settingName = 'pp' + paymentProcessorId;
        var settingData = {};
        settingData[settingName] = results[0].user_name;
        CRM.api3('Setting', 'create',
            settingData
        ).then(function (results) {
            CRM.api4('PaymentProcessor', 'get', {
                select: ["id"],
                where: [["title", "=", "CB SystemPay National"]]
            }).then(function(paymentProcessors) {
                // do something with paymentProcessors array
            }, function (error) {
                // oops
                CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                is_cartable_working--;
            });

            var donneeSyndicateProcessorId = (paymentProcessorLocal ? paymentProcessorId : '') + (paymentProcessorSystemPayId !=='' ? (',' + paymentProcessorSystemPayId) : '') + (paymentProcessorNationalId !== '' ? (',' + paymentProcessorNationalId) : '') + (paymentbyChq !== '' ? (',' + paymentbyChq + ',0') : '');
            CRM.api4('Contact', 'update', {
                values: { "DonneesSyndicat.PaymentProcessors": donneeSyndicateProcessorId },
                where: [["id", "=", syndicate], ["contact_type", "=", "Organization"], ["contact_sub_type", "=", "SyndicatSUD"]]
            }).then(function (results) {
                results.forEach(function (result) {
                    var name = paymentProcessorName;
                    var row = CRM.$('#cartable-syndicates tr#syndicate-' + syndicate);
                    var paymentProcessorLink = CRM.$('<a>')
                        .attr('href', CRM.url('civicrm/admin/paymentProcessor/edit', {
                            action: "update",
                            id: paymentProcessorId,
                            reset: 1,
                        }))
                        .text(name);
                    var paymentProcessorTd = CRM.$('<td>')
                        .addClass('paymentprocessor')
                        .append(paymentProcessorLink);
                    
                    CRM.$('td.paymentprocessor', row).replaceWith(paymentProcessorTd);
                });
                CRM.api4('PaymentProcessor', 'create', {
                    values: paymentProcessorTest 
                }).then(function (results) {
                    var settingName = 'pp_test' + paymentProcessorId;
                    var settingData = {};
                    settingData[settingName] = results[0].user_name;
                    CRM.api3('Setting', 'create',
                        settingData
                    ).then(function (results) {
                        CRM.alert('Passerelle(s) de paiement  générée(s)', 'Succès', 'success');
                        setTimeout(function() {
                            location.reload();
                        }, 10);
                        is_cartable_working--;
                    }, function (error) {
                        // oops
                        CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                        is_cartable_working--;
                    });
                }, function (error) {
                    // oops
                    CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                    is_cartable_working--;
                });
            }, function (error) {
                // oops
                CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                is_cartable_working--;
            });
        }, function (error) {
            // oops
            CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
            is_cartable_working--;
        });     
        is_cartable_working--;
    }, function (error) {
        // oops
        CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
        is_cartable_working--;
    });
}
//Adh & Don
const cartable_create_adh_don_page = function (pageData, syndicate, adh, don, adhPageMember, adhParams) {
    CRM.alert('Génération en cours', 'Information', 'info');
    //create contribution page
    CRM.api4('ContributionPage', 'create', {
        values: pageData
    }).then(function (results) {
        const contributionPageId = results[0].id;
        const contributionPageName = results[0].title;
        const contributionPageGroup = 'contribution_page_options';
        //create membership block
        adhPageMember.entity_id = results[0].id
        CRM.api4('MembershipBlock', 'create', {
            values: adhPageMember
        }).then(function (results) {
            //Adh Params
            CRM.api4('Contact', 'update', {
                values: adhParams,
                where: [["id", "=", syndicate], ["contact_type", "=", "Organization"], ["contact_sub_type", "=", "SyndicatSUD"]]
            }).then(function(results) {
                // do something with results array
            }, function(failure) {
                // handle failure
            });
            if (adh) {
                 //UFJoin (Profil)
                CRM.api4('UFJoin', 'create', {
                    values: {"is_active":true, "module":"CiviContribute", "entity_table":"civicrm_contribution_page", "entity_id":contributionPageId, "weight":1, "uf_group_id:label":"Vos informations d'inscription", "uf_group_id:name":"event_registration"}}).then(function(results) {
                        // do something with results array
                }, function(failure) {
                // handle failure
                });
            }
            if (don) {
                 //UFJoin (Profil)
                 CRM.api4('UFJoin', 'create', {
                    values: {"is_active":true, "module":"CiviContribute", "entity_table":"civicrm_contribution_page", "entity_id":contributionPageId, "weight":1, "uf_group_id:label":"Vos informations (don)", "uf_group_id:name":"event_registration"}}).then(function(results) {
                        // do something with results array
                }, function(failure) {
                // handle failure
                });
            }
            //Group and option
            CRM.api3('OptionValue', 'create', {
                option_group_id: contributionPageGroup,
                name: contributionPageName,
                label: contributionPageName,
                value: contributionPageId,
                is_active: 1,
                is_reserved: 1
            }).then(function (result) {
                var typePage = "";
                var typeClass = "";
                if (adh) {
                    typePage = "DonneesSyndicat.MembershipPage";
                    typeClass = "adhpage";
                } else if (don) {
                    typePage = "DonneesSyndicat.DonationPage";
                    typeClass = "donpage";
                }
                const updateValues = {};
                updateValues[typePage] = contributionPageId;
                //update fied ContributionPage or MembershipPage on Contact 
                CRM.api4('Contact', 'update', {
                    values: updateValues,
                    where: [["id", "=", syndicate], ["contact_type", "=", "Organization"], ["contact_sub_type", "=", "SyndicatSUD"]]
                }).then(function (results) {
                    if (don) {
                        //Price Set
                        CRM.api4('FinancialType', 'get', {
                            select: ["id"],
                            where: [["name", "=", "don"]],
                        }).then(function (financialTypes) {
                            const financialTypeDonId = financialTypes[0]['id'];
                            var label = contributionPageName.toLowerCase().normalize('NFD').replace(/[\u0300-\u036f]/g, '').replace(/\s+/g, '_');
                            CRM.api4('PriceSet', 'create', {
                                values: {
                                    "title": contributionPageName,
                                    "name": label,
                                    "is_active": true,
                                    "financial_type_id": financialTypeDonId,
                                    "extends:label": ["Contribution"],
                                    "is_quick_config": true,
                                    "is_reserved": false
                                }
                            }).then(function (results) {
                                var priceSetId = results[0]['id'];
                                //Price Set Entity
                                CRM.api4('PriceSetEntity', 'create', {
                                    values: {
                                        "entity_table": "civicrm_contribution_page",
                                        "entity_id": contributionPageId,
                                        "price_set_id": priceSetId
                                    }
                                  }).then(function(results) {
                                    // do something with results array
                                  }, function(failure) {
                                    // handle failure
                                  });
                                //Price field
                                console.log(priceSetId)
                                CRM.api4('PriceField', 'create', {
                                    values: {
                                        "price_set_id": priceSetId,
                                        "label": "Je donne",
                                        "name": "contribution_amount",
                                        "html_type": "Radio",
                                        "is_enter_qty": false,
                                        "is_display_amounts": true,
                                        "is_active": true,
                                        "is_required": false,
                                        "visibility_id": 1,
                                        "custom": null,
                                        "check_permissions": null
                                    }
                                  }).then(function(results) {
                                      //Price field value
                                      var pricefielId = results[0]['id'];
                                      var PriceFieldValueName = contributionPageName.toLowerCase().normalize('NFD').replace(/[\u0300-\u036f]/g, '').replace(/\s+/g, '_');
                                      CRM.api4('PriceFieldValue', 'create', {
                                          values: {
                                            "price_field_id": pricefielId,
                                            "name": PriceFieldValueName + '_10',
                                            "label": " ",
                                            "amount": 10,
                                            "weight": 1,
                                            "is_default": false,
                                            "is_active": true,
                                            "visibility_id": 1,
                                            "financial_type_id": financialTypeDonId,
                                          }
                                      }).then(function(results) {
                                        // do something with results array
                                      }, function(failure) {
                                        // handle failure
                                      });
                                      CRM.api4('PriceFieldValue', 'create', {
                                        values: {
                                            "price_field_id": pricefielId,
                                            "name": PriceFieldValueName + '_20',
                                            "label": " ",
                                            "amount": 20,
                                            "weight": 2,
                                            "is_default": false,
                                            "is_active": true,
                                            "visibility_id": 1,
                                            "financial_type_id": financialTypeDonId,
                                        }
                                    }).then(function(results) {
                                      // do something with results array
                                    }, function(failure) {
                                      // handle failure
                                    });
                                    CRM.api4('PriceFieldValue', 'create', {
                                        values: {
                                            "price_field_id": pricefielId,
                                            "name": PriceFieldValueName + '_50',
                                            "label":" ",
                                            "amount": 50,
                                            "weight": 3,
                                            "is_default": false,
                                            "is_active": true,
                                            "visibility_id": 1,
                                            "financial_type_id": financialTypeDonId,
                                        }
                                    }).then(function(results) {
                                        //refresh front data
                                        results.forEach(function (result) {
                                            var row = CRM.$('#cartable-syndicates tr#syndicate-' + syndicate);
                                            var contributionPageLink = CRM.$('<a>')
                                                .attr('href', CRM.url('civicrm/admin/contribute/settings', {
                                                    action: "update",
                                                    id: contributionPageId,
                                                    reset: 1,
                                                }))
                                                .text(contributionPageName);
                                            var contributionPage = CRM.$('<td>')
                                            .addClass(typeClass)
                                            .append(contributionPageLink);
                                        CRM.$('td.' + typeClass, row).replaceWith(contributionPage);
                                        }); 
                                        CRM.alert('Page(s) d\'ahésion/de don générée(s)', 'Succès', 'success');
                                        setTimeout(function() {
                                            location.reload();
                                        }, 10);
                                        is_cartable_working--;
                                    }, function(failure) {
                                      // handle failure
                                    });
                                    
                                  }, function(failure) {
                                    // handle failure
                                  });
                            }, function(failure) {
                                // handle failure
                            });
                          }, function(failure) {
                            // handle failure
                          });
                    }
                }, function (error) {
                    // oops
                    CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                    is_cartable_working--;
                });
            }, function (error) {
                // oops
                CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
                is_cartable_working--;
            });
        }, function(failure) {
            // handle failure
            CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
        });
        
    }, function (error) {
        // oops
        CRM.alert('Une erreur s\'est produite.', 'Erreur', 'error');
        is_cartable_working--;
    });
}
//Add Manager or Team
const cartable_add_manager = function (syndicate, groupContact, contact_id_a, manager, team) {
    CRM.alert('Génération en cours', 'Information', 'info');
    CRM.api4('GroupContact', 'create', {
        values: groupContact
    }).then(function (results) {
        var name_a_b = "";
        if (manager) {
            name_a_b = "SUD_Gestionnaire"
        } else if (team) {
            name_a_b = "SUD_Equipiere_De"
        }
        CRM.api4('RelationshipType', 'get', {
            where: [["name_a_b", "=", name_a_b]]
        }).then(function(relationshipTypes) {
            var relationType = relationshipTypes[0]['id']
            var relation = {
                "contact_id_a": contact_id_a,
                "contact_id_b": syndicate,
                "relationship_type_id": relationType,
                "is_active": true,
                "is_permission_a_b": 1,
                "is_permission_b_a": 0,
            }
            CRM.api4('Relationship', 'create', {
                values: relation
            }).then(function (results) {
                CRM.api4('RelationshipType', 'get', {
                    select: ["id"],
                    where: [["name_a_b", "=", "SUD_Membre_De"]]
                }).then(function (relationshipTypes) {
                    var relationMemberOf = relationshipTypes[0]['id']
                    CRM.api4('Relationship', 'get', {
                        where: [["contact_id_a", "=", contact_id_a], ["contact_id_b", "=", syndicate], ["relationship_type_id", "=", relationMemberOf]]
                      }).then(function(relationships) {
                            if (relationships.length === 0) {
                                var relationMember = {
                                    "contact_id_a": contact_id_a,
                                    "contact_id_b": syndicate,
                                    "relationship_type_id": relationMemberOf,
                                    "is_active": true,
                                    "is_permission_a_b": 0,
                                    "is_permission_b_a": 1,
                                }
                                CRM.api4('Relationship', 'create', {
                                    values: relationMember
                                }).then(function (results) {
                                }, function(failure) {
                                    // handle failure
                                });
                            }
                      }, function(failure) {
                        // handle failure
                      });
                }, function(failure) {
                    // handle failure
                });
                var message = "";
                if (manager) {
                    message = 'Gestionnaires Ajouté' 
                } else if (team) {
                    message = 'Equipier Ajouté'
                }
                CRM.alert(message, 'Succès', 'success');
            // do something with results array
            }, function(failure) {
            });
        }, function(failure) {
        });
    }, function (error) {
        // oops
    }); 
}

const cartable_update_raw_status = function(){
    CRM.$('#cartable-syndicates tr input[type=checkbox]').each(function () {
        if (CRM.$(this).is(':checked')) {
            CRM.$(this).closest('tr').addClass('selected');
        }
        else {
            CRM.$(this).closest('tr').removeClass('selected');
        }
    });

}

CRM.$(document).ready(function () {
    cartable_update_raw_status();
    CRM.$('#cartable-syndicates tr input[type=checkbox]').on('click', cartable_update_raw_status);

    CRM.$('#cartable-generator-tools').createTabs({
        children: '.crm-form-block',
        childrenTitle: 'h2',
    });

    //Membership Type
    CRM.$('#cartable-generate-membership-type').on('click', function () {
        if (is_cartable_working) {
            return;
        }
        CRM.$('#cartable-syndicates tr').each(function(){
            if(CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')){
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];
                CRM.api4('RelationshipType', 'get', {
                    select: ["id"],
                    where: [["label_a_b", "=", "Membre de"]]
                }).then(function (relationshipTypes) {
                    var relationId = relationshipTypes[0]['id']
                    var membershipTypeData = {
                        "sequential": 1,
                        "visibility": "Public",
                        "member_of_contact_id": syndicate.id,
                        "financial_type_id": CRM.$('#financial_type_id').val(),
                        "duration_unit": CRM.$('#duration_unit').val(),
                        "duration_interval": CRM.$('#duration_interval').val(),
                        "period_type": CRM.$('#period_type').val(),
                        "name": syndicate.display_name,
                        "auto_renew": 1,
                        "fixed_period_start_day": 901, //1sept
                        "fixed_period_rollover_day": 630, //30juin
                        "relationship_type_id": relationId, //relation membre de
                        "relationship_direction": ["a_b"],
                    }
                    cartable_create_membershiptype(membershipTypeData);
                }, function(failure) {
                    // handle failure
                });

               
            }
        });
    });
    //Campaign
    CRM.$('#cartable-generate-campaign').on('click', function () {
        if (is_cartable_working) {
            return;
        }
        CRM.$('#cartable-syndicates tr').each(function () {
            if (CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')) {
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];

                var campaignData = {
                    "title": syndicate.display_name,
                    "campaign_type_id": CRM.$('#campaign_type_id').val(),
                    "status_id": CRM.$('#campaign_status_id').val(),
                    "start_date": CRM.$('#campaign_start_date').val(),
                    "is_active": CRM.$('#campaign_is_active').is(':checked')
                }
                cartable_create_campaign(campaignData, syndicate.id);
            }
        });
    });
     //Member
     CRM.$('#cartable-generate-member-group').on('click', function () {
        if (is_cartable_working) {
            return;
        }
        CRM.$('#cartable-syndicates tr').each(function () {
            if (CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')) {
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];

                var membergroupData = {
                }
                cartable_create_member_group(membergroupData);
            }
        });
    });
    //Manager
    CRM.$('#cartable-generate-manager-group').on('click', function () {
        if (is_cartable_working) {
            return;
        }
        CRM.$('#cartable-syndicates tr').each(function () {
            if (CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')) {
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];
                var selectedValues = CRM.$('#manager_group_type').val();
                var managerGroupName = 'Gestionnaires ' + syndicate.display_name;
                var managerParentId = CRM.$('#manager_group_parent').val();

                var managergroupData = {
                    "title": managerGroupName,
                    "description": managerGroupName,
                    "is_active": CRM.$('#manager_group_is_active').is(':checked'), 
                    "visibility": CRM.$('#manager_group_visibility').val(), 
                    "parents": [managerParentId], 
                    "frontend_title": managerGroupName, 
                    "is_reserved": CRM.$('#manager_group_is_reserved').is(':checked'), 
                    "group_type:label": selectedValues,
                }
                cartable_create_manager_group(managergroupData, syndicate.id);
            }
        });
    });
    //SepaCreditor
    CRM.$('#cartable-generate-sepacreditor').on('click', function () {
        if (is_cartable_working) {
            return;
        }

        CRM.$('#cartable-syndicates tr').each(function () {
            if (CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')) {
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];
                var sepaCreditorData = {
                    "name": syndicate.display_name,
                    "label": syndicate.display_name,
                    "country_id.name": "France",
                    "currency": "EUR", 
                    "mandate_prefix": "SEPA", 
                    "mandate_active": CRM.$('#sepacreditor_mandate_active').is(':checked'), 
                    "sepa_file_format_id:name": CRM.$('#sepacreditor_sepa_file_format_id_name').val(),
                    "pi_ooff": 9,
                    "pi_rcur": "7-8",
                    "uses_bic": CRM.$('#sepacreditor_uses_bic').is(':checked'),
                    "creditor_type": "SEPA",
                    "creditor_id": syndicate.id,
                }
                CRM.api4('Contact', 'get', {
                    select: ["id", "address.street_address", "address.street_number", "address.postal_code", "address.city", "DonneesSyndicat.IBAN", "DonneesSyndicat.BIC", "DonneesSyndicat.ICS"],
                    join: [["Address AS address", "LEFT"]],
                    where: [["contact_sub_type", "=", "SyndicatSUD"]]
                  }).then(function(contacts) {
                      contacts.forEach(function (contact) {
                          if (contact.id == syndicate.id) {
                            if (contact['DonneesSyndicat.IBAN']) {
                                sepaCreditorData.iban = contact['DonneesSyndicat.IBAN'];
                            }
                            if (contact['DonneesSyndicat.BIC']) {
                                sepaCreditorData.bic = contact['DonneesSyndicat.BIC'];
                            }
                            if (contact['DonneesSyndicat.ICS']) {
                                sepaCreditorData.identifier = contact['DonneesSyndicat.ICS'];
                            }
                            var address = '';
                            if (contact['address.street_number']) {
                                address += contact['address.street_number'] + ' ';
                            }
                            if (contact['address.street_address']) {
                                address += contact['address.street_address'] + ', ';
                            }
                            if (contact['address.postal_code'] && contact['address.city']) {
                                address += contact['address.postal_code'] + ' ' + contact['address.city'];
                            }
                            sepaCreditorData.address = address;
                        }
                    });
                    if (sepaCreditorData) {
                        cartable_create_sepaCreditor(sepaCreditorData, syndicate.id);
                    }
                  }, function(failure) {
                    // handle failure
                  });
            }
        });
    });
    //Payment Processor
    CRM.$('#cartable-generate-payment-processor').on('click', function () {
        if (is_cartable_working) {
            return;
        }
        CRM.$('#cartable-syndicates tr').each(function () {
            if (CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')) {
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];
                var syndicateName = syndicate.display_name;
                var syndicatTerms = syndicateName.split(" ");
                var syndicateAbbr = syndicatTerms.slice(2).join(" ");
                var paymentProcessorTitle = "Prélèvement bancaire (" + syndicateAbbr + ")";

                var creditorId = CRM.$("input[name='sepaCreditor-" + syndicate.id + "']").val();
               
                var paymentProcessorSystemPayId = '';
                var paymentProcessorNationalId = '';
                var paymentbyChq = '';
                var paymentProcessorLocal = false;
                var paymentProcessorChoice = CRM.$('#payment_processor_choice').val();

                if (paymentProcessorChoice.includes('processor_systempay')) {
                    paymentProcessorSystemPayId = CRM.$("input[name='paymentProcessorSystemPayId']").val();
                }
                if (paymentProcessorChoice.includes('processor_national')) {
                    paymentProcessorNationalId = CRM.$("input[name='paymentProcessorNationalId']").val();
                }
                if (paymentProcessorChoice.includes('processor_cheque')) {
                    paymentbyChq = 'Chèque';
                }
                if (paymentProcessorChoice.includes('processor_syndicate')) {
                    paymentProcessorLocal = true;
                }

                var is_active = CRM.$('#payment_processor_is_active').is(':checked');
                if (is_active !== false && paymentProcessorLocal) {
                    is_active = true
                }

                var paymentProcessorData = {
                    "payment_processor_type_id.name": "SEPA_Direct_Debit_NG",
                    "name": paymentProcessorTitle,
                    "title": paymentProcessorTitle,
                    "financial_account_id.name": CRM.$('#payment_processor_financial_account_id_name').val(),
                    "is_active": is_active,
                    "is_default": CRM.$('#payment_processor_is_default').is(':checked'),
                    "is_test": false,
                    "user_name": creditorId
                }
                var paymentProcessorTestData = {
                    "payment_processor_type_id.name": "SEPA_Direct_Debit_NG",
                    "name": paymentProcessorTitle,
                    "title": paymentProcessorTitle,
                    "financial_account_id.name": CRM.$('#payment_processor_financial_account_id_name').val(),
                    "is_active": CRM.$('#payment_processor_is_active').is(':checked'),
                    "is_default": CRM.$('#payment_processor_is_default').is(':checked'),
                    "is_test": true,
                    "user_name": 2 //national
                }
                cartable_create_paymentProcessor(paymentProcessorData, paymentProcessorTestData, syndicate.id, paymentProcessorSystemPayId, paymentProcessorNationalId, paymentbyChq, paymentProcessorLocal);
            }
        });
    });
     //Adh et Don Page
     CRM.$('#cartable-generate-adh-page, #cartable-generate-don-page').on('click', function () {
        if (is_cartable_working) {
            return;
        }
         var adh = false;
         var don = false;
        if (this.id === 'cartable-generate-adh-page') {
            adh = true;
        } else if (this.id === 'cartable-generate-don-page') {
            don = true;
        }
         CRM.$('#cartable-syndicates tr').each(function () {
             if (CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')) {
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];
                 
                var adhPageName = "";
                var donVsAdh = "";
                var financial_type_id = "";
                var syndicateAddress = '';
                if (adh) {
                    donVsAdh = "adh";
                    adhPageName = 'Adh - ' + syndicate.display_name;
                    financial_type_id = 2; // cotisation des membres
                } else if (don) {
                    donVsAdh = 'don'
                    adhPageName = 'Don - ' + syndicate.display_name;
                    financial_type_id = 1; //don
                }
                var isRecur = CRM.$('#' + donVsAdh + '-page_is_recur').is(':checked');
                var selectedValues = CRM.$('#' + donVsAdh + '-page_recur_frequency_unit').val();
                var selectedParams = CRM.$('#adh-page_params_frequency').val();
                var isConfirmEnabled = CRM.$('#' + donVsAdh + '-page_is_confirm_enabled').is(':checked');
                var isActivePage = CRM.$('#' + donVsAdh + '-page_is_active').is(':checked');
                var isPayLater = CRM.$('#' + donVsAdh + '-page_is_pay_later').is(':checked');
                var amountBlockIsActive = CRM.$('#' + donVsAdh + '-page_amount_block_is_active').is(':checked');
                 var isAllowOtherAmount = CRM.$('#' + donVsAdh + '-page_is_allow_other_amount').is(':checked');
                //payment processor 
                 var paymentProcessorFields = CRM.$("input[name='paymentProcessor-" + syndicate.id + "']");
                 var paymentProcessorIds = [];
                 if (paymentProcessorFields.length !== 0) {
                    paymentProcessorFields.each(function () {
                        var paymentProcessorId = CRM.$(this).val();
                        paymentProcessorIds.push(paymentProcessorId)
                    })
                 } else {
                    CRM.api4('PaymentProcessor', 'get', {
                        select: ["id"],
                        where: [["name", "=", "CB SystemPay National"]]
                    }).then(function (paymentProcessors) {
                        paymentProcessorIds.push(paymentProcessors[0]['id']);
                    }, function(failure) {
                        // handle failure
                    });
                 }
               
                //campaign
                var campaignId = CRM.$("input[name='campaign-" + syndicate.id + "']").val();

                //recur and frequencyUnit
                var frequencyUnit = [];
                var recur = false;
                if (isRecur || selectedValues) {
                    frequencyUnit = selectedValues !== null && selectedValues !== "" ? selectedValues : [];
                    recur = true;
                }
        
                CRM.api4('Contact', 'get', {
                    select: ["address_primary.city", "address_primary.postal_code", "address_primary.street_address", "address_primary.street_number"],
                    where: [["contact_sub_type", "=", "SyndicatSUD"], ["id", "=", syndicate.id]]
                }).then(function (contact) {
                    syndicateAddress = syndicate.display_name + ', ' + contact[0]['address_primary.street_address'] + ' ' + contact[0]['address_primary.postal_code'] + ' ' + contact[0]['address_primary.city'];
                    var payLaterReceipt = "Merci d'envoyer votre chèque au siège de votre syndicat. " + syndicateAddress;

                    var adhPageData = {
                        "title": adhPageName,
                        "financial_type_id": financial_type_id,
                        "campaign_id": campaignId,
                        "is_confirm_enabled": isConfirmEnabled,
                        "is_active": isActivePage,
                        "is_share": false,
                        "currency:name": "EUR",
                        "payment_processor": paymentProcessorIds,
                        "is_pay_later": isPayLater,
                        "pay_later_text": "Je paierai par chèque",
                        "pay_later_receipt": payLaterReceipt,
                        "amount_block_is_active": amountBlockIsActive,
                        "is_recur": recur,
                        "recur_frequency_unit": selectedValues,
                        "initial_amount_label": "Ma contribution",
                        "is_allow_other_amount": isAllowOtherAmount,
                    };

                    //params adh
                    var adhParams = {
                        "ParametresAdhesion.FrequencesPaiement": selectedParams,
                        "ParametresAdhesion.ContributionStartDay": 1,
                        "ParametresAdhesion.ContributionStartMonth": 9,
                        "ParametresAdhesion.ContributionEndDay": 30,
                        "ParametresAdhesion.ContributionEndMonth": 6,
                        "ParametresAdhesion.ProRata": 0
                    }

                    //membership type
                    var membershipTypeId = CRM.$("input[name='membershiptype-" + syndicate.id + "']").val();
                  
                    var display_min_fee = CRM.$('#' + donVsAdh + '-page_display_min_fee').is(':checked');
                    var isRequired = CRM.$('#' + donVsAdh + '-page_is_required').is(':checked');
                    var memberIsActive = CRM.$('#' + donVsAdh + '-page_member_is_active').is(':checked');
                    var PageMemberNewText = "";
                    var PageMemberRenewalTitle = "";
                    if (adh) {
                        PageMemberNewText = "Adhésion " + syndicate.display_name;
                        PageMemberRenewalTitle = "Réadhésion " + syndicate.display_name;
                    } else if (don) {
                        PageMemberNewText = "Don " + syndicate.display_name;
                        PageMemberRenewalTitle = "Don " + syndicate.display_name;
                    }

                    var adhPageMemberText = '<details><summary>D&eacute;duction d&rsquo;imp&ocirc;ts :</summary><p>La cotisation syndicale donne droit &agrave; une d&eacute;duction d&rsquo;imp&ocirc;ts &eacute;gale aux 2/3 de la somme.<br />Vous recevrez une attestation fiscale pour la d&eacute;claration de revenu annuelle uniquement sur les sommes effectivement per&ccedil;ues par le syndicat jusqu&rsquo;en d&eacute;cembre de l&rsquo;ann&eacute;e pr&eacute;c&eacute;dant la d&eacute;claration.</p></details><details><summary>Comment calculer mon salaire moyen net :</summary><p>Il s&rsquo;agit de votre salaire annuel net (l&rsquo;addition de votre salaire net mensuel avant imp&ocirc;ts sur le revenu indiqu&eacute; sur votre bulletin de salaire) divis&eacute; par 12. Par exemple, si vous avez touch&eacute; 23 184 euros net sur l&rsquo;ann&eacute;e en comptant vos heures suppl&eacute;mentaires et vos primes, votre salaire mensuel moyen net est de 1932 euros : vous pouvez donc s&eacute;lectionner &laquo; plus de 1900 euros &raquo; dans la liste.</p></details>';
                    var adhPageMemberData = {
                        "entity_table": "civicrm_contribution_page",
                        "membership_type_default": membershipTypeId,
                        "membership_types": {},
                        "display_min_fee": display_min_fee,
                        "new_title": PageMemberNewText,
                        "renewal_title": PageMemberRenewalTitle,
                        "new_text": adhPageMemberText,
                        "renewal_text": adhPageMemberText,
                        "is_required": isRequired,
                        "is_separate_payment": false,
                        "is_active": memberIsActive
                    }
                    //Right BDD syntax
                    adhPageMemberData.membership_types[membershipTypeId] = null;
                    cartable_create_adh_don_page(adhPageData, syndicate.id, adh, don, adhPageMemberData, adhParams);
                   
                }, function (failure) {
                    // handle failure
                });
            }
        });
     });
    //Add Manager and Team
    CRM.$('#cartable-generate-add-manager-for-syndicate , #cartable-generate-add-team-for-syndicate').on('click', function () {
        if (is_cartable_working) {
            return;
        }
        var manager = false;
         var team = false;
        if (this.id === 'cartable-generate-add-manager-for-syndicate') {
            manager = true;
        } else if (this.id === 'cartable-generate-add-team-for-syndicate') {
            team = true;
        }
        CRM.$('#cartable-syndicates tr').each(function () {
            if (CRM.$('input[type=checkbox]', CRM.$(this)).is(':checked')) {
                is_cartable_working++;
                var syndicate = syndicates[CRM.$(this).attr('data-id')];
                var groupSelect = "";
                var contacts_emails = "";
                if (manager) {
                    groupSelect = CRM.$('#add-manager-for-syndicate').val();
                    contacts_emails = CRM.$('#add-manager-contact-mail').val();
                } else if (team) {
                    groupSelect = CRM.$('#add-team-for-syndicate').val();
                    contacts_emails = CRM.$('#add-team-contact-mail').val();
                }
                if (contacts_emails.includes(",")) {
                    var contacts_emails_array = contacts_emails.split(",");
                    contacts_emails_array.forEach(function (email) {
                        CRM.api4('Email', 'get', {
                            select: ["id"],
                            where: [["email", "=", email], ["is_primary", "=", true]]
                        }).then(function (result) {
                            if (result.length > 0) {
                                var mail = result[0]['id']
                                CRM.api4('Contact', 'get', {
                                    select: ["id"],
                                    where: [["email_primary", "=", mail], ['contact_type', '=', 'Individual'],]
                                }).then(function (contacts) {
                                    var contact_id_a = contacts[0]['id'];
                                    var groupContact = {
                                        "group_id": groupSelect,
                                        "contact_id": contact_id_a,
                                        "status": "Added",
                                    };
                                    cartable_add_manager(syndicate.id, groupContact, contact_id_a, manager, team);
                                }, function (failure) {
                                    // handle failure
                                });
                            } else {
                                CRM.api4('Contact', 'create', {
                                    values: {"display_name": email}
                                }).then(function (results) {
                                    var contact_id = results[0]['id'];
                                    CRM.api4('Email', 'create', {
                                        values: { "contact_id": contact_id, "location_type_id:name": "Principal", "email": email, "is_billing": false }
                                    }).then(function (results) {
                                        var contact_id_a = contact_id;
                                        var groupContact = {
                                            "group_id": groupSelect,
                                            "contact_id": contact_id_a,
                                            "status": "Added"
                                        };
                                        cartable_add_manager(syndicate.id, groupContact, contact_id_a, manager, team);
                                    }).catch(function (failure) {
                                        // handle failure
                                    });
                                }).catch(function (failure) {
                                    // handle failure
                                });
                            }
                        }).catch(function (failure) {
                            // handle failure
                        });
                    })
                } else if (contacts_emails !== 0) {
                    CRM.api4('Email', 'get', {
                        select: ["id"],
                        where: [["email", "=", contacts_emails], ["is_primary", "=", true]]
                    }).then(function (result) {
                        if (result.length > 0) {
                            var mail = result[0]['id']
                            CRM.api4('Contact', 'get', {
                                select: ["id"],
                                where: [["email_primary", "=", mail], ['contact_type', '=', 'Individual'],]
                            }).then(function (contacts) {
                                var contact_id_a = contacts[0]['id'];
                                var groupContact = {
                                    "group_id": groupSelect,
                                    "contact_id": contact_id_a,
                                    "status": "Added",
                                };
                                cartable_add_manager(syndicate.id, groupContact, contact_id_a, manager, team);
                            }, function (failure) {
                                // handle failure
                            });
                        } else {
                            CRM.api4('Contact', 'create', {
                                values: {"display_name": contacts_emails}
                            }).then(function (results) {
                                var contact_id = results[0]['id'];
                                CRM.api4('Email', 'create', {
                                    values: { "contact_id": contact_id, "location_type_id:name": "Principal", "email": contacts_emails, "is_billing": false }
                                }).then(function (results) {
                                    var contact_id_a = contact_id;
                                    var groupContact = {
                                        "group_id": groupSelect,
                                        "contact_id": contact_id_a,
                                        "status": "Added"
                                    };
                                    cartable_add_manager(syndicate.id, groupContact, contact_id_a, manager, team);
                                }).catch(function (failure) {
                                    // handle failure
                                });
                            }).catch(function (failure) {
                                // handle failure
                            });
                        }
                    }).catch(function (failure) {
                        // handle failure
                    });
                }
            }
        });
    });
});
