CRM.$.fn.replaceWithTag = function (tagName) {
    var result = [];
    this.each(function () {
        var newElem = CRM.$('<' + tagName + '>').get(0);
        for (var i = 0; i < this.attributes.length; i++) {
            newElem.setAttribute(
                this.attributes[i].name, this.attributes[i].value
            );
        }
        newElem = CRM.$(this).wrapInner(newElem).children(0).unwrap().get(0);
        result.push(newElem);
    });
    return CRM.$(result);
};

var syndicate;
var membershipRates;
var Frequencies;
var GrilleSalarialeField;
var PaymentMethodField;

var initialGridValue;
var initialMethodValue;

var manuallyChangedAmount = false;

var pick_salary_grid = function(){
    if (CRM.$('#total_amount').val() == 0 || !manuallyChangedAmount){
        CRM.$('#total_amount').val(CRM.$(this).val().split('|')[1]);
    }
    initialGridValue = CRM.$(this).val();
};

var compute_GrilleSalarialeField = function(){
    CRM.$('[id^=' + GrilleSalarialeField + ']').replaceWithTag('select').html('<option value="">--</option>').on('change', pick_salary_grid);
    if (syndicate && typeof cartable.Syndicates.Syndicates[syndicate] != 'undefined' && typeof cartable.Syndicates.Syndicates[syndicate].MembershipRates != 'undefined' && Object.keys(cartable.Syndicates.Syndicates[syndicate].MembershipRates).length){
        membershipRates = cartable.Syndicates.Syndicates[syndicate].MembershipRates;
    }
    else{
        membershipRates = cartable.Membership.membershipRates;
    }
    for (var Salary in membershipRates) {
        CRM.$('[id^=' + GrilleSalarialeField + ']').append(
            CRM.$('<option>')
                .attr('value', syndicate + '|' + membershipRates[Salary])
                .text(Salary + ' - ' + CRM.formatMoney(membershipRates[Salary]))
        );
    }
    CRM.$('[id^=' + GrilleSalarialeField + ']').val(initialGridValue);
}

var pick_payment_method = function(){
    initialMethodValue = CRM.$(this).val();
};

var compute_PaymentMethodField = function(){
    CRM.$('[id^=' + PaymentMethodField + ']').replaceWithTag('select').html('<option value="">--</option>').on('change', pick_payment_method);
    var SyndicateFrequencies = Object.keys(Frequencies);
    if (syndicate && typeof cartable.Syndicates.Syndicates[syndicate] != 'undefined' && typeof cartable.Syndicates.Syndicates[syndicate].PaymentFrequency != 'undefined' && Object.keys(cartable.Syndicates.Syndicates[syndicate].PaymentFrequency).length) {
        SyndicateFrequencies = cartable.Syndicates.Syndicates[syndicate].PaymentFrequency;
    }
    SyndicateFrequencies.forEach(Frequency=>{
        CRM.$('[id^=' + PaymentMethodField + ']').append(
            CRM.$('<option>')
            .attr('value', Frequency)
            .text(Frequencies[Frequency].title)
        );
    });
    CRM.$('[id^=' + PaymentMethodField + ']').val(initialMethodValue);
};

var change_syndicate = function(){
    CRM.$('#customData').unbind('DOMSubtreeModified', change_syndicate);
    syndicate = CRM.$('#membership_type_id_0').val();
    if(GrilleSalarialeField){
        compute_GrilleSalarialeField();
    }
    if(PaymentMethodField){
        compute_PaymentMethodField();
    }
};


var init_membership_custom_datas = function(){
    if(typeof cartable.Membership != 'undefined'){
        Frequencies = cartable.Membership.FrequenciesData;
        PaymentMethodField = cartable.Membership.PaymentMethodField;
        GrilleSalarialeField = cartable.Membership.GrilleSalarialeField;
        initialGridValue = CRM.$('[id^=' + GrilleSalarialeField + ']').val();
        initialMethodValue = CRM.$('[id^=' + PaymentMethodField + ']').val();
        change_syndicate();
        CRM.$('#membership_type_id_0, #membership_type_id_1').on('change', function(){
            change_syndicate();
            CRM.$('#customData').bind('DOMSubtreeModified', change_syndicate);
        });
    }
    CRM.$('#total_amount').on('change', function(){
        if(CRM.$(this).val() != 0){
            manuallyChangedAmount = true;
        }
        else{
            manuallyChangedAmount = false;
        }
    });
};