var AnnualContributionAmount = 0;
var ToPayAmount = null;
var otherAmountField;
var GrilleSalarialeField;
var PaymentMethodField;
var membershipFieldWrapper;
var GrilleSalarialeFieldWrapper;
var PaymentMethodFieldWrapper;
var numberOfMonthsForContributionField;
var numberOfMonthsForContributionFieldWrapper;
var numberOfMonthsForProrataField;
var numberOfMonthsForProrataFieldWrapper;
var annualAmountForContributionField;
var annualAmountForContributionFieldWrapper;
var Syndicate;
var SyndicateId;
var membershipType;
var Frequency;
var Frequencies;
var FrequencySelector;
var MembershipStartDate;
var membershipEndDate;
var SalarySelect;
var SalaryGreaterOption;
var isProRata = false;
var isApportionment = false;

var MonthsToDispatchTo;
var TheoricalMonthAmount;

var MonthsToDispatchTo_Apportionment;
var ApportionmentMonthAmount;

var MonthsToDispatchTo_ProRata;
var ProrataMonthAmount;

var isReadyForHumans = false;


/**
 * Triggered when the user selects a custom salary amount
 * 
 * @returns void
 */
const cartable_pick_custom_salary = function(){
    try {
        var custom_salary = prompt(cartable.Membership.i18n.custom_salary);
        if (custom_salary && !isNaN(custom_salary)) {
            var membershipRatioToUse = (Syndicate.membershipRatio != null && Syndicate.membershipRatio != 0) ? Syndicate.membershipRatio : cartable.Membership.membershipRatio;
            AnnualContributionAmount = custom_salary * membershipRatioToUse / 100;
            SalaryGreaterOption.attr('value', AnnualContributionAmount).text(custom_salary+cartable.Membership.currency.symbol);
            SalarySelect.val(AnnualContributionAmount).select2().trigger('change');
        }
        else{
            alert(cartable.Membership.i18n.custom_salary_nan);
            SalarySelect.val("").select2().trigger('change');
        }
    }
    catch (err) {
        wp_reporting.log_error('cartable', err);
    }
}

/**
 * Calculates remaining months to dispatch to
 * 
 * @param int start_day 
 * @param int start_month 
 * @param int end_day 
 * @param int end_month 
 * @param int current_day 
 * @param int current_month 
 * 
 * @returns  Associative object
 */
const cartable_remaining_months = function (start_day, start_month, end_day, end_month, current_day, current_month){
    _MonthsToDispatchTo = 12;
    _MonthsToDispatchTo_Apportionment = 12;
    _MonthsToDispatchTo_ProRata = 12;
    try {
        var current_date = parseInt(current_month + '' + current_day);
        var startDate = parseInt(start_month + '' + start_day);
        var endDate = parseInt(end_month + '' + end_day); 
        if (startDate >= endDate) {
            var _MonthsToDispatchTo_Apportionment = 1 + 12 - (start_month - end_month);
            if (current_date >= startDate) {
                _MonthsToDispatchTo_ProRata = 12 - (current_month - end_month);
            }
            else if (current_date <= endDate) {
                _MonthsToDispatchTo_ProRata = end_month - current_month;
            }
            else {
                _MonthsToDispatchTo_ProRata = _MonthsToDispatchTo_Apportionment;
            }
            if (_MonthsToDispatchTo_ProRata === 0) {
                _MonthsToDispatchTo_ProRata = _MonthsToDispatchTo_Apportionment;
            }
        }
        else {
            var _MonthsToDispatchTo_Apportionment = end_month - start_month;
            if (current_date >= startDate) {
                _MonthsToDispatchTo_ProRata = end_month - current_month;
            }
            else {
                _MonthsToDispatchTo_ProRata = _MonthsToDispatchTo_Apportionment;
            }
            if (_MonthsToDispatchTo_ProRata <= 0 || _MonthsToDispatchTo > _MonthsToDispatchTo_Apportionment) {
                _MonthsToDispatchTo_ProRata = _MonthsToDispatchTo_Apportionment;
            }
        }
    }
    catch (err) {
        wp_reporting.log_error('cartable', err);
    }
    return {
        MonthsToDispatchTo: _MonthsToDispatchTo,
        MonthsToDispatchTo_ProRata: _MonthsToDispatchTo_ProRata,
        MonthsToDispatchTo_Apportionment: _MonthsToDispatchTo_Apportionment
    };
};

/**
 * Show/hides payment processors based on the selected frequency
 * 
 * @returns void
 */
const cartable_show_hide_payment_processors = function(){
    var PaymentProcessors_shown = {};
    CRM.$('.payment_processor-section input').each(function () {
        var payment_processor_id = parseInt(CRM.$(this).val());
        var payment_processor_is_sepa = (CRM.$(this).attr('class').indexOf('sepa') > -1);
        // Shows payment processors if...
        if (
            // Payment processors are selected in Syndicate configuration
            Syndicate.PaymentProcessors.indexOf(payment_processor_id) != -1
            &&
            (
                // Frequency is not set
                typeof Frequency == 'undefined'
                ||
                (
                    // Frequency is set and is not monthly
                    Frequency.unit != 'month'
                    ||
                    (
                        // Frequency is pro-rata and payment processor is SEPA
                        Frequency.is_prorata
                        &&
                        payment_processor_is_sepa
                    )
                    ||
                    (
                        // Frequency is not pro-rata and payment processor is not SEPA
                        !Frequency.is_prorata
                        &&
                        !payment_processor_is_sepa
                    )
                )
            )
        ) {
            CRM.$(this).show().removeProp('disabled').next('label').show();
            PaymentProcessors_shown[Syndicate.PaymentProcessors.indexOf(payment_processor_id)] = CRM.$(this);
        }
        else {
            CRM.$(this).hide().prop('disabled', 'disabled').removeProp('checked').trigger('change').next('label').hide();
        }
    });
    var PaymentProcessors_wrapper = CRM.$('.payment_processor-section .content');

    var firstIndex=null;
    for (var ppIndex in cartable.sortObject(PaymentProcessors_shown)) {
        if(firstIndex == null){
            firstIndex = ppIndex;
        }
        PaymentProcessors_wrapper.append(PaymentProcessors_shown[ppIndex].parents('.cartable-payment-processor-row'));
    }
    setTimeout(function(){
        PaymentProcessors_shown[firstIndex].prop('checked', true).trigger('change').trigger('keyup');
    }, 2000);
}

/**
 * Triggered when the user selects a salary amount
 * 
 * @param event event
 * 
 * @returns void
 */
const cartable_pick_membership_amount = function(event){
    var raw_contribution_amount = SalarySelect.val();
    if (raw_contribution_amount === '_FREE_'){
        SalarySelect.after(
            CRM.$('<a>')
                .on('click', cartable_pick_custom_salary)
                .attr('class', 'cartable-salary-greater-link')
                .text(cartable.Membership.i18n.another_salary)
        );
        cartable_pick_custom_salary();
        return;
    }

    AnnualContributionAmount = parseFloat(raw_contribution_amount);
    if (isNaN(AnnualContributionAmount)){
        CRM.$('.frequency-wrapper').hide(200);
    }
    else{
        CRM.$('.frequency-wrapper').show(200);
    }
    
    if(!initial_auto_select && GrilleSalarialeField){
        GrilleSalarialeField.val(SyndicateId+'|'+AnnualContributionAmount);
    }
    // Calculate effective months to be paid
    MonthsToDispatchTo_ProRata = MonthsToDispatchTo_Apportionment = MonthsToDispatchTo = 12;
    isProRata = Syndicate.ProRata;
    if (Syndicate.ContributionEndDay && Syndicate.ContributionEndMonth && Syndicate.ContributionStartDay && Syndicate.ContributionStartMonth){
        isApportionment = true;
        var currentMonth = CRM.utils.formatDate(new Date(), 'm');
        var currentDay = CRM.utils.formatDate(new Date(), 'dd');
        var ComputedDispatchedMonths = cartable_remaining_months(Syndicate.ContributionStartDay, Syndicate.ContributionStartMonth, Syndicate.ContributionEndDay, Syndicate.ContributionEndMonth, currentDay, currentMonth);
        MonthsToDispatchTo_Apportionment = ComputedDispatchedMonths.MonthsToDispatchTo_Apportionment;
        if (isProRata === true){
            MonthsToDispatchTo_ProRata = ComputedDispatchedMonths.MonthsToDispatchTo_ProRata;
        }
    }
    
    TheoricalMonthAmount = cartable.roundedAmountByMonths(MonthsToDispatchTo);
    ApportionmentMonthAmount = cartable.roundedAmountByMonths(MonthsToDispatchTo_Apportionment);
    ProrataMonthAmount = cartable.roundedAmountByMonths(MonthsToDispatchTo_ProRata);

    var ApportionmentMonthAmountProrata = isProRata ? ProrataMonthAmount : ApportionmentMonthAmount;
    var MonthsToDispatchTo_ApportionmentProrata = isProRata ? MonthsToDispatchTo_ProRata : MonthsToDispatchTo_Apportionment;

    var FrequencyControl = CRM.$('.cartable-membership-frequency-selector input[type=radio]:checked');
    var frequency_name = FrequencyControl.val();
    if(!initial_auto_select && PaymentMethodField){
        PaymentMethodField.val(frequency_name);
    }
    var AnnualTaxFreeAmount = cartable.fiscal_deducted(AnnualContributionAmount);

    var year = new Date().getFullYear();
    // Amounts
    CRM.$('.cartable-membership-frequency-selector .year-amount').text(cartable.amountForHumans(AnnualContributionAmount));
    CRM.$('.cartable-membership-frequency-selector .month-amount').text(cartable.amountForHumans(TheoricalMonthAmount));
    CRM.$('.cartable-membership-frequency-selector .month-apportionment-amount').text(cartable.amountForHumans(ApportionmentMonthAmountProrata));
    CRM.$('.cartable-membership-frequency-selector .theorical-month-amount').text(cartable.amountForHumans(TheoricalMonthAmount));
    CRM.$('.cartable-membership-frequency-selector .theorical-apportionment-month-amount').text(cartable.amountForHumans(ApportionmentMonthAmount));
    CRM.$('.cartable-membership-frequency-selector .year-free-amount').text( cartable.amountForHumans(AnnualTaxFreeAmount));
    // Number of months
    CRM.$('.cartable-membership-frequency-selector .membership-nb-months').text( MonthsToDispatchTo );
    CRM.$('.cartable-membership-frequency-selector .membership-nb-apportionment-months').text(MonthsToDispatchTo_ApportionmentProrata);
    CRM.$('.cartable-membership-frequency-selector .membership-nb-theorical-apportionment-months').text(MonthsToDispatchTo_Apportionment);
    // Dates
    CRM.$('.cartable-membership-frequency-selector .end-date').text( membershipEndDate );
    CRM.$('.cartable-membership-frequency-selector .start-date').text( MembershipStartDate );
    CRM.$('.cartable-membership-frequency-selector .apportionment-start-date').text(!isApportionment ? '' : CRM.utils.formatDate(year + '-' + Syndicate.ContributionStartMonth + '-' + Syndicate.ContributionStartDay, cartable.Membership.i18n.dateformat) );
    CRM.$('.cartable-membership-frequency-selector .apportionment-end-date').text(!isApportionment ? '' : CRM.utils.formatDate(year + '-' + Syndicate.ContributionEndMonth + '-' + Syndicate.ContributionEndDay, cartable.Membership.i18n.dateformat));
    if (isProRata && MonthsToDispatchTo_Apportionment != MonthsToDispatchTo_ApportionmentProrata){
        CRM.$('.frequency-theorical-amount-help').show();
    }
    else {
        CRM.$('.frequency-theorical-amount-help').hide();
    }
    if(!frequency_name || typeof cartable.Membership.FrequenciesData[frequency_name]=='undefined'){
        CRM.$('#cartable-tab-step-2 .front-tabs-link.next').hide();
        return;
    }
    if(!AnnualContributionAmount || isNaN(AnnualContributionAmount)){
        CRM.$('#cartable-tab-step-2 .front-tabs-link.next').hide();
        otherAmountField.val('').trigger('blur');
        return;
    }
    Frequency = cartable.Membership.FrequenciesData[frequency_name];

    if(Frequency.is_recur && Frequency.unit){
        CRM.$('#is_recur').prop('checked', 'checked').trigger('change');
        setTimeout(function(){
            CRM.$('#auto_renew').prop('checked', 'checked').trigger('change');
        }, 300);
        CRM.$('#frequency_unit').val(Frequency.unit);
    }
    else{
        CRM.$('#is_recur').removeProp('checked').trigger('change');
        CRM.$('#auto_renew').removeProp('checked').trigger('change');
        CRM.$('#frequency_unit').val('');
    }

    var maxMonthsToDispath = '';
    var effectiveMonthsToDispatch = '';
    
    ToPayAmount = AnnualContributionAmount;
    if(Frequency.unit == 'month'){
        ToPayAmount = TheoricalMonthAmount;
        var maxMonthsToDispath = MonthsToDispatchTo;
        var effectiveMonthsToDispatch = MonthsToDispatchTo;
        if (Frequency.is_prorata){
            ToPayAmount = ApportionmentMonthAmount;
            var maxMonthsToDispath = MonthsToDispatchTo_Apportionment;
            var effectiveMonthsToDispatch = MonthsToDispatchTo_ApportionmentProrata;
        }
    }

    var priceElement = CRM.$('#'+Syndicate.membership_field);
    priceElement
        .trigger('click')
        ;


    numberOfMonthsForContributionField.val(maxMonthsToDispath);
    numberOfMonthsForProrataField.val(effectiveMonthsToDispatch);
    if(cartable.Membership.numberOfMonthsForProrataField !== null){
        annualAmountForContributionField.val(AnnualContributionAmount);
    }

    if(otherAmountField){
        otherAmountField.val(ToPayAmount).trigger('blur');
        CRM.$('#cartable-tab-step-2 .front-tabs-link.next').show();
    }

    // Focus on current frequency
    CRM.$('.cartable-membership-frequency-selector').removeClass('active').addClass('inactive');
    CRM.$('.cartable-membership-frequency-selector.frequency-'+frequency_name).removeClass('inactive').addClass('active');

    cartable_show_hide_payment_processors();

    if (isReadyForHumans){
        if(event.currentTarget == SalarySelect[0]){
            location.hash = '#cartable-membership-frequency-selector';
        }
        else{
            location.hash = '#cartable-post-contribution-form';
        }
    }

}

/**
 * Replaces placeholders in a string
 * 
 * @param string string 
 * 
 * @returns string
 */
function cartable_membership_text_replace(string){
    return string
        // Amounts
        .replace('[year_amount]', '<span class="amount year-amount"></span>')
        .replace('[year_free_amount]', '<span class="tax-free-amount year-free-amount"></span>')
        .replace('[month_amount]', '<span class="amount month-amount"></span>')
        .replace('[theorical_month_amount]', '<span class="amount theorical-month-amount"></span>')
        .replace('[month_apportionment_amount]', '<span class="amount month-apportionment-amount"></span>')
        .replace('[theorical_apportionment_month_amount]', '<span class="amount theorical-apportionment-month-amount"></span>')
        // Number of months
        .replace('[nb_months]', '<span class="membership-nb-months"></span>')
        .replace('[nb_apportionment_months]', '<span class="membership-nb-apportionment-months"></span>')
        .replace('[nb_theorical_apportionment_months]', '<span class="membership-nb-theorical-apportionment-months"></span>')
        // Dates
        .replace('[start_date]', '<time class="membership-date start-date"></time>')
        .replace('[end_date]', '<time class="membership-date end-date"></time>')
        .replace('[apportionment_start_date]', '<time class="membership-date apportionment-start-date"></time>')
        .replace('[apportionment_end_date]', '<time class="membership-date apportionment-end-date"></time>')
        ;
}

/**
 * Resets the membership amount
 * 
 * @returns void
 */
const cartable_reset_membership_amount = function(){
    CRM.$('#cartable-membership-selector').remove();
    var MembershipSelector = CRM.$('<div>')
    .attr('id', 'cartable-membership-selector')
    ;

    var chosenSyndicateRadio = CRM.$('#priceset .membership_amount-content input[type=radio]:checked');

    SyndicateId = chosenSyndicateRadio.attr('data-syndicate-id');
    Syndicate = cartable.Syndicates.Syndicates[SyndicateId];
    membershipType = cartable.Syndicates.IndexedMembershipTypes[SyndicateId];
    // initial_auto_select = true; // Disabled this because after civi5.69.4, the custom fields where not filled anymore
    // cartable_select_zone();
    var chosenSyndicateButton = CRM.$('#cartable-label-'+chosenSyndicateRadio.attr('id')+'');
    chosenSyndicateButton.addClass('active');

    MembershipStartDate = cartable.format_date(membershipType.start_day);
    membershipEndDate = cartable.format_date(membershipType.end_day);

    MembershipSelector.append(
        CRM.$('<h3>')
        .addClass('cartable-title cartable-membership-title')
        .text(cartable.Membership.i18n.my_contribution)
    );

    MembershipSelector.append(
        CRM.$('<span>')
        .addClass('cartable-membership-chosen-syndicate-name')
        .text(chosenSyndicateButton.attr('data-name'))
    );


    SalarySelect = CRM.$('<select>')
        .attr('id', 'cartable-membership-salary-select')
        .attr('name', 'cartable-membership-salary-select')
        .addClass('cartable-membership-salary-select')
        .on('change', cartable_pick_membership_amount)
        .append(
            CRM.$('<option>')
            .attr('value', '')
            .text(cartable.Membership.i18n.pick_your_salary)
        )
    ;
    
    var membershipRates = cartable.Membership.membershipRates;
    if(Syndicate.MembershipRates !== undefined && Object.keys(Syndicate.MembershipRates).length){
        membershipRates = Syndicate.MembershipRates;
    }

    for(var Salary in membershipRates){
        SalarySelect.append(
            CRM.$('<option>')
                .attr('value', membershipRates[Salary])
                .text(Salary)
        );
    }

    FrequencySelector = CRM.$('<div>')
        .attr('id', 'cartable-membership-frequency-selector')
    ;
    MembershipSelector.append(
        CRM.$('<div>')
        .addClass('membership-wrapper')
        .append(
            CRM.$('<div>')
            .addClass('salary-wrapper')
            .append(
                CRM.$('<h3>')
                .addClass('cartable-title cartable-membership-salary-title')
                .text(cartable.Membership.i18n.your_salary_tax_free)
                ,
                SalarySelect,
            ),
            CRM.$('<div>')
            .addClass('frequency-wrapper')
            .hide()
            .append(
                CRM.$('<h3>')
                .addClass('cartable-title cartable-membership-frequency-title')
                .text(cartable.Membership.i18n.your_contribution_mode)
                ,
                FrequencySelector,
            ),
        ),
    );
    Frequencies = Object.keys(cartable.Membership.FrequenciesData);
    if(Syndicate.PaymentFrequency !== undefined && Object.keys(Syndicate.PaymentFrequency).length){
        Frequencies = Syndicate.PaymentFrequency;
    }
    Frequencies.forEach((frequency) => {
        var FrequencyData = cartable.Membership.FrequenciesData[frequency];

        if(CRM.$('#auto_renew_section').css('display') == 'none' && FrequencyData.is_recur){
            return;
        }
        var FrequencyItem = CRM.$('<div>')
            .addClass('cartable-membership-frequency-selector frequency-'+frequency)
            .append([
                    CRM.$('<input>')
                    .attr('name', 'cartable-membership-frequency')
                    .attr('value', frequency)
                    .attr('data-frequency-unit', frequency)
                    .attr('type', 'radio')
                    .attr('id', 'cartable-membership-frequency-'+frequency)
                    .on('change click blur', cartable_pick_membership_amount)
                ,
                    CRM.$('<label>')
                    .attr('for', 'cartable-membership-frequency-'+frequency)
                    .addClass('frequency-label')
                    .append(
                        CRM.$('<div>')
                        .addClass('frequency-text')
                        .append(
                            CRM.$('<div>')
                            .addClass('frequency-title')
                            .html(cartable_membership_text_replace(FrequencyData.title))
                            ,
                            CRM.$('<div>')
                            .addClass('frequency-description')
                            .html(cartable_membership_text_replace(FrequencyData.description))
                            ,
                        )
                        ,
                        CRM.$('<div>')
                        .addClass('frequency-amount-wrapper')
                        .append(
                            CRM.$('<span>')
                            .addClass('frequency-amount')
                            .html(cartable_membership_text_replace(FrequencyData.amount_label))
                            ,
                            FrequencyData.amount_help ? CRM.$('<span>')
                            .addClass('frequency-amount-help')
                            .html(cartable_membership_text_replace(FrequencyData.amount_help)) : null
                            ,
                            FrequencyData.amount_help_theorical ? CRM.$('<span>')
                            .addClass('frequency-theorical-amount-help')
                            .html(cartable_membership_text_replace(FrequencyData.amount_help_theorical)) : null
                            ,
                        )
                        ,
                        CRM.$('<div>')
                        .addClass('frequency-taxfree')
                        .html(cartable_membership_text_replace(FrequencyData.tax_free_label))
                        ,
                    )
                ,
            ])
        ;
        FrequencySelector.append(FrequencyItem);
    });

    CRM.$('#cartable-tab-step-2').prepend(MembershipSelector);

    SalarySelect.after(CRM.$('#membership-intro').clone());
    SalarySelect.select2({
        minimumResultsForSearch: -1
    });
    if (Syndicate.membershipRatio || cartable.Membership.membershipRatio) {
        SalaryGreaterOption = CRM.$('<option>')
            .attr('value', '_FREE_')
            .attr('id', 'cartable-salary-greater-option')
            .text(cartable.Membership.i18n.greater_salary);
        SalarySelect.append(SalaryGreaterOption);
    }

    cartable_show_hide_payment_processors();

    CRM.$('#membership').parent().hide();
    if(!GrilleSalarialeField || !SalarySelect){
        cartable_pick_membership_amount();
    }

    if (cartable.Syndicates.AcceptRulesOfProcedureField && cartable.Syndicates.defaultRulesOfProcedure) {
        if (Syndicate.RulesOfProcedure){
            CRM.$('#helprow-'+cartable.Syndicates.AcceptRulesOfProcedureField+' details div').html(Syndicate.RulesOfProcedure);
        }
        else{
            CRM.$('#helprow-'+cartable.Syndicates.AcceptRulesOfProcedureField+' details div').html(cartable.Syndicates.defaultRulesOfProcedure);
        }
    }
}

/**
 * Checks the context of the contribution page
 */
const cartable_simple_contribution_check = function(){
    var final_price = parseFloat((CRM.$('#pricevalue').text()).replace(cartable.Membership.currency.symbol, ''));
    if (final_price > 0) {
        CRM.$('#cartable-tab-step-2 .front-tabs-link.next').show();
    }
    else{
        CRM.$('#cartable-tab-step-2 .front-tabs-link.next').hide();
    }
};

/**
 * Initializes the simple contribution form is not in a membership context
 */
const cartable_simple_contribution_init = function(){
    CRM.$('.contribution_amount-content input, .other_amount-content input').on('change', cartable_simple_contribution_check);
    cartable_simple_contribution_check();
};

jQuery(document).ready(function(){
    cartable.addAutoFill('cartable-membership-frequency', 'frequency');
    cartable.addAutoFill('cartable-membership-salary-select', 'salary');
    
    if (cartable.Membership.otherAmountField) {
        cartable.addAutoFill('price_' + cartable.Membership.otherAmountField.id, 'other_amount');
    }
    if (cartable.Membership.membershipField) {
        cartable.addAutoFill('price_' + cartable.Membership.membershipField.id, 'syndicate');
    }
    if (cartable.Membership.contributionField) {
        cartable.addAutoFill('price_' + cartable.Membership.contributionField.id, 'contribution_amount');
    }
    if (!cartable.is_membership){
        cartable_simple_contribution_init();
        cartable.autoFill();
        return;
    }
    // After that, we are in a membership form
    if(cartable.Membership.otherAmountField !== null){
        otherAmountField = CRM.$('#price_'+cartable.Membership.otherAmountField.id);
    }
    if(cartable.Membership.membershipField !== null){
        membershipFieldWrapper = CRM.$('.crm-price-field-id-'+cartable.Membership.membershipField.id);
        CRM.$('#priceset .membership_amount-content input[type=radio]').on('chosen', cartable_reset_membership_amount);
        CRM.$('#pricevalue, #pricelabel').show();
    }

    if(cartable.Membership.GrilleSalarialeField !== null){
        GrilleSalarialeField = CRM.$('#'+cartable.Membership.GrilleSalarialeField);
        GrilleSalarialeFieldWrapper = CRM.$('#editrow-'+cartable.Membership.GrilleSalarialeField);
        GrilleSalarialeFieldWrapper.hide();
    }
    if(cartable.Membership.PaymentMethodField !== null){
        PaymentMethodField = CRM.$('#'+cartable.Membership.PaymentMethodField);
        PaymentMethodFieldWrapper = CRM.$('#editrow-'+cartable.Membership.PaymentMethodField);
        PaymentMethodFieldWrapper.hide();
    }
    if(cartable.Membership.numberOfMonthsForContributionField !== null){
        numberOfMonthsForContributionField = CRM.$('#'+cartable.Membership.numberOfMonthsForContributionField);
        numberOfMonthsForContributionFieldWrapper = CRM.$('#editrow-'+cartable.Membership.numberOfMonthsForContributionField);
        numberOfMonthsForContributionFieldWrapper.hide();
    }
    if(cartable.Membership.numberOfMonthsForProrataField !== null){
        numberOfMonthsForProrataField = CRM.$('#'+cartable.Membership.numberOfMonthsForProrataField);
        numberOfMonthsForProrataFieldWrapper = CRM.$('#editrow-' + cartable.Membership.numberOfMonthsForProrataField);
        numberOfMonthsForProrataFieldWrapper.hide();
    }
    if(cartable.Membership.annualAmountForContributionField !== null){
        annualAmountForContributionField = CRM.$('#'+cartable.Membership.annualAmountForContributionField);
        annualAmountForContributionFieldWrapper = CRM.$('#editrow-' + cartable.Membership.annualAmountForContributionField);
        annualAmountForContributionFieldWrapper.hide();
    }

    if (cartable.Syndicates.AcceptRulesOfProcedureField){
        CRM.$('#helprow-' + cartable.Syndicates.AcceptRulesOfProcedureField).addClass('help-visible').html('<details class="cartable-rop"><summary>' + cartable.Syndicates.i18n.seeRulesOfProcedure+'</summary><div></div></details>'); 
    }

    // In membership-completing context, we hide every fields except the one we need
    // Execution is stopped after this "if"
    if (typeof cartable.Membership.MembershipToComplete != 'undefined' && cartable.Membership.MembershipToComplete !== null) {
        CRM.$('#Main').addClass('membership-to-complete');
        CRM.$('#priceset').addClass('priceset-membership-to-complete');
        // Fill fields
        otherAmountField.val(cartable.Membership.MembershipToComplete.recur_amount).trigger('blur');
        numberOfMonthsForContributionField.val(cartable.Membership.MembershipToComplete.numberOfMonthsForContribution).trigger('blur');
        numberOfMonthsForProrataField.val(cartable.Membership.MembershipToComplete.numberOfMonthsForProrata).trigger('blur');
        annualAmountForContributionField.val(cartable.Membership.MembershipToComplete.annualAmountForContribution).trigger('blur');
        PaymentMethodField.val(cartable.Membership.MembershipToComplete.PaymentMethod).trigger('blur');
        GrilleSalarialeField.val(cartable.Membership.MembershipToComplete.GrilleSalariale).trigger('blur');
        CRM.$('#auto_renew').prop('checked', 'checked').trigger('change');
        CRM.$('#pricesetTotal').before([
            CRM.$('<div>')
            .addClass('messages')
            .html(cartable.Membership.i18n.membership_completion),
        ]);
        // Indicates first transaction amount
        if (cartable.Membership.MembershipToComplete.first_transaction != cartable.Membership.MembershipToComplete.recur_amount){
            CRM.$('#pricesetTotal').before([
                CRM.$('<div>')
                .addClass('cartable-membership-first-transaction')
                .addClass('crm-section')
                .append(
                    CRM.$('<div>')
                    .addClass('cartable-membership-first-transaction-label')
                    .addClass('label')
                    .text(cartable.Membership.i18n.first_transaction)
                    ,
                    CRM.$('<div>')
                    .addClass('cartable-membership-first-transaction-value')
                    .addClass('content')
                    .append(
                        CRM.$('<input>')
                        .attr('type', 'text')
                        .attr('name', 'membership-first-amount')
                        .css('width', 'auto')
                        .val(cartable.Membership.MembershipToComplete.first_transaction)
                        ,
                        CRM.$('<span>')
                        .addClass('currency')
                        .text(cartable.Membership.currency.symbol)
                        ,
                        ' ',
                        CRM.$('<span>')
                        .addClass('membership-nbr-transactions')
                        .text(cartable.Membership.i18n.number_of_transactions.replace('%d', cartable.Membership.MembershipToComplete.nbr_due_installments))
                    )
                    ,
                ),
                CRM.$('<div>').addClass('clear').text(' ')
            ]);
            CRM.$('#amount_sum_label').text(
                cartable.Membership.i18n.next_transactions
                    .replace('%d', cartable.Membership.MembershipToComplete.frequency_interval)
                    .replace('%s', cartable.Membership.i18n[cartable.Membership.MembershipToComplete.frequency_unit+'_s'])
            );
        }
        else{
            CRM.$('#amount_sum_label').text(
                cartable.Membership.i18n.amount_per_trans
            );
        }
        // Hide other payment processors
        CRM.$('.cartable-payment-processor-row').each(function(){
            if (CRM.$(this).find('input').val() != cartable.Membership.MembershipToComplete.payment_processor_id){
                CRM.$(this).hide();
            }
            else{
                CRM.$(this).find('input').prop('checked', 'checked').trigger('change');
            }
        });
        // Hide other stuff
        CRM.$('#membership-intro').hide();
        CRM.$('.cartable-tab-section > h2').hide();


        CRM.$('#_qf_Main_upload-bottom').css('float', 'right');
        return;
    }

    // Initial check, in case the form is pre-filled
    CRM.$('#priceset .membership_amount-content input[type=radio]:checked').each(function(){
        // initial_auto_select = true; // Disabled this because after civi5.69.4, the custom fields where not filled anymore
        var mt = CRM.$(this).attr('membership-type');
        if(typeof cartable.mt_to_zones[mt] != 'undefined'){
            cartable.mt_to_zones[mt].trigger('click');
            CRM.$(this).trigger('change');
            js_tab_openTab('cartable-tab-step-2');
        }
    });

    jQuery('.crm-contribution-main-form-block').on('tab_open_2', function () {
        setTimeout(function(){
            location.hash = '#cartable-membership-selector';
        }, 300);
        if (isReadyForHumans && Frequency){
            setTimeout(function(){
                location.hash = '#cartable-post-contribution-form';
            }, 600);
        }
    });
    jQuery('.crm-contribution-main-form-block').on('tab_open_3', function () {
        setTimeout(function(){
            location.hash = '#cartable-tab-step-3';
        }, 300);
    });
    jQuery('.crm-contribution-main-form-block').on('tab_open_4', function () {
        setTimeout(function(){
            location.hash = '#cartable-tab-step-4';
        }, 300);
    });

    // Also pre-check frequency
    setTimeout(function(){
        if (cartable.Membership.membershipField !== null) {
            cartable_reset_membership_amount();
        }
        if(GrilleSalarialeField && SalarySelect){
            var FreqVal = PaymentMethodField.val();
            var GrilleVal = (GrilleSalarialeField.val()).split('|');
            if(GrilleVal.length==2){
                var GrilleSyndic = GrilleVal[0];
                var GrilleValue = GrilleVal[1];
                SalarySelect.val(GrilleValue).trigger('change');
                if(PaymentMethodField && Frequencies){
                    var FreqFieldChecked = CRM.$('#cartable-membership-frequency-'+FreqVal);
                    if(FreqFieldChecked.length){
                        FreqFieldChecked.prop('checked', 'checked').trigger('change');
                    }
                }
                isReadyForHumans = true;
                return;
            }
        }
        if(!CRM.$('#auto_renew').is(':checked')){
            CRM.$('#cartable-membership-frequency-oneoff').prop('checked', 'checked').trigger('change');
        }
        else{
            if(otherAmountField && SalarySelect && otherAmountField.val() < SalarySelect.val() ){
                CRM.$('#cartable-membership-frequency-monthly').prop('checked', 'checked').trigger('change');
            }
            else{
                CRM.$('#cartable-membership-frequency-yearly').prop('checked', 'checked').trigger('change');
            }
        }
        isReadyForHumans = true;
        cartable.autoFill();
    }, 1000);
});
