var currentUserId;
var currentPassword;


function openModal() {
    var modal = document.createElement('div');
    modal.classList.add('cartable-password-modal');

    var modalContentWrapper = document.createElement('div');
    modalContentWrapper.classList.add('cartable-modal-content-wrapper');
    var translatedText = cartable.reset_password.l10n.resetPassword;
    modalContentWrapper.innerHTML = '<h2 class="title">' + translatedText + '</h2>';

    var closeButton = document.createElement('span');
    closeButton.classList.add('cartable-password-modal-close-button');
    closeButton.innerHTML = '&times;';
    var translatedText = cartable.reset_password.l10n.close;
    closeButton.setAttribute('title', translatedText)

    var passwordDisplay = document.createElement('div');
    passwordDisplay.id = 'cartable-password-display';

    var passwordContainer = document.createElement('div');
    passwordContainer.classList.add('cartable-password-container');

    var copyIcon = document.createElement('span');
    copyIcon.classList.add('cartable-password-modal-copy-icon');
    copyIcon.innerHTML = '<i class="crm-i fa-regular fa-copy"></i>';
    var translatedText = cartable.reset_password.l10n.copy;
    copyIcon.setAttribute('title', translatedText);
    copyIcon.addEventListener('click', copyPasswordToClipboard);

    passwordDisplay.textContent = generateRandomPassword();

    var buttonContainer = document.createElement('div');
    buttonContainer.classList.add('cartable-button-container');

    var useButton = document.createElement('button');
    useButton.classList.add('button');
    var translatedText = cartable.reset_password.l10n.use;
    useButton.textContent = translatedText;
    useButton.addEventListener('click', confirmPasswordChange);

    var generateButton = document.createElement('button');
    generateButton.classList.add('button');
    var translatedText = cartable.reset_password.l10n.generate;
    generateButton.textContent = translatedText;
    generateButton.addEventListener('click', updatePasswordDisplay);

    buttonContainer.appendChild(useButton);
    buttonContainer.appendChild(generateButton);
    
    passwordContainer.appendChild(passwordDisplay);
    passwordContainer.appendChild(copyIcon);
    modalContentWrapper.appendChild(passwordContainer);
    modalContentWrapper.appendChild(buttonContainer);

    var modalContent = document.createElement('div');
    modalContent.classList.add('cartable-password-modal-content');
    modalContent.appendChild(closeButton);
    modalContentWrapper.appendChild(modalContent);

    modal.appendChild(modalContentWrapper);
    document.body.appendChild(modal);

    closeButton.addEventListener('click', closeModal);
}


function closeModal() {
    var modal = document.querySelector('.cartable-password-modal');
    modal.parentNode.removeChild(modal);
}

function cartable_reset_password(userID) {
    openModal();
    currentUserId = userID;
}

function generateRandomPassword() {
    var length = 15;
    var charset = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
    var password = '';

    for (var i = 0; i < length; i++) {
        var randomIndex = Math.floor(Math.random() * charset.length);
        password += charset.charAt(randomIndex);
    }
    currentPassword = password;
    return password;
}

function updatePasswordDisplay() {
    var passwordDisplay = document.getElementById('cartable-password-display');
    passwordDisplay.textContent = generateRandomPassword();
}
  

function copyPasswordToClipboard() {
    var passwordDisplay = document.getElementById('cartable-password-display');
    var password = passwordDisplay.textContent;

    var tempInput = document.createElement('input');
    tempInput.setAttribute('type', 'text');
    tempInput.setAttribute('value', password);
    document.body.appendChild(tempInput);
    tempInput.select();
    document.execCommand('copy');
    document.body.removeChild(tempInput);

    var infoBubble = document.createElement('div');
    infoBubble.classList.add('cartable-modal-info-bubble');
    var translatedText = cartable.reset_password.l10n.passwordCut;
    infoBubble.textContent = translatedText;
    passwordDisplay.appendChild(infoBubble);

    setTimeout(function() {
        passwordDisplay.removeChild(infoBubble);
    }, 2000);
}

function confirmPasswordChange() {

    CRM.confirm({
        title: cartable.reset_password.l10n.resetPassword,
        message: cartable.reset_password.l10n.confirmReset
    })
    .on('crmConfirm:yes', function () {
        saveNewPassword(currentPassword);
    })
    .on('crmConfirm:no', function () {
        // closeModal();
    });
}
function saveNewPassword(newPassword) {
    CRM.api4('Contact', 'updatePassword', {
        userID: currentUserId,
        newPassword: newPassword
    }).then(function(results) {
        CRM.alert(results.message, cartable.reset_password.l10n.resetPassword, 'success');
        closeModal();
    }, function(failure) {
        CRM.alert(failure.message, cartable.reset_password.l10n.resetPassword, 'error');
    });
}
