var currentURL = window.location.href;
//Advanced Form
var searchTermAdvanced = 'advanced';
var regex = new RegExp(searchTermAdvanced, 'i');
var isAdvancedForm = regex.test(currentURL);
//Contribution Form
var searchTermContribution = 'contribute';
var regex = new RegExp(searchTermContribution, 'i');
var isContributionForm = regex.test(currentURL);
//Membership Form
var searchTermMembership = 'member';
var regex = new RegExp(searchTermMembership, 'i');
var isMembershipForm = regex.test(currentURL);


CRM.$(function ($) {
    var champs2id = CRM.$('#s2id_group');
    var groupTypeField = CRM.$('#group');
    if (isContributionForm  || isMembershipForm) {
        champs2id = CRM.$('#s2id_campaign_id');
        groupTypeField = CRM.$('#campaign_id');
    }
    var initialBorder = champs2id.css('border');

    function handleSubmit(event) {
        var groupTypeValue = groupTypeField.val();
        if (!groupTypeValue) {
            var translateText = cartable.search_confirm.l10n.emptyGroup;
            if (isContributionForm || isMembershipForm) {
                translateText = cartable.search_confirm.l10n.emptyCampaign;
            }
            CRM.confirm({ message: translateText })
                .on('crmConfirm:yes', function () {
                    var form = $(event.target).closest('form')[0];
                    if (form) {
                        form.submit();
                    }
            })
            .on('crmConfirm:no', function () {
                champs2id.css('border', '2px solid red');
                var windowHeight = $(window).height();
                var champOffset = champs2id.offset().top;
                var scrollTo = champOffset - (windowHeight / 2);
                $('html, body').animate({
                    scrollTop: scrollTo
                }, 1000);
            });
            event.preventDefault();
        }
    }
    
    if (isAdvancedForm) {
        CRM.$('#_qf_Advanced_refresh-bottom').on('click', function (event) {
            //search contact only
            if (CRM.$('#component_mode').val() == 1) {
                handleSubmit(event);
                confirmationAffichee = false;
            }
        });
    } else if (isContributionForm) {
        CRM.$('#_qf_Contribution_upload-bottom, #_qf_Contribution_upload_new-bottom').on('click', function (event) {
            handleSubmit(event);
            confirmationAffichee = false;
        });  
    } else if (isMembershipForm) {
        CRM.$('#_qf_Membership_upload-bottom, #_qf_Membership_upload_new-bottom').on('click', function (event) {
            handleSubmit(event);
            confirmationAffichee = false;
        });  
    } else {
        CRM.$('#_qf_Basic_refresh-bottom').on('click', function (event) {
            handleSubmit(event);
            confirmationAffichee = false;
        });    
    }
    

    groupTypeField.on('change', function () {
        var groupTypeValue = groupTypeField.val();
        if (groupTypeValue) {
            champs2id.css('border', initialBorder);
        }
    });
});
