<?php
namespace Tests\Acceptance;

use \Tests\Support\AcceptanceTester;

// here you can define custom actions
// all public methods declared in helper class will be available in $I

class Acceptance 
{
    var $role = '';
    var $permission_wanted_items = [];
    var $permission_unwanted_items = [];
  
    /**
     * Try to fetch credentials for the given role in the current environment
     * Login to wordpress
     * @param AcceptanceTester $I
     */
    public function _login(AcceptanceTester $I): bool {
        $classname = get_class($this);
        $this->role = strtolower(str_replace(['Acceptance', 'Cest'], '', $classname));
        
        $login = $I->get_login($this->role);
        $password = $I->get_password($this->role);
        
        if($login && $password) {
            $I->amOnPage('/');
            $this->see('Connexion');
            $I->seeLink('Connexion');
            $I->click('Connexion');
    
            $I->see('Identifiant ou adresse e-mail');
            $I->see('Mot de passe');
            $I->see('Se souvenir de moi');
            $I->fillField('log', $login);
            $I->fillField('pwd', $password);
            $I->click('Se connecter');
            return true;
        }
        return false;
    }
    
    public function accessCiviCRM(AcceptanceTester $I){
        // If credentials are not set, do not test.
        if(false === $this->_login($I)){
            return;
        }
        $I->amOnPage('/wp-admin/');
        // check if civicrm is well configured
        $I->see('CiviCRM');
        $I->click('CiviCRM');
        $I->see('Accueil CiviCRM');
    }

    public function checkPermissions(AcceptanceTester $I){
        // If credentials are not set, do not test.
        if(false === $this->_login($I)){
            return;
        }
        $I->amOnPage('/wp-admin/admin.php?page=CiviCRM');

        foreach($this->permission_wanted_items as $item){
            $I->see($item);
        }

        foreach($this->permission_unwanted_items as $item){
            $I->dontSee($item);
        }
    }
}
