<?php


namespace Tests\Functional;

use Tests\Support\FunctionalTester;

require_once '_AdhesionProcess.php';
class AdhesionParCBCest // extends _AdhesionProcess
{

    public function _afterMap(FunctionalTester $I)
    {
        $uri = $I->grabFromCurrentUrl();
        $uri = str_replace("?", '?action=preview&', $uri);
        $I->amOnPage($uri);
    }

    // tests
    public function _selectPayment(FunctionalTester $I)
    {
        $I->forceClick('input[placeholder="Prélèvement bancaire (93)"] + label');
        $I->wait('10');
        $I->forceClick('.payment_processor_omnipay-systempay + label');
    }

    public function _selectFrequency(FunctionalTester $I)
    {
        $I->click('.cartable-membership-frequency-selector.frequency-yearly label');
    }

    public function _validatePayment(FunctionalTester $I)
    {
        $I->click('Suivant');
        $I->wait(5);
        $I->click('#card_5100010000000114');
        $I->click('#validationButtonCard');
        // Localiser l'iframe avec un sélecteur CSS ou XPath
        $I->waitForElementVisible('//iframe[contains(@id, "LYRA_CHALLENGE_")]', 10);
        $iframe = $I->grabAttributeFrom('//iframe[contains(@id, "LYRA_CHALLENGE_")]', 'id');
        $I->switchToIFrame($iframe);
        $I->waitForElementVisible('#validate', 10);
        $I->click('.btn.btn-success.btn-validate');
        $I->waitForElementVisible('#validate', 10);
        $I->click('.btn.btn-success.btn-validate');
        $I->switchToIFrame();
        $I->waitForElementVisible('#backToBoutiqueBlock button');
        $I->click('#backToBoutiqueBlock button');
    }

    public function _checkupBefore(FunctionalTester $I)
    {
        // Check if the membership is created
        $I->click('#tab_member a');
        $I->wait(10);
        $I->see('Sud éducation 93', '#memberships table');
        $I->see('Nouveau', '#memberships table');
        
        // Check if the contribution is created
        $I->see('Contributions');
        $I->click('#tab_contribute a');
        $I->wait(10);
        $I->see('Contribution en ligne: Adhérer à Sud éducation 93', '.ui-tabs-panel');
        $I->see('Terminé', '.ui-tabs-panel');
    }

    public function _afterMail(FunctionalTester $I)
    {
        $I->see('[MODE TEST] FEDERATION SUD EDUCATION- Votre inscription');
        $I->click('[MODE TEST] FEDERATION SUD EDUCATION- Votre inscription');
        $I->forceClick('#rcmbtn120');

        $I->see("[MODE TEST] Enregistrement d'un abonnement");
        $I->click("[MODE TEST] Enregistrement d'un abonnement");
        $I->forceClick('#rcmbtn120');

        $I->see('[MODE TEST] FEDERATION SUD EDUCATION - Votre paiement');
        $I->click('[MODE TEST] FEDERATION SUD EDUCATION - Votre paiement');
        $I->forceClick('#rcmbtn120');
    }

    // public function ProcessusAdhesion(FunctionalTester $I)
    // {
    //     if(isset($_SERVER['CODECEPTION_SKIP_CB']) && $_SERVER['CODECEPTION_SKIP_CB'] == 'true'){
    //         codecept_debug('Skip CB test');
    //         return true;
    //     }
        
    //     parent::ProcessusAdhesion($I);
    // }
    
}
