<?php

declare(strict_types=1);

namespace Tests\Support;

require_once '_base.php';
/**
 * Inherited Methods
 * @method void wantTo($text)
 * @method void wantToTest($text)
 * @method void execute($callable)
 * @method void expectTo($prediction)
 * @method void expect($prediction)
 * @method void amGoingTo($argumentation)
 * @method void am($role)
 * @method void lookForwardTo($achieveValue)
 * @method void comment($description)
 * @method void pause($vars = [])
 *
 * @SuppressWarnings(PHPMD)
*/
class ApiTester extends _base
{
    use _generated\ApiTesterActions;
    use \Codeception\Lib\Actor\Shared\Friend; 

    public function API4(string $entity, string $method, array $params)
    {
        $this->sendPost('/civicrm/ajax/api4/'. $entity .'/'. $method, [
            "params" => json_encode($params)
        ]);
        $this->seeResponseCodeIsSuccessful();
        $this->seeResponseIsJson();
        return json_decode($this->grabResponse(), true);
    }
}
