<?php


namespace Tests\Unit;

use Tests\Support\UnitTester;
require 'cartable/inc/utils.php';

class SummerBreakTest extends \Codeception\Test\Unit
{

    protected UnitTester $tester;

    public function testBetweenJanuaryAndEnd()
    {
        $nextcollection = \cartable_compute_next_contribution_date('2024-04-01', 10, 9, 6, 10);
        return $this->assertEquals('2024-04-01', $nextcollection);
    }

    public function testJustBeforeEnd()
    {
        $nextcollection = \cartable_compute_next_contribution_date('2024-06-09', 10, 9, 6, 10);
        return $this->assertEquals('2024-06-09', $nextcollection);
    }

    public function testDuringBreak()
    {
        $nextcollection = \cartable_compute_next_contribution_date('2024-08-12', 10, 9, 6, 10);
        return $this->assertEquals('2024-10-09', $nextcollection);
    }

    public function testBetweenStartAndDecember()
    {
        $nextcollection = \cartable_compute_next_contribution_date('2024-11-05', 10, 9, 6, 10);
        return $this->assertEquals('2024-11-05', $nextcollection);
    }
}
